	SUBROUTINE CHITET(IQPNT)
*****************************************************************
*  Calculate weight function for the integration over BZ        *
*  the following susceptibility like expressions:               *
*                                                               *
*  Real part:                                                   *
*                                                               *
*  ___    /  3    f(Ef-E(kj))*(1-f(Ef-E(k+qj'))                 *
*  >      \ d k   -----------------------------  R(k,k+q,jj')   *
*  ---    /             E(kj)-E(k+qj")+Omega      LL't          *
*  jj'     BZ                                                   *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k   f(Ef-E(kj))*f(Ef-E(k+qj') R(k,k+q,jj')        *
*  ---    /                                  LL't               *
*  jj'     BZ                                                   *
*                                                               *
*                                                               *
*  Imaginary part:                                              *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k  [f(Ef-E(kj))-f(Ef-E(k+qj')]*R(k,k+q,jj')*      *
*  ---    /          d(E(kj)-E(k+qj')-W)                        *
*  jj'     BZ                                                   *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k  [f(Ef-E(kj))-f(Ef-E(k+qj')]*R(k,k+q,jj')*      *
*  ---    /          d(E(kj)-E(k+qj')-W)*(v(kj)-v(k+qj')^2      *
*  jj'     BZ                                                   *
*                                                               *
*  Imaginary part when omega->0:                                *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k   d(Ef-E(kj))*d(Ef-E(k+qj')*R(k,k+q,jj')        *
*  ---    /                                                     *
*  jj'     BZ                                                   *
*                                                               *
*                                                               *
*  ___    /  3                                                  *
*  >      \ d k d(Ef-E(kj))*d(Ef-E(k+qj')*R(k,k+q,jj')          *
*  ---    /                                 *(v(kj)-v(k+qj')^2  *
*  jj'     BZ                                                   *
*                                                               *
*  where f(x) are occupation numbers and R are some matrix      *
*  elements. Tetrahedron method is used.                        *
*****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IKOV(NOPRMAX),NDIV(3),KTQ(4),KT(4),NBNDC(NPANMAX)
     &   ,KCUT(3,4,6),IPQ(0:50,0:50,0:50),KTT(4),KGG(4)
     &   ,IGQ(0:50,0:50,0:50),IG0IG1(KMAX,NOPRMAX)
     &   ,IGS(0:50,0:50,0:50),ISG(NOPRMAX,NOPRMAX)
     &   ,IK0IK1(KMAX,NOPRMAX),KSYMPN(NOPRMAX,KMAX)
     &   ,MSYMPN(NOPRMAX,KMAX),IPW(0:50,0:50,0:50)
     &   ,IK0IKW(KMAX,NOPRMAX),IG0IGW(KMAX,NOPRMAX)
     &   ,IGW(0:50,0:50,0:50),NDIW(3),KTW(4),KCUW(3,4,6)
	DIMENSION PNT(3,KMAX),EARR(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,WEIGH(NDIMMAX*NSPINMAX,KMAX),WEIGK(NBNDMAX*NSPINMAX,4,4)
     &   ,WEIGD(NDIMMAX*NSPINMAX,KMAX),WGT(KMAX),ORTH(2:3)
     &   ,WEIGQ(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,6,4)
     &   ,WGTOM(NBNDMAX*NSPINMAX,NBNDMAX*NSPINMAX,4,4)
     &   ,PNW(3,KMAX),EARW(NDIMMAX*NSPINMAX,KMAX,NPANMAX)
     &   ,GBAS(3,3),RBAS(3,3),QB(3,3),RB(3,3),QW(3,3),RW(3,3)
        DIMENSION REC(3,3),PKT(3,4),PKW(3,4),CRW(3,4),QWGT(4,3)
     &   ,E(4),H(4),QPNT(3),WGTQ(4),AT(4),AD(4),ADS(4,2),ATS(4,2)
     &   ,VEL(3),VEL0(3),PQT(3,4),VK(3),VQ(3)
	CHARACTER*60 DSFFILE,PHNFILE,TMPFILE,WGTFILE(10)
     &   ,SCRFILE(100),FILE
	LOGICAL EXIST,LNEG,LPOS
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE            !!! from readini
        COMMON /ORBS/   NORBS                                   !!! from readini
        COMMON /SPIN/   NSPIN                                   !!! from readini
        COMMON /WHICOM/ NWHI,LWHI,IWHI                          !!! from readlrt
C Inputs:
        COMMON /LATTICE/RBAS,GBAS,QB,RB,QW,RW                   !!! from readstr
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                         !!! from readini
        COMMON /KAPPAR/ NPAN                                    !!! from readini
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT,NBNDC,POLUS           !!! from readini
        COMMON /EFERMI/ EF,DOS,VEL                              !!! from ttrint1
C K-mesh:
        COMMON /INTTR/  NDIV,NDIW                               !!! from init
        COMMON /QMESH/  NQPNT,QPNT                              !!! from qvector
        COMMON /MESH/   NPNT,PNT,WGT                            !!! from ttrmsh
        COMMON /MESW/   NPNW,PNW                                !!! from ttrmsh
        COMMON /SYMMESH/IG0IG1,IK0IK1                           !!! from symmsh
        COMMON /SYMMESW/IG0IGW,IK0IKW                           !!! from symmsh
        COMMON /WMESH/  KCUT,IPQ,IGQ                            !!! from bzmesh
        COMMON /WMESW/  KCUW,IPW,IGW                            !!! from bzmesh
C Bands:
        COMMON /ENERGY/ EARR,WEIGH,WEIGD                        !!! from lmtbnd
        COMMON /ENRWGT/ EARW                                    !!! from lmtbnd
C Group:
        COMMON /INVERS/ INV,IKOV                                !!! from group
        COMMON /GROUPOUT/NGROUP                                 !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG,KSYMPN,MSYMPN,IGS        !!! from symmsh
C Frequency:
	COMMON /FREQU/  OMGR                                    !!! from init
C Temporary:
	COMMON /STORE1/ WEIGQ,WGTOM                             !!! tmp.storage
C Outputs:
        COMMON /OUT0/   SCRFILE                                 !!! from qvector
        COMMON /OUT1PH/ ICDSF,ICDRO,ICPHN,ICTMP,ICDSV,ICWGT     !!! from readlrt
        COMMON /OUT2PH/ DSFFILE,PHNFILE,TMPFILE,WGTFILE         !!! from qvector 
        COMMON /WORD/   NVAL                                    !!! from block
        COMMON /UNIT/   IUN                                     !!! from readini
	DATA PI/3.141592653589793D0/,NODEBUG/0/,EPS/1.D-10/
	IF(LWHI.NE.1)RETURN
C  GET INFORMATION ABOUT THE FILE
	IF(ICWGT.NE.0)FILE=WGTFILE(LWHI)
	IF(ICWGT.EQ.0)FILE=SCRFILE(40)
	IF(ICWGT.EQ.2)GOTO 5000
        NRECL=NVAL/2
        NRECL=NVAL/2*NBNDC(1)**2*NSPIN**2*6+NRECL
	NRECL=NVAL/2*NBNDC(1)*NSPIN*4+NRECL
        NRECL=NVAL/2*NBNDC(1)**2*NSPIN**2*4+NRECL
	NRECL=MAX(NRECL,NVAL/2*13)
        OPEN(UNIT=40,FILE=FILE,STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	WRITE(40,REC=1)NRECL,NDIV(1),NDIV(2),NDIV(3),NPNT,
     &  NBNDF(1),NBNDE(1),NBNDT(1),NSPIN,NORBS,LWHI,POLUS,OMGR
C  OPEN SCRATCH FILE FOR FAST ACCESS
        OPEN(UNIT=39,FILE=SCRFILE(39),STATUS='NEW',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	WRITE(39,REC=1)NRECL,NDIV(1),NDIV(2),NDIV(3),NPNT,
     &  NBNDF(1),NBNDE(1),NBNDT(1),NSPIN,NORBS,LWHI,POLUS,OMGR
C  INITIALLY SET WEIGHTS FOR ALL POINTS TO ZERO
        DOS0=0.D0
        VEL0(1)=0.D0
        VEL0(2)=0.D0
        VEL0(3)=0.D0
	DO ISGQ=1,NSGQ
	DO IPNT=1,NPNT
	WGTQ(1)=0.D0
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	DO IC=1,4
	WEIGK(IBANC1,IC,1)=0.D0
	ENDDO
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
C  WEIGHTS FOR THE REAL PART
	DO IC=1,6
	WEIGQ(IBANC,IBANC1,IC,1)=0.D0
	ENDDO
C  WEIGHTS FOR THE IMAGINARY PART
	DO IC=1,4
	WGTOM(IBANC,IBANC1,IC,1)=0.D0
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IREC=1+IPNT+NPNT*(ISGQ-1)
	WRITE(39,REC=IREC)WGTQ(1),(((WEIGQ(IBANC,IBANC1,IC,1),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC,1),IBANC=1,NBNDC(1)*
     &  NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,4)
	ENDDO
	ENDDO
C------------------------------------------------------------
C  DO OVER WHOLE BRILLOUIN ZONE REPRESENTED BY MICROCELLS AND 
C  INTEGRATE OVER THE TETRAHEDRA
C------------------------------------------------------------
	VOLIBZ=1.D0
        OT=1.D0/DBLE(NDIV(1)*NDIV(2)*NDIV(3))/6.D0
        OW=1.D0/DBLE(NDIW(1)*NDIW(2)*NDIW(3))/6.D0
	DO 4200 I3=0,NDIV(3)-1               !!! over cells along G3
	DO 4200 I2=0,NDIV(2)-1               !!! over cells along G2
	DO 4200 I1=0,NDIV(1)-1               !!! over cells along G1
C  THE MICROCELL IS SET UP BY I1,I2,I3
C  SET UP TETRAHEDRA INSIDE MICROCELL
	DO 4100 ITTR=1,6                    !!! over tetrahedra
	DO I=1,4
C  COORDINATES OF THE TETRAHEDRON AGE GIVEN BY KTT, SHIFTED - BY KTT1
	J1=I1+KCUT(1,I,ITTR)
	J2=I2+KCUT(2,I,ITTR)
	J3=I3+KCUT(3,I,ITTR)
	KTT(I)=IPQ(J1,J2,J3)
	KGG(I)=IGS(J1,J2,J3)
	ENDDO
C  TWO TETRAHEDRA FOUND, DEFINE CASE
	DO I=1,4
	KT(I)=0
	ENDDO
	DO I=1,4
	IF(KT(I).EQ.0)THEN
	KT(I)=I
	DO J=I+1,4
        IF(KTT(I).EQ.KTT(J).AND.KGG(I).EQ.KGG(J).AND.KT(J).EQ.0)KT(J)=I  
	ENDDO
	ENDIF
	ENDDO
C  READ WEIGHTS FOR THE POINTS
	DO I=4,1,-1 ! looping backwards to avoid bug in shit IBM compiler
	IPNT=KTT(I)
	ISGQ=KGG(I)
	IREC=1+IPNT+NPNT*(ISGQ-1)
	READ(39,REC=IREC)WGTQ(KT(I)),(((WEIGQ(IBANC,IBANC1,IC,KT(I)),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC,KT(I)),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC,KT(I)),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,4)
	ENDDO
C  SET GEOMETRICAL WEIGHT
	DO I=1,4
	WGTQ(KT(I))=WGTQ(KT(I))+OT/4.D0       !!! geometrical weight f(kj)=1
	ENDDO
C  SET UP POINTS "K" DESCRIBING TETRAHEDRON IN THE SPACE
        DO I=1,4
        J1=I1+KCUT(1,I,ITTR)
        J2=I2+KCUT(2,I,ITTR)
        J3=I3+KCUT(3,I,ITTR)
        PKT(1,I)=(J1*QB(1,1)+J2*QB(1,2)+J3*QB(1,3))*2.D0*PI/PAR
        PKT(2,I)=(J1*QB(2,1)+J2*QB(2,2)+J3*QB(2,3))*2.D0*PI/PAR
        PKT(3,I)=(J1*QB(3,1)+J2*QB(3,2)+J3*QB(3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
        DO I=2,4
        PKT(1,I)=PKT(1,I)-PKT(1,1)
        PKT(2,I)=PKT(2,I)-PKT(2,1)
        PKT(3,I)=PKT(3,I)-PKT(3,1)
	ENDDO
C  SET RECIPROCALS "REC" TO "PKT"
        CALL CROSS(REC(1,1),PKT(1,3),PKT(1,4))
        CALL CROSS(REC(1,2),PKT(1,4),PKT(1,2))
        CALL CROSS(REC(1,3),PKT(1,2),PKT(1,3))
        W=REC(1,1)*PKT(1,2)+REC(2,1)*PKT(2,2)+REC(3,1)*PKT(3,2)
        IF(ABS(W).LE.1.D-10)STOP'<DELTET>:: INTERNAL ERROR: W=0'
        DO I=1,3
        REC(I,1)=REC(I,1)/W
        REC(I,2)=REC(I,2)/W
        REC(I,3)=REC(I,3)/W
	ENDDO
C--------------------------------------------
C  DO OVER DIVISIONS OF THE MICROCELL
C--------------------------------------------
        DO 3200 ID3=0,NDIW(3)/NDIV(3)-1
        DO 3200 ID2=0,NDIW(2)/NDIV(2)-1
        DO 3200 ID1=0,NDIW(1)/NDIV(1)-1
C  THE SMALL MICROCELL IS SET UP BY IW1,IW2,IW3
        IW1=I1*NDIW(1)/NDIV(1)+ID1
        IW2=I2*NDIW(2)/NDIV(2)+ID2
        IW3=I3*NDIW(3)/NDIV(3)+ID3
C  SET UP SMALL TETRAHEDRON INSIDE SMALL MICROCELL
        DO 3100 ITTRD=1,6
        DO I=1,4
        JW1=IW1+KCUT(1,I,ITTRD)
        JW2=IW2+KCUT(2,I,ITTRD)
        JW3=IW3+KCUT(3,I,ITTRD)
        KTW(I)=IPW(JW1,JW2,JW3)
	KTQ(I)=IK0IKW(KTW(I),IGW(JW1,JW2,JW3))
	ENDDO
C  SET UP POINTS K DESCRIBING SMALL TETRAHEDRON IN THE SPACE
        DO I=1,4
        JW1=IW1+KCUT(1,I,ITTRD)
        JW2=IW2+KCUT(2,I,ITTRD)
        JW3=IW3+KCUT(3,I,ITTRD)
        PKW(1,I)=(JW1*QW(1,1)+JW2*QW(1,2)+JW3*QW(1,3))*2.D0*PI/PAR
        PKW(2,I)=(JW1*QW(2,1)+JW2*QW(2,2)+JW3*QW(2,3))*2.D0*PI/PAR
        PKW(3,I)=(JW1*QW(3,1)+JW2*QW(3,2)+JW3*QW(3,3))*2.D0*PI/PAR
	ENDDO
C  SHIFT COORDINATE SYSTEM TO THE FIRST POINT
        DO I=1,4
        PKW(1,I)=PKW(1,I)-PKT(1,1)
        PKW(2,I)=PKW(2,I)-PKT(2,1)
        PKW(3,I)=PKW(3,I)-PKT(3,1)
        PQT(1,I)=PKW(1,I)+QPNT(1)*2.D0*PI/PAR
        PQT(2,I)=PKW(2,I)+QPNT(2)*2.D0*PI/PAR
        PQT(3,I)=PKW(3,I)+QPNT(3)*2.D0*PI/PAR
	ENDDO
C  CHECK WHETHER A SMALL TETRAHEDRON "PKW" IS INSIDE  TETRAHEDRON "PKT"
        DO I=1,4
        X1=PKW(1,I)*REC(1,1)+PKW(2,I)*REC(2,1)+PKW(3,I)*REC(3,1)
        X2=PKW(1,I)*REC(1,2)+PKW(2,I)*REC(2,2)+PKW(3,I)*REC(3,2)
        X3=PKW(1,I)*REC(1,3)+PKW(2,I)*REC(2,3)+PKW(3,I)*REC(3,3)
        IF(.NOT.((X1.GE.-EPS.AND.X1.LE.1.D0+EPS).AND.
     &           (X2.GE.-EPS.AND.X2.LE.1.D0+EPS).AND.
     &           (X3.GE.-EPS.AND.X3.LE.1.D0+EPS).AND.
     &           (X1+X2+X3.LE.1.D0+EPS)))GOTO3100
        CRW(1,I)=X1
        CRW(2,I)=X2
        CRW(3,I)=X3
	ENDDO
C---------------------------------------------
C  CALCULATE CONTRIBUTIONS FOR THESE POINTS
C---------------------------------------------
	IPAN=1
C  START LOOPING OVER BANDS
	DO 2200 IBNDS=1,NSPIN                 !!! over spin subbands
	DO 2100 IBNDT=NBNDE(1),NBNDF(1)       !!! over all bands
	IBNDC=IBNDT-NBNDE(1)+1
	IBANC=IBNDS+NSPIN*(IBNDC-1)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DO I=1,4
	E(I)=EARW(IBAND,KTW(I),1)             !!! E(k,js)
	H(I)=EARW(IBAND,KTQ(I),1)             !!! E(g*k+q,js)
	ENDDO
C-----------------------------------------------------
C  SET WEIGHTS FOR THE NUMBER OF STATES
C-----------------------------------------------------
        CALL GETVEL(E,PKW,VK)                 !!! dE(kjs)/dk
        CALL MCTTRINT0(E,EF,OW,AT,AD,TS,DS,'B','W')
        DOS0=DOS0+DS
        DO IVEL=1,3
        VEL0(IVEL)=VEL0(IVEL)+DS*VK(IVEL)**2  !!! velocities
        ENDDO
        DO IT=1,4
        DO I=1,4
        IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
        IF(IT.NE.1)WF=CRW(IT-1,I)
        WEIGK(IBANC,1,KT(IT))=WEIGK(IBANC,1,KT(IT))+AT(I)*WF !!! weight f(kjs)
        WEIGK(IBANC,3,KT(IT))=WEIGK(IBANC,3,KT(IT))+AD(I)*WF !!! weight d(kjs)
	ENDDO
	ENDDO
        CALL MCTTRINT0(H,EF,OW,AT,AD,TS,DS,'B','W')
        DO IT=1,4
        DO I=1,4
        IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
        IF(IT.NE.1)WF=CRW(IT-1,I)
        WEIGK(IBANC,2,KT(IT))=WEIGK(IBANC,2,KT(IT))+AT(I)*WF !!! weight f(k+qjs)
        WEIGK(IBANC,4,KT(IT))=WEIGK(IBANC,4,KT(IT))+AD(I)*WF !!! weight d(k+qjs)
	ENDDO
	ENDDO
C  START LOOPING OVER BANDS
	DO 1200 IBNDS1=1,NSPIN                !!! over spin subbands
	DO 1100 IBNDT1=NBNDE(1),NBNDF(1)      !!! over bands
	IBNDC1=IBNDT1-NBNDE(1)+1
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DIF=0.D0
	DO I=1,4
	H(I)=EARW(IBAND1,KTQ(I),1)            !!! E(g*k+q,j's')
	DIF=DIF+ABS(E(I)-H(I)+OMGR)
	ENDDO
C-----------------------------------------------------
C  SET WEIGHTS FOR THE REAL PART OF SUSCEPTIBILITY
C-----------------------------------------------------
	IF(ABS(DIF).GT.1.D-05)THEN
C  ENERGIES ARE DIFFERENT, SET UP WEIGHTS FOR 1/[E(k,js)-E(g*k+q,j's')+Omega]
	CALL MCHEAD(E,H,EF,OMGR,OW,QWGT)
        DO IT=1,4
        DO I=1,4
	WE=(E(I)-H(I)+OMGR)**2/((E(I)-H(I)+OMGR)**2+POLUS**2)
        IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
        IF(IT.NE.1)WF=CRW(IT-1,I)
	WEIGQ(IBANC,IBANC1,1,KT(IT))=WEIGQ(IBANC,IBANC1,1,KT(IT))+
     &  QWGT(I,1)*WF                          !!! f(kj)*[1-f(k+qj')]
	WEIGQ(IBANC,IBANC1,2,KT(IT))=WEIGQ(IBANC,IBANC1,2,KT(IT))+
     &  QWGT(I,2)*WF                          !!! [1-f(kj)]*f(k+qj')
	WEIGQ(IBANC,IBANC1,5,KT(IT))=WEIGQ(IBANC,IBANC1,5,KT(IT))+
     &  QWGT(I,1)*WF*WE                       !!! f(kj)*[1-f(k+qj')]
	WEIGQ(IBANC,IBANC1,6,KT(IT))=WEIGQ(IBANC,IBANC1,6,KT(IT))+
     &  QWGT(I,2)*WF*WE                       !!! [1-f(kj)]*f(k+qj')
	ENDDO
	ENDDO
	ELSE
C  ENERGIES ARE THE SAME, WEIGHTS ARE JUST DENSITY OF STATES
	IF(ABS(OMGR).GT.1.D-10)PRINT*,'<CHITET>: CASE OMEGA.NE.0'
        CALL MCTTRINT0(E,EF,OW,ATS(1,1),ADS(1,1),TS,DS,'B','W')
        CALL MCTTRINT0(H,EF,OW,ATS(1,2),ADS(1,2),TS,DS,'B','W')
        DO IT=1,4
        DO I=1,4
        IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
        IF(IT.NE.1)WF=CRW(IT-1,I)
	WEIGQ(IBANC,IBANC1,3,KT(IT))=WEIGQ(IBANC,IBANC1,3,KT(IT))-
     &  0.5D0*(ADS(I,1)+ADS(I,2))/2.D0*WF    !!! f(kj)*[1-f(k+qj')]=>-N(Ef)/2
	WEIGQ(IBANC,IBANC1,4,KT(IT))=WEIGQ(IBANC,IBANC1,4,KT(IT))+
     &  0.5D0*(ADS(I,1)+ADS(I,2))/2.D0*WF    !!! [1-f(kj)]*f(k+qj')=>+N(Ef)/2
	ENDDO
	ENDDO
	ENDIF
C------------------------------------------------------
C  SET WEIGHTS FOR THE IMAGINARY PART OF SUSCEPTIBILITY
C------------------------------------------------------
        CALL GETVEL(H,PQT,VQ)                 !!! dE(gk+qj's')/dk
        VFAC=(VK(1)*VK(1)+VK(2)*VK(2)+VK(3)*VK(3))+
     &       (VQ(1)*VQ(1)+VQ(2)*VQ(2)+VQ(3)*VQ(3))-
     &     2*(VK(1)*VQ(1)+VK(2)*VQ(2)+VK(3)*VQ(3))
C  CHECK WHETHER THE ENERGIES AT THE CORNERS COINCIDE
        DIF=0.D0
        DO I=1,4
        DIF=DIF+ABS(E(I)-H(I)+OMGR)
        ENDDO
C  CHECK WHETHER TRANSITION IS ALLOWED
        LNEG=.FALSE.
        LPOS=.FALSE.
        DO I=1,4
        IF(E(I)-H(I)+OMGR.LE.0.D0)LNEG=.TRUE.
        IF(E(I)-H(I)+OMGR.GE.0.D0)LPOS=.TRUE.
        ENDDO
        IF(ABS(DIF).GT.1.D-05.AND.LNEG.AND.LPOS.AND.
     &  ABS(OMGR).GE.1.D-10)THEN
C  ENERGIES ARE DIFFERENT, SET UP WEIGHTS
        CALL MOHEAD(E,H,EF,OMGR,OW,QWGT)
        DO IT=1,4
        DO I=1,4
        IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
        IF(IT.NE.1)WF=CRW(IT-1,I)
        WGTOM(IBANC,IBANC1,1,KT(IT))=
     &  WGTOM(IBANC,IBANC1,1,KT(IT))+
     &  QWGT(I,1)*WF                          !!! f(kj)*[1-f(k+qj')]
        WGTOM(IBANC,IBANC1,2,KT(IT))=
     &  WGTOM(IBANC,IBANC1,2,KT(IT))+
     &  QWGT(I,1)*WF*VFAC                     !!! f(kj)*[1-f(k+qj')]
        ENDDO
        ENDDO
        ENDIF
C------------------------------------------------------
C  SET WEIGHTS FOR THE IMAGINARY PART WHEN OMEGA-->ZERO
C------------------------------------------------------
C  CHECK WHETHER TRANSITION IS ALLOWED
        LNEG=.FALSE.
        LPOS=.FALSE.
        DO I=1,4
        IF(E(I)-H(I).LE.0.D0)LNEG=.TRUE.
        IF(E(I)-H(I).GE.0.D0)LPOS=.TRUE.
        ENDDO
        IF(LNEG.AND.LPOS)THEN        !!! transition is allowed
        CALL MDHEAD(E,H,EF,OW,QWGT)
        DO IT=1,4
        DO I=1,4
        IF(IT.EQ.1)WF=1.D0-CRW(1,I)-CRW(2,I)-CRW(3,I)
        IF(IT.NE.1)WF=CRW(IT-1,I)
        WGTOM(IBANC,IBANC1,3,KT(IT))=WGTOM(IBANC,IBANC1,3,KT(IT))+
     &  QWGT(I,1)*WF
        WGTOM(IBANC,IBANC1,4,KT(IT))=WGTOM(IBANC,IBANC1,4,KT(IT))+
     &  QWGT(I,1)*WF*VFAC
        ENDDO
        ENDDO
	ENDIF
1100    CONTINUE                             !!! over bands
1200    CONTINUE                             !!! over spin subbands
2100    CONTINUE                             !!! over bands
2200    CONTINUE                             !!! over spin subbands
C  WRITE CONTRIBUTIONS BACK TO THE FILE
	DO I=1,4
	IPNT=KTT(I)
	ISGQ=KGG(I)
	IREC=1+IPNT+NPNT*(ISGQ-1)
	WRITE(39,REC=IREC)WGTQ(KT(I)),(((WEIGQ(IBANC,IBANC1,IC,KT(I)),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC,KT(I)),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC,KT(I)),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,4)
	ENDDO
3100    CONTINUE                                  !!! over small tetrahedra
3200    CONTINUE                                  !!! over small microcells
4100    CONTINUE                                  !!! over tetrahedra
4200    CONTINUE                                  !!! over microcells
C  NORMALIZATION
	DO ISGQ=1,NSGQ                            !!! over star of the q-vector
	DO IPNT=1,NPNT                            !!! over irreducible points
	IREC=1+IPNT+NPNT*(ISGQ-1)
	READ(39,REC=IREC)WGTQ(1),(((WEIGQ(IBANC,IBANC1,IC,1),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,6),((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &  IC=1,4),(((WGTOM(IBANC,IBANC1,IC,1),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),
     &  IC=1,4)
	WGTQ(1)=WGTQ(1)/VOLIBZ*2.D0/DBLE(NSPIN)
	DO IBNDS1=1,NSPIN
	DO IBNDC1=1,NBNDC(1)
	IBANC1=IBNDS1+NSPIN*(IBNDC1-1)
	DO IC=1,4
	WEIGK(IBANC1,IC,1)=WEIGK(IBANC1,IC,1)/VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	DO IBNDS=1,NSPIN
	DO IBNDC=1,NBNDC(1)
	IBANC=IBNDS+NSPIN*(IBNDC-1)
C  FOR THE REAL PART
	DO IC=1,6
	WEIGQ(IBANC,IBANC1,IC,1)=WEIGQ(IBANC,IBANC1,IC,1)/
     &  VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
C  FOR THE IMAGINARY PART
	DO IC=1,4
	WGTOM(IBANC,IBANC1,IC,1)=WGTOM(IBANC,IBANC1,IC,1)/
     &  VOLIBZ*2.D0/DBLE(NSPIN)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	ENDDO
	IREC=1+IPNT+NPNT*(ISGQ-1)
	WRITE(40,REC=IREC)WGTQ(1),(((WEIGQ(IBANC,IBANC1,IC,1),
     &  IBANC=1,NBNDC(1)*NSPIN),IBANC1=1,NBNDC(1)*NSPIN),IC=1,6),
     &  ((WEIGK(IBANC,IC,1),IBANC=1,NBNDC(1)*NSPIN),IC=1,4),
     &  (((WGTOM(IBANC,IBANC1,IC,1),IBANC=1,NBNDC(1)*NSPIN),
     &  IBANC1=1,NBNDC(1)*NSPIN),IC=1,4)
        ENDDO                                     !!! over irreducible points
        ENDDO                                     !!! over star of the q-vector
        DOS0=DOS0/VOLIBZ*2.D0/DBLE(NSPIN)     !!! total dos
        VEL0(1)=VEL0(1)/VOLIBZ*2.D0/DBLE(NSPIN)!! velocities
        VEL0(2)=VEL0(2)/VOLIBZ*2.D0/DBLE(NSPIN)!! velocities
        VEL0(3)=VEL0(3)/VOLIBZ*2.D0/DBLE(NSPIN)!! velocities
	IF(ABS(DOS-DOS0).GE.1.D-10)PRINT*,'<CHITET> WRONG DOS'
	IF((VEL(1)-VEL0(1))**2+(VEL(2)-VEL0(2))**2+
     &  (VEL(3)-VEL0(3))**2.GE.1.D-10)PRINT*,'<CHITET> WRONG VEL'
        WRITE(IUN,1010)
        WRITE(IUN,1020)(VEL0(I),I=1,3)
        WRITE(IUN,1030)
        WRITE(IUN,1040)(13.6058D0*SQRT(8.D0*PI*VEL0(I)/OMEGAC),I=1,3)
1010    FORMAT(1X,'Calculated average square of electron velocities:')
1020    FORMAT(1X,'<Vx^2>=',G14.7,' ; <Vy^2>=',G14.7,' ; <Vz^2>=',G14.7)
1030    FORMAT(1X,'Calculated bare plasma frequencies (in units eV):')
1040    FORMAT(1X,'om_p^x=',G14.7,' ; om_p^y=',G14.7,' ; om_p^z=',G14.7)
	CLOSE(39,STATUS='DELETE')
	CLOSE(40,STATUS='KEEP')
C  WEIGHT-FILE HAS BEEN CALCULATED, CHECK IT
5000    INQUIRE(FILE=FILE,RECL=NRECL)
CWRONG  IF(WRONG)THEN                !!! wrong compiler option
        NRECL=NVAL
        OPEN(UNIT=40,FILE=FILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NRECL)
        READ(40,REC=1)NRECL
        CLOSE(40)
CWRONG  ENDIF
	OPEN(UNIT=40,FILE=FILE,STATUS='OLD',
     &  FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NRECL)
	READ(40,REC=1)NRECL,N1,N2,N3,NPNT0,
     &	NBNDF0,NBNDE0,NBNDT0,NSPIN0,NORBS0,LWHI0,POLUS0,OMGR0
	IF(N1.NE.NDIV(1).OR.N2.NE.NDIV(2).OR.N3.NE.NDIV(3))
     &  STOP'<DELTET>: # of divisions mismatches in WGTFILE'
	IF(NPNT0.NE.NPNT)
     &  STOP'<DELTET>:: # of points mismatches in WGTFILE'
	IF(NBNDF0.NE.NBNDF(1))
     &  STOP'<DELTET>:: # of filled bands mismatches in WGTFILE'
	IF(NBNDE0.NE.NBNDE(1))
     &  STOP'<DELTET>:: # of empty bands mismatches in WGTFILE'
	IF(NBNDT0.NE.NBNDT(1))
     &  STOP'<DELTET>:: # of total bands mismatches in WGTFILE'
	IF(NSPIN0.NE.NSPIN)
     &  STOP'<DELTET>:: # of spins mismatches in WGTFILE'
	IF(NORBS0.NE.NORBS)
     &  STOP'<DELTET>:: SO-coupling mismatches in WGTFILE'
	IF(LWHI0.NE.1)
     &  STOP'<DELTET>:: Not Re(chi) stored in WGTFILE'
	IF(ABS(POLUS-POLUS0).GE.1.D-10)
     &  STOP'<DELTET>:: Poles mismatch in WGTFILE'
	IF(ABS(OMGR-OMGR0).GE.1.D-10)
     &  STOP'<DELTET>:: Frequencies mismatch in WGTFILE'
	CLOSE(40)
	RETURN
	END
