	SUBROUTINE CONVOL1(VPS,CHI,CON,TLR,IBMIN,IBMAX,JBMIN,JBMAX)
*******************************************************
*  Makes a convolution of the pseudopotential and     *
*  pseudoorbital. This is what takes all the time     *
*  in the program.                                    *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
	DIMENSION GPLW(3,0:NPLWMAX)
	COMPLEX*16 VPS(0:NPLWMAX),CHI(0:NBASMAX),CON(0:NBASMAX)
	CHARACTER*1 TLR
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG      !!! from plwmsh
        DATA PI/3.141592653589793D0/
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
        M1D=KGMAX(1)-KGMIN(1)+1
        M2D=KGMAX(2)-KGMIN(2)+1
        M3D=KGMAX(3)-KGMIN(3)+1
        M12D=M1D*M2D
        M123D=M1D*M2D*M3D
C  MAKE IT WITH THE RIGHT INDEX
	IF(TLR.EQ.'R')THEN
        DO IBAS=IBMIN,IBMAX                !!! over ibas
        CON(IBAS)=(0.D0,0.D0)
        M1I=KVEC(1,IBAS)-KGMIN(1)
        M2I=KVEC(2,IBAS)-KGMIN(2)
        M3I=KVEC(3,IBAS)-KGMIN(3)
        DO JBAS=JBMIN,JBMAX                !!! over jbas
        M1K=M1I-KVEC(1,JBAS)
        M2K=M2I-KVEC(2,JBAS)
        M3K=M3I-KVEC(3,JBAS)
        IFTR=1+M1K+M1D*M2K+M12D*M3K
        KPLW=-1
        IF(IFTR.GT.0.AND.IFTR.LE.M123D)KPLW=INDG(IFTR)
        IF(KPLW.GE.0)
     &  CON(IBAS)=CON(IBAS)+VPS(KPLW)*CHI(JBAS)
        ENDDO                              !!! over jbas
        ENDDO                              !!! over ibas
C  MAKE IT WITH THE LEFT INDEX
	ELSEIF(TLR.EQ.'L')THEN
        DO IBAS=IBMIN,IBMAX                !!! over ibas
        CON(IBAS)=(0.D0,0.D0)
        M1I=KVEC(1,IBAS)+KGMIN(1)
        M2I=KVEC(2,IBAS)+KGMIN(2)
        M3I=KVEC(3,IBAS)+KGMIN(3)
        DO JBAS=JBMIN,JBMAX                !!! over jbas
        M1K=KVEC(1,JBAS)-M1I
        M2K=KVEC(2,JBAS)-M2I
        M3K=KVEC(3,JBAS)-M3I
        IFTR=1+M1K+M1D*M2K+M12D*M3K
        KPLW=-1
        IF(IFTR.GT.0.AND.IFTR.LE.M123D)KPLW=INDG(IFTR)
        IF(KPLW.GE.0)
     &  CON(IBAS)=CON(IBAS)+CHI(JBAS)*VPS(KPLW)
        ENDDO                              !!! over jbas
        ENDDO                              !!! over ibas
	ENDIF
	END



	SUBROUTINE CONVOL2(RHOPS,CHIL,CHIR,TPM,JBMIN,JBMAX,IBMIN,IBMAX)
*******************************************************
*  Makes a convolution of two pseudoorbitals.         *
*  This is what takes all the time in the program.    *
*******************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
	DIMENSION GPLW(3,0:NPLWMAX)
	COMPLEX*16 RHOPS(0:NPLWMAX),CHIL(0:NBASMAX),CHIR(0:NBASMAX)
	CHARACTER*1 TPM
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG      !!! from plwmsh
        DATA PI/3.141592653589793D0/
        M1D=KGMAX(1)-KGMIN(1)+1
        M2D=KGMAX(2)-KGMIN(2)+1
        M3D=KGMAX(3)-KGMIN(3)+1
        M12D=M1D*M2D
        M123D=M1D*M2D*M3D
C  MAKE IT WITH PLUS
	IF(TPM.EQ.'P')THEN
        DO JBAS=JBMIN,JBMAX
        M1J=KVEC(1,JBAS)+KGMIN(1)
        M2J=KVEC(2,JBAS)+KGMIN(2)
        M3J=KVEC(3,JBAS)+KGMIN(3)
        DO IBAS=IBMIN,IBMAX
        M1K=KVEC(1,IBAS)-M1J
        M2K=KVEC(2,IBAS)-M2J
        M3K=KVEC(3,IBAS)-M3J
        IFTR=1+M1K+M1D*M2K+M12D*M3K
        KPLW=-1
        IF(IFTR.GT.0.AND.IFTR.LE.M123D)KPLW=INDG(IFTR)
        IF(KPLW.GE.0)
     &  RHOPS(KPLW)=RHOPS(KPLW)+CHIL(JBAS)*CHIR(IBAS)
        ENDDO                                   !!! over ibas
        ENDDO                                   !!! over jbas
C  MAKE IT WITH MINUS
	ELSEIF(TPM.EQ.'M')THEN
        DO JBAS=JBMIN,JBMAX
        M1J=KVEC(1,JBAS)+KGMIN(1)
        M2J=KVEC(2,JBAS)+KGMIN(2)
        M3J=KVEC(3,JBAS)+KGMIN(3)
        DO IBAS=IBMIN,IBMAX
        M1K=KVEC(1,IBAS)-M1J
        M2K=KVEC(2,IBAS)-M2J
        M3K=KVEC(3,IBAS)-M3J
        IFTR=1+M1K+M1D*M2K+M12D*M3K
        KPLW=-1
        IF(IFTR.GT.0.AND.IFTR.LE.M123D)KPLW=INDG(IFTR)
        IF(KPLW.GE.0)
     &  RHOPS(KPLW)=RHOPS(KPLW)-CHIL(JBAS)*CHIR(IBAS)
        ENDDO                                   !!! over ibas
        ENDDO                                   !!! over jbas
	ENDIF
	END
