	SUBROUTINE ENYCOR(ROOT,NODES,L,JT,D,S,Z,FI,FID,
     &                    NRAD,H,R,DR,LR)
***************************************************************
*   Find eigenvalue for given l and number of nodes.          *
*   LR=0 - non-relativistically                               *
*   LR=1 - scalar-relativistically                            *
*   LR=2 - fully relativistically                             *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	DIMENSION Z(0:NRADMAX),P(0:NRADMAX),Q(0:NRADMAX)
     &    ,R(0:NRADMAX),DR(0:NRADMAX),FI(0:NRADMAX)
     &    ,FID(0:NRADMAX)
	LOGICAL EXIT
	DATA C2/0.000013312838D0/
	IF(Z(0).GE.1.D-05)LCR=LR
	IF(Z(0).LE.1.D-05)LCR=0
	E=ROOT
	EMAX=1.D+25
C   DEFINE CLASSICAL TURNING POINT
	DO IRAD=1,NRAD
	IF(-Z(IRAD)/R(IRAD).LE.E)ITRN=IRAD
	ENDDO
	IF(ITRN.GT.NRAD-10)ITRN=NRAD
C   DEFINE INTEGRATION RADIUS
	RS=15.D0*R(ITRN)
	MRAD=NRAD
	DO IRAD=0,NRAD
	IF(RS.GT.R(IRAD))MRAD=IRAD
	ENDDO
	IF(MOD(MRAD,2).NE.0)MRAD=MRAD-1
	IF(MRAD.GT.NRAD-10)MRAD=NRAD
	RS=R(MRAD)
	ECUT=-Z(MRAD)/R(MRAD)
	ITER=0
	ICTR=0
 100    ITER=ITER+1
C   GET APPROXIMATE ROOT
	CALL GETENR(E,NODE,DELQ,ITER,EMAX,NODES,EXIT,NOROOT)
C   SET LOGARITHMIC DERIVATIVE AT THE SPHERE BOUNDARY
	EKIN=E+Z(MRAD)/RS
	IF(EKIN.LT.0.D0.AND.ICTR.LT.4)THEN
	D=-1.D0-SQRT(-EKIN)*RS
	DO L0=1,L
	D=-EKIN*RS*RS/D-DBLE(2*L0+1)
	ENDDO
	D=D+DBLE(L)
C   CHANGE BOUNDARY CONDITION TO THE CENTER OF THE BAND
	ELSE 
	ICTR=ICTR+1
	D=DBLE(-L-1)
	IF(ICTR.EQ.5)THEN
	ITER=0
	RS=S
	MRAD=NRAD
	ITRN=NRAD
	PRINT*,'<CORSCH>: CANNOT FIND BINDING ENERGY, SET DNY=-L-1'
	GOTO100
	ENDIF
	ENDIF
C   SOLVE SHROEDINGER (DIRAC) EQUATION
	CALL RUNSCH(E,RS,Z,L,JT,NODE,D,ITRN,P,Q,DELQ,MRAD,
     &  H,R,DR,LCR)
	IF(EXIT.OR.NOROOT.GT.1)GOTO200
	GOTO100
C   SET ROOT 
 200    IF(NOROOT.LE.1)ROOT=E
	IF(NOROOT.GT.1)ROOT=ROOT
	IF(ECUT.LT.E.AND.MRAD.LT.NRAD)THEN
	PRINT*,'<CORSCH>:: LOST OF ACCURACY, ECUT,ROOT==',ECUT,E
	ENDIF
C   GET RADIAL WAVE FUNCTIONS IN NON-RELATIVISTIC CASE
	IF(LCR.EQ.0)THEN
	ANORM=SQRT(FSIM(P,P,MRAD,H,DR))
	DO I=1,MRAD
	FI(I)=P(I)/(ANORM*R(I))
	FID(I)=Q(I)/(ANORM*R(I))+DBLE(L)*P(I)/(ANORM*R(I)*R(I))
	ENDDO
	DO I=MRAD+1,NRAD
	FI(I)=0.D0
	FID(I)=0.D0
	ENDDO
	IF(L.EQ.0)THEN
	FI(0)=1.D0/ANORM
	FID(0)=-Z(0)/(2.D0*ANORM)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.0D0
	FID(0)=1.D0/ANORM
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
C   GET RADIAL WAVE FUNCTIONS IN SCALAR-RELATIVISTIC CASE
	ELSEIF(LCR.EQ.1)THEN
	ANORM=SQRT(FSIM(P,P,MRAD,H,DR))
	DO I=1,MRAD
	FI(I)=P(I)/(ANORM*R(I))
	FID(I)=Q(I)/(ANORM*R(I))*(1.D0+C2*(E+Z(I)/R(I)))
	ENDDO
	DO I=MRAD+1,NRAD
	FI(I)=0.D0
	FID(I)=0.D0
	ENDDO
	IF(L.EQ.0)THEN
	FI(0)=FI(1)-FID(1)*R(1)  !!! diverges
	FID(0)=FID(1)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.D0
	FID(0)=FID(1)            !!! diverges
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
C   GET RADIAL WAVE FUNCTIONS IN FULLY-RELATIVISTIC CASE
C   THE PHI IS A LARGE COMPONENT AND PHID IS A SMALL COMPONENT
	ELSEIF(LCR.EQ.2)THEN
	RJ=DBLE(JT)/2.D0
	RL=DBLE(L)
	IF(ABS(RJ-(RL-0.5D0)).LE.1.D-10)RK=RL
	IF(ABS(RJ-(RL+0.5D0)).LE.1.D-10)RK=-RL-1.D0
	ANORMG2=FSIM(P,P,MRAD,H,DR)
C   FORM SMALL COMPONENT F*r=FI
	FI(0)=(Q(0)+(RK+1.D0)/Z(0)/C2*P(0))*SQRT(C2)
	DO I=1,MRAD
	A=1.D0+C2*(E+Z(I)/R(I))
	FI(I)=(Q(I)+(RK+1.D0)/A*P(I)/R(I))*SQRT(C2)
	ENDDO
	ANORMF2=FSIM(FI,FI,MRAD,H,DR)
	ANORM=SQRT(ANORMG2+ANORMF2)
C   RENORMALIZE LARGE COMPONENT G=FI AND SMALL COMPONENT F=FID
	DO I=1,MRAD
	FI(I)=P(I)/(ANORM*R(I))
	A=1.D0+C2*(E+Z(I)/R(I))
	FID(I)=(Q(I)+(RK+1.D0)/A*P(I)/R(I))*SQRT(C2)/(R(I)*ANORM)
	ENDDO
	DO I=MRAD+1,NRAD
	FI(I)=0.D0
	FID(I)=0.D0
	ENDDO
	IF(L.EQ.0)THEN
	FI(0)=FI(1)              !!! diverges
	FID(0)=FID(1)
	ELSEIF(L.EQ.1)THEN
	FI(0)=0.D0
	FID(0)=FID(1)            !!! diverges
	ELSE
	FI(0)=0.D0
	FID(0)=0.D0
	ENDIF
C   RELATIVISTIC LOGARITHMIC DERIVATIVE
	DRLOG=R(MRAD)/SQRT(C2)*FID(MRAD)/FI(MRAD)-RK-1.D0
	IF(ABS(DRLOG-D).GT.1.D-05)PRINT*,
     &  '<CORSCH>:: LOGARITHMIC DERIVATIVES MISMATCH',D,DRLOG
	ENDIF
	END



	SUBROUTINE GETENR(E,NODE,DELQ,ITER,EMAX,NODES,EXIT,NOROOT)
***************************************************************
*   Search for the eigenvalue.                                *
***************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	LOGICAL EXIT
	SAVE
	DATA NITERMAX/100/,EPS/1.D-10/
C  **** SET STEP 1 AND RETURN ****
	IF(ITER.EQ.1)THEN
	KEY=1
	IF(E.LE.0)ESTEP=-0.1D0*E
	IF(E.GT.0)ESTEP=+0.1D0*E
	IF(ABS(ESTEP).LT.0.5D0)ESTEP=0.5D0
	NOROOT=0
	NOROOT1=0
	EXIT=.FALSE.
	RETURN
	ENDIF
C  **** CHECK FOR NITERMAX *******
	IF(ITER.GT.NITERMAX)THEN
	PRINT*,' NUMBER OF ITERATIONS EXCEEDED IN <CORSCH>'
	IF(NOROOT1.GT.1)NOROOT=2
	EXIT=.TRUE.
	ENDIF
C  GOTO ACCORDING TO PREVIOUS CALL
	GOTO (10,20,30,40,50),KEY
C  **** DEFINE APPROXIMATE ROOT WITH CORRECT NUMBER OF NODES (STEP 1 AND 2) ****
C  STEP 1 ------>
  10    E1=E
	N1=NODE
	D1=DELQ
C  NUMBER OF NODES IS TOO LARGE, DECREASE ENERGY
	IF(N1.GT.NODES)THEN
	E=E1-ESTEP
C  NUMBER OF NODES IS TOO SMALL, INCREASE ENERGY
	ELSEIF(N1.LT.NODES)THEN
	E=E1+ESTEP
	IF(E.GE.EMAX)THEN
	ESTEP=EMAX-E1-1.D-10
	E=E1+ESTEP
	NOROOT=NOROOT+1
	ENDIF
C  NUMBER OF NODES IS OK, GOTO STEP 3
	ELSEIF(N1.EQ.NODES)THEN
	ESTEPP=ESTEP
	ESTEPM=ESTEP
	EP1=E1
	NP1=N1
	DP1=D1
	EM1=E1
	NM1=N1
	DM1=D1
	E3=E1
	N3=N1
	D3=D1
	E4=E1
	N4=N1
	D4=D1
	NOROOT=0
	GOTO30
	ENDIF   
	KEY=2
	RETURN
C  STEP 2 ------>
  20    E2=E
	N2=NODE
	D2=DELQ
C  NUMBER OF NODES IS TOO LARGE, DECREASE ENERGY
	IF(N2.GT.NODES.AND.N1.GT.NODES)THEN
	E=E2-ESTEP
	E1=E2
	N1=N2
	D1=D2
C  NUMBER OF NODES IS TOO SMALL, INCREASE ENERGY
	ELSEIF(N2.LT.NODES.AND.N1.LT.NODES)THEN
	E=E2+ESTEP
	IF(E.GE.EMAX)THEN
	ESTEP=EMAX-E2-1.D-10
	E=E2+ESTEP
	NOROOT=NOROOT+1
	ENDIF
	E1=E2
	N1=N2
	D1=D2
C  NUMBER OF NODES IS TOO LARGE, DECREASE ENERGY STEP
	ELSEIF(N2.GT.NODES.AND.N1.LT.NODES)THEN
	ESTEP=ESTEP/2.D0
	E=E1+ESTEP
	IF(E.GE.EMAX)THEN
	ESTEP=EMAX-E1-1.D-10
	E=E1+ESTEP
	NOROOT=NOROOT+1
	ENDIF
C  NUMBER OF NODES IS TOO SMALL, DECREASE ENERGY STEP
	ELSEIF(N2.LT.NODES.AND.N1.GT.NODES)THEN
	ESTEP=ESTEP/2.D0
	E=E1-ESTEP
C  NUMBER OF NODES IS OK, GOTO STEP 3
	ELSEIF(N2.EQ.NODES)THEN
	E1=E2
	N1=N2
	D1=D2
	ESTEPP=ESTEP
	ESTEPM=ESTEP
	EP1=E1
	NP1=N1
	DP1=D1
	EM1=E1
	NM1=N1
	DM1=D1
	E3=E1
	N3=N1
	D3=D1
	E4=E1
	N4=N1
	D4=D1
	NOROOT=0
	GOTO30
	ENDIF
	KEY=2
	RETURN
C  APPROXIMATE ROOT WITH CORRECT NUMBER OF NODES HAS BEEN FOUND.
C  DEFINE ENERGY RANGE FOR THE ROOT (STEP 3 AND 4)
C  STEP 3 INCREASES ENERGY ------>
  30    E3=E
	N3=NODE
	D3=DELQ
	EP2=E4
	NP2=N4
	DP2=D4
C  ENERGY RANGE IS DEFINED, GOTO STEP 5
	IF(DP2*D1.LT.0.D0.AND.NP2.EQ.NODES)THEN
	E2=E4
	N2=N4
	D2=D4
	E=E4
	NODE=N4
	DELQ=D4
	GOTO50
C  SIGN OF DERIVATIVES IS THE SAME, INCREASE ENERGY
	ELSEIF(DP2*D1.GT.0.D0.AND.NP2.EQ.NODES)THEN
	E=EP2+ESTEPP
	   IF(E.GE.EMAX)THEN
	   ESTEPP=EMAX-EP2-1.D-10
	   E=EP2+ESTEPP
	   NOROOT1=NOROOT1+1
	   ENDIF
	EP1=EP2
	NP1=NP2
	DP1=DP2
C  NUMBER OF NODES IS TOO LARGE, DECREASE ENERGY STEP
	ELSEIF(NP2.GT.NODES)THEN
	ESTEPP=ESTEPP/2.D0
	E=EP1+ESTEPP
	   IF(E.GE.EMAX)THEN
	   ESTEPP=EMAX-EP1-1.D-10
	   E=EP1+ESTEPP
	   ENDIF
	ENDIF
	KEY=4
	RETURN
C  STEP 4 DECREASES ENERGY ------>
  40    E4=E
	N4=NODE
	D4=DELQ
	EM2=E3
	NM2=N3
	DM2=D3
C  ENERGY RANGE IS DEFINED, GOTO STEP 5
	IF(DM2*D1.LT.0.D0.AND.NM2.EQ.NODES)THEN
	E2=E3
	N2=N3
	D2=D3
	E=E3
	NODE=N3
	DELQ=D3
	GOTO50
C  SIGN OF DERIVATIVES IS THE SAME, DECREASE ENERGY
	ELSEIF(DM2*D1.GT.0.D0.AND.NM2.EQ.NODES)THEN
	E=EM2-ESTEPM
	EM1=EM2
	NM1=NM2
	DM1=DM2
C  NUMBER OF NODES IS TOO SMALL, DECREASE ENERGY STEP
	ELSEIF(NM2.LT.NODES)THEN
	ESTEPM=ESTEPM/2.D0
	E=EM1-ESTEPM
	ENDIF
	KEY=3
	RETURN
C  ***** ENERGY RANGE HAS BEEN FOUND, DEFINE APPROXIMATE ROOT *****
C  ***** KNOWN VALUES ARE : E1,D1,E2,D2 ***************************
C  STEP 5 : CROSSING LINE METHOD ------>
  50    IF(DELQ*D2.GE.0.D0)THEN
	E2=E
	D2=DELQ
	ELSEIF(DELQ*D1.GE.0.D0)THEN
	E1=E
	D1=DELQ
	ENDIF
C  DEFINE ROOT IN LINEAR APPROXIMATION
	E0=(D1*E2-D2*E1)/(D1-D2)
C  CHECK FOR CONVERGENCY
	IF(ABS(E-E0).GT.EPS)EXIT=.FALSE.
	IF(ABS(E-E0).LE.EPS)EXIT=.TRUE.
	KEY=5
	E=E0
	END




	SUBROUTINE RUNSCH(EN,S,Z,L,JT,NODES,D,ITRN,P,Q,DELQ,
     &                    NRAD,H,R,DR,LR)
***************************************************************
*  The solution of the radial Schroedinger equation           *
*                                                             *
*   / P'(r)=Q(r)+(l+1)*P(r)/r                                 *
*   \ Q'(r)=(V(r)-E)*P(r)-(l+1)*Q(r)/r                        *
*     FI(r)=P(r)/r and FID(r)=FI'(r)                          *
*                                                             *
*  or (scalar) relativistic Dirac equation                    *
*                                                             *
*   / P'(r)=A(r)*Q(r)+P(r)/r                                  *
*   \ Q'(r)=[V(r)-E+C(r)-V'(r)/A(r)^2*(k+1)]*P(r)-Q(r)/r      *
*  where                                                      *
*     A(r)=1+(E-V(r))/c^2                                     *
*     C(r)=l*(l+1)/r^2/A(r)                                   *
*     g(r)=P(r)/r - large component and                       *
*     f(r)=(Q(r)+(k+1)/A(r)*P(r)/r)/(rc) - small component    *
*  and c is the light velocity.                               *
*  Scalar-relativistic equations are obtained by dropping     *
*  the spin-orbit term with k=-l-1 for j=l+1/2 and k=l for    *
*  j=l-1/2. Note that the input jt=2*j                        *
***************************************************************
	IMPLICIT REAL*8 (A-H,K,M,O-Z)
	INCLUDE 'PARAM.DAT'
	REAL*8 L2
	DIMENSION Z(0:NRADMAX),P(0:NRADMAX),Q(0:NRADMAX),R(0:NRADMAX)
     &   ,DR(0:NRADMAX),DZDR(0:NRADMAX)
	DATA C2/0.000013312838D0/
	L1=L+1
	NODES=0
	BETTA=S/(EXP(H*NRAD)-1.D0)
	IF(Z(0).GE.1.D-05)LCR=LR
	IF(Z(0).LE.1.D-05)LCR=0
C ********************************************************** 
C       NON-RELATIVISTIC VERSION (LOGARITHMIC SCALE)       *
C **********************************************************
	IF(LCR.EQ.0) THEN
C   DIRECT RECURSION ---->
C   ASSYMPTOTIC BEHAVIOR ::
	P(0)=0.D0
	Q(0)=0.D0
	I0=1
  10    P(I0)=R(I0)**L1*(1.D0-Z(0)/(2.D0*L1)*R(I0))
	IF(P(I0).EQ.0.D0)THEN
	Q(I0)=0.D0
	I0=I0+1
	GOTO10
	ENDIF
	Q(I0)=-Z(0)*R(I0)**L1/(L1*2.D0)
	IF(Z(0).LE.1.D-05)Q(I0)=-EN*R(I0)**(L1+1)/(2.D0*L1+1)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	A3=DR(I0)*H
	B3=A3/R3*L1
	V3=A3*EN+A3/R3*Z(I0)
	DO 20 I=I0,ITRN-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0) !!! R(I+1/2)
	R3=R(I+1)
	A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I+1)*H
	B1=B3
	B2=A2/R2*L1
	B3=A3/R3*L1
	V1=V3
	IF(I.NE.NRAD-1)
     &  V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*6.25D-2
	IF(I.EQ.NRAD-1)V2=A2*EN+A2/R2*(Z(I)+Z(I+1))*0.5D0
	V3=A3*EN+A3/R3*Z(I+1)
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
  20    CONTINUE
	PTURN=P(ITRN)
	QTURN=Q(ITRN)
	IF(ITRN.EQ.NRAD)THEN
	DELQ=QTURN-(D-L)/S*P(NRAD)
	RETURN
	ENDIF
C   REVERSE RECURSION -->
	P(NRAD)=1.D-03
	Q(NRAD)=(D-L)/S*P(NRAD)
	R3=R(NRAD)
	A3=DR(NRAD)*H
	B3=A3/R3*L1
	V3=A3*EN+A3/R3*Z(NRAD)
	DO 30 I=NRAD,ITRN+1,-1
	R1=R3
	R2=BETTA*(EXP(H*(I-0.5D0))-1.D0) !!! R(I-1/2)
	R3=R(I-1)
	A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I-1)*H
	B1=B3
	B2=A2/R2*L1
	B3=A3/R3*L1
	V1=V3
	IF(I.NE.NRAD)
     &  V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I-1))-Z(I-2)-Z(I+1))*6.25D-2
	IF(I.EQ.NRAD)V2=A2*EN+A2/R2*(Z(I)+Z(I-1))*0.5D0
	V3=A3*EN+A3/R3*Z(I-1)
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)-M1*0.5D0)+B2*(P(I)-K1*0.5D0)
	M2=-V2*(P(I)-K1*0.5D0)-B2*(Q(I)-M1*0.5D0)
C   **************
	K3= A2*(Q(I)-M2*0.5D0)+B2*(P(I)-K2*0.5D0)
	M3=-V2*(P(I)-K2*0.5D0)-B2*(Q(I)-M2*0.5D0)
C   **************
	K4= A3*(Q(I)-M3)+B3*(P(I)-K3)
	M4=-V3*(P(I)-K3)-B3*(Q(I)-M3)
C   **************
	P(I-1)=P(I)-(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I-1)=Q(I)-(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I-1).LT.0.D0)NODES=NODES+1
  30    CONTINUE
C   MATCHING OF FUNCTIONS
	ANORM=PTURN/P(ITRN)
	DO 40 I=ITRN,NRAD
	P(I)=P(I)*ANORM
	Q(I)=Q(I)*ANORM
  40    CONTINUE
C   MISMATCH IN DERIVATIVES
	DELQ=QTURN-Q(ITRN)
C ********************************************************** 
C       SCALAR-RELATIVISTIC VERSION                        *
C **********************************************************
	ELSEIF(LCR.EQ.1)THEN
	L2=L1*(L1-1)
C   DIRECT RECURSION ---->
C   ASSIMPTOTIC BEHAVIOR ::
	QL=SQRT(L2+1-Z(0)**2*C2)
	P(0)=0.D0
	Q(0)=0.D0
	I0=1
  50    P(I0)=R(I0)**QL
	IF(P(I0).EQ.0.D0)THEN
	Q(I0)=0.D0
	I0=I0+1
	GOTO50
	ENDIF
	Q(I0)=P(I0)*(QL-1.D0)/(Z(0)*C2)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	A3=DR(I0)*(1.D0+EV3*C2)*H
	V3=DR(I0)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DO 60 I=I0,ITRN-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD-1)
     &  EV2=EN+(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*6.25D-02/R2
	IF(I.EQ.NRAD-1)EV2=EN+(Z(I)+Z(I+1))*0.5D0/R2
	EV3=EN+Z(I+1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I+1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
  60    CONTINUE
	PTURN=P(ITRN)
	QTURN=Q(ITRN)
	IF(ITRN.EQ.NRAD)THEN
	DELQ=QTURN-D*P(NRAD)/(S+(EN*S+Z(NRAD))*C2)
	RETURN
	ENDIF
C   REVERSE RECURSION -->
	P(NRAD)=1.D-03
	Q(NRAD)=D*P(NRAD)/(S+(EN*S+Z(NRAD))*C2)
	R3=R(NRAD)
	B3=DR(NRAD)/R3*H
	EV3=EN+Z(NRAD)/R3
	A3=DR(NRAD)*(1.D0+EV3*C2)*H
	V3=DR(NRAD)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DO 70 I=NRAD,ITRN+1,-1
	R1=R3
	R2=BETTA*(EXP(H*(I-0.5D0))-1.D0)   !!! R(I-1/2)
	R3=R(I-1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I-1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD)
     &  EV2=EN+(9.D0*(Z(I)+Z(I-1))-Z(I-2)-Z(I+1))*6.25D-02/R2
	IF(I.EQ.NRAD)EV2=EN+(Z(I)+Z(I-1))*0.5D0/R2
	EV3=EN+Z(I-1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I-1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I-1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)-M1*0.5D0)+B2*(P(I)-K1*0.5D0)
	M2=-V2*(P(I)-K1*0.5D0)-B2*(Q(I)-M1*0.5D0)
C   **************
	K3= A2*(Q(I)-M2*0.5D0)+B2*(P(I)-K2*0.5D0)
	M3=-V2*(P(I)-K2*0.5D0)-B2*(Q(I)-M2*0.5D0)
C   **************
	K4= A3*(Q(I)-M3)+B3*(P(I)-K3)
	M4=-V3*(P(I)-K3)-B3*(Q(I)-M3)
C   **************
	P(I-1)=P(I)-(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I-1)=Q(I)-(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I-1).LT.0.D0)NODES=NODES+1
  70    CONTINUE
C   MATCHING OF FUNCTIONS
	ANORM=PTURN/P(ITRN)
	DO 80 I=ITRN,NRAD
	P(I)=P(I)*ANORM
	Q(I)=Q(I)*ANORM
  80    CONTINUE
C   MISMATCH IN DERIVATIVES
	DELQ=QTURN-Q(ITRN)
C ********************************************************** 
C       FULLY-RELATIVISTIC VERSION                         *
C **********************************************************
	ELSEIF(LCR.EQ.2)THEN
	RJ=DBLE(JT)/2.D0
	RL=DBLE(L)
	IF(ABS(RJ-(RL-0.5D0)).LE.1.D-10)RK=RL
	IF(ABS(RJ-(RL+0.5D0)).LE.1.D-10)RK=-RL-1.D0
	L2=L1*(L1-1)
C   FIND DERIVATIVE OF THE POTENTIAL
	CALL SDERIV1(Z,DZDR,NRAD,H,R,DR,S)
C   DIRECT RECURSION ---->
C   ASSIMPTOTIC BEHAVIOR ::
	QL=SQRT(L2-(RK+1)+1-Z(0)**2*C2)
	P(0)=0.D0
	Q(0)=0.D0
	I0=1
  90    P(I0)=R(I0)**QL
	IF(P(I0).EQ.0.D0)THEN
	Q(I0)=0.D0
	I0=I0+1
	GOTO90
	ENDIF
	Q(I0)=P(I0)*(QL-1.D0)/(Z(0)*C2)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	DVDR3=Z(I0)/R3/R3-DZDR(I0)/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A3=DR(I0)*(1.D0+EV3*C2)*H
	V3=DR(I0)*(EV3-L2/R3/R3/(1.D0+EV3*C2)+SO3)*H
	DO 100 I=I0,ITRN-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	DVDR1=DVDR3
	SO1=SO3
	IF(I.NE.NRAD-1)THEN
	ZMR=(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*6.25D-02
	ZMD=(9.D0*(DZDR(I)+DZDR(I+1))-DZDR(I-1)-DZDR(I+2))*
     &  6.25D-02
	ELSEIF(I.EQ.NRAD-1)THEN
	ZMR=(Z(I)+Z(I+1))*0.5D0
	ZMD=(DZDR(I)+DZDR(I+1))*0.5D0
	ENDIF
	EV2=EN+ZMR/R2
	DVDR2=ZMR/R2/R2-ZMD/R2
	SO2=DVDR2/R2*(RK+1.D0)*C2/(1.D0+EV2*C2)**2
	EV3=EN+Z(I+1)/R3
	DVDR3=Z(I+1)/R3/R3-DZDR(I+1)/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2)+SO2)*H
	V3=DR(I+1)*(EV3-L2/R3/R3/(1.D0+EV3*C2)+SO3)*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I+1).LT.0.D0)NODES=NODES+1
 100    CONTINUE
	PTURN=P(ITRN)
	QTURN=Q(ITRN)
	AS=1.D0+C2*(EN+Z(NRAD)/S)
	IF(ITRN.EQ.NRAD)THEN
	DELQ=QTURN-P(NRAD)/S*(D+(RK+1.D0)*(1.D0-1.D0/AS))
	RETURN
	ENDIF
C   REVERSE RECURSION -->
	P(NRAD)=1.D-03
	Q(NRAD)=P(NRAD)/S*(D+(RK+1.D0)*(1.D0-1.D0/AS))
	R3=R(NRAD)
	B3=DR(NRAD)/R3*H
	EV3=EN+Z(NRAD)/R3
	DVDR3=Z(NRAD)/R3/R3-DZDR(NRAD)/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A3=DR(NRAD)*(1.D0+EV3*C2)*H
	V3=DR(NRAD)*(EV3-L2/R3/R3/(1.D0+EV3*C2)+SO3)*H
	DO 110 I=NRAD,ITRN+1,-1
	R1=R3
	R2=BETTA*(EXP(H*(I-0.5D0))-1.D0)   !!! R(I-1/2)
	R3=R(I-1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I-1)/R3*H
	EV1=EV3
	DVDR1=DVDR3
	SO1=SO3
	IF(I.NE.NRAD)THEN
	ZMR=(9.D0*(Z(I)+Z(I-1))-Z(I-2)-Z(I+1))*6.25D-02
	ZMD=(9.D0*(DZDR(I)+DZDR(I-1))-DZDR(I-2)-DZDR(I+1))*
     &  6.25D-02
	ELSEIF(I.EQ.NRAD)THEN
	ZMR=(Z(I)+Z(I-1))*0.5D0
	ZMD=(DZDR(I)+DZDR(I-1))*0.5D0
	ENDIF
	EV2=EN+ZMR/R2
	DVDR2=ZMR/R2/R2-ZMD/R2
	SO2=DVDR2/R2*(RK+1.D0)*C2/(1.D0+EV2*C2)**2
	EV3=EN+Z(I-1)/R3
	DVDR3=Z(I-1)/R3/R3-DZDR(I-1)/R3
	SO3=DVDR3/R3*(RK+1.D0)*C2/(1.D0+EV3*C2)**2
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I-1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2)+SO2)*H
	V3=DR(I-1)*(EV3-L2/R3/R3/(1.D0+EV3*C2)+SO3)*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)-M1*0.5D0)+B2*(P(I)-K1*0.5D0)
	M2=-V2*(P(I)-K1*0.5D0)-B2*(Q(I)-M1*0.5D0)
C   **************
	K3= A2*(Q(I)-M2*0.5D0)+B2*(P(I)-K2*0.5D0)
	M3=-V2*(P(I)-K2*0.5D0)-B2*(Q(I)-M2*0.5D0)
C   **************
	K4= A3*(Q(I)-M3)+B3*(P(I)-K3)
	M4=-V3*(P(I)-K3)-B3*(Q(I)-M3)
C   **************
	P(I-1)=P(I)-(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I-1)=Q(I)-(M1+M4+2.D0*(M2+M3))/6.D0
	IF(P(I)*P(I-1).LT.0.D0)NODES=NODES+1
 110    CONTINUE
C   MATCHING OF FUNCTIONS
	ANORM=PTURN/P(ITRN)
	DO 120 I=ITRN,NRAD
	P(I)=P(I)*ANORM
	Q(I)=Q(I)*ANORM
 120    CONTINUE
C   MISMATCH IN DERIVATIVES
	DELQ=QTURN-Q(ITRN)
	ENDIF
	END



	SUBROUTINE DOTSCH(EN,S,Z,L,JT,D,ITRN,P,Q,PDOT,QDOT,
     &                    NRAD,H,R,DR,LR)
C  THIS PROGRAM IS NOT FINISHED YET.
***************************************************************
*  The solution of the equation for energy derivatives        *
*                                                             *
*   / Pdot'(r)=Qdot(r)+(l+1)*Pdot(r)/r                        *
*   \ Qdot'(r)=(V(r)-E)*Pdot(r)-(l+1)*Qdot(r)/r-P(r)          *
*     FIdot(r)=Pdot(r)/r                                      *
*                                                             *
*  or scalar-relativistic version                             *
*                                                             *
*   / Pdot'(r)=Adot*Q(r)+Pdot(r)/r+A(r)*Qdot(r)               *
*   \ Qdot'(r)=(V(r)-E+C(r))*Pdot(r)-Qdot(r)/r+(Cdot(r)-1)*P(r)
*  where                                                      *
*     A(r)=1+(E-V(r))/c^2                                     *
*     C(r)=l*(l+1)/r^2/A(r)                                   *
*     Adot=1/c^2                                              *
*     Cdot(r)=-l*(l+1)/r^2/A(r)/A(r)*Adot                     *
*     FIdot(r)=Pdot(r)/r                                      *
*  and c is the light velocity                                *
***************************************************************
	IMPLICIT REAL*8 (A-H,K,M,O-Z)
	INCLUDE 'PARAM.DAT'
	REAL*8 L2
	DIMENSION Z(0:NRADMAX),P(0:NRADMAX),Q(0:NRADMAX),PDOT(0:NRADMAX)
     &           ,QDOT(0:NRADMAX),R(0:NRADMAX),DR(0:NRADMAX)
	DATA C2/0.000013312838D0/
	L1=L+1
	BETTA=S/(EXP(H*NRAD)-1.D0)
	IF(Z(0).GE.1.D-05)LCR=LR
	IF(Z(0).LE.1.D-05)LCR=0
C ****** NON-RELATIVISTIC VERSION (LOGARITHMIC SCALE) ****** NOT DEBUGGED
	IF(LCR.EQ.0) THEN
C   DIRECT RECURSION ---->
C   ASSYMPTOTIC BEHAVIOR ::
	PDOT(0)=0.D0
	QDOT(0)=0.D0
	I0=1
  10    DL=-0.5D0/(2.D0*L+3.D0)
	EL=-(Z(0)*DL-Z(0)/(2.D0*L1))/6.D0/(L+2.D0)
	PDOT(I0)=R(I0)**(L+3)*(DL+EL*R(I0))
	IF(PDOT(I0).EQ.0.D0)THEN
	QDOT(I0)=0.D0
	I0=I0+1
	GOTO10
	ENDIF
	QDOT(I0)=R(I0)**(L+2)*(2.D0*DL+3.D0*EL*R(I0))
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	A3=DR(I0)*H
	B3=A3/R3*L1
	P3=P(I0)
	V3=A3*EN+A3/R3*Z(I0)
	DO 20 I=I0,ITRN-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0) !!! R(I+1/2)
	R3=R(I+1)
	A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I+1)*H
	B1=B3
	B2=A2/R2*L1
	B3=A3/R3*L1
	P1=P3
	V1=V3
	IF(I.NE.NRAD-1)V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))
     &  *6.25D-2
	IF(I.EQ.NRAD-1)V2=A2*EN+A2/R2*(Z(I)+Z(I+1))*0.5D0
	IF(I.NE.NRAD-1)P2=(9.D0*(P(I)+P(I+1))-P(I-1)-P(I+2))*6.25D-2
	IF(I.EQ.NRAD-1)P2=(P(I)+P(I+1))*0.5D0
	V3=A3*EN+A3/R3*Z(I+1)
	P3=P(I+1)
C   **************
	K1= A1*QDOT(I)+B1*PDOT(I)
	M1=-V1*PDOT(I)-B1*QDOT(I)-P1*A1
C   **************
	K2= A2*(QDOT(I)+M1*0.5D0)+B2*(PDOT(I)+K1*0.5D0)
	M2=-V2*(PDOT(I)+K1*0.5D0)-B2*(QDOT(I)+M1*0.5D0)-P2*A2
C   **************
	K3= A2*(QDOT(I)+M2*0.5D0)+B2*(PDOT(I)+K2*0.5D0)
	M3=-V2*(PDOT(I)+K2*0.5D0)-B2*(QDOT(I)+M2*0.5D0)-P2*A2
C   **************
	K4= A3*(QDOT(I)+M3)+B3*(PDOT(I)+K3)
	M4=-V3*(PDOT(I)+K3)-B3*(QDOT(I)+M3)-P3*A3
C   **************
	PDOT(I+1)=PDOT(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	QDOT(I+1)=QDOT(I)+(M1+M4+2.D0*(M2+M3))/6.D0
  20    CONTINUE
	PDOTTURN=PDOT(ITRN)
	QDOTTURN=QDOT(ITRN)
	IF(ITRN.EQ.NRAD)RETURN
C   REVERSE RECURSION -->
	PDOT(NRAD)=1.D0
	QDOT(NRAD)=(D-L)/S*PDOT(NRAD)
	R3=R(NRAD)
	A3=DR(NRAD)*H
	B3=A3/R3*L1
	P3=P(NRAD)
	V3=A3*EN+A3/R3*Z(NRAD)
	DO 30 I=NRAD,ITRN+1,-1
	R1=R3
	R2=BETTA*(EXP(H*(I-0.5D0))-1.D0) !!! R(I-1/2)
	R3=R(I-1)
	A1=A3
	A2=(R2+BETTA)*H
	A3=DR(I-1)*H
	B1=B3
	B2=A2/R2*L1
	B3=A3/R3*L1
	P1=P3
	V1=V3
	IF(I.NE.NRAD)P2=(9.D0*(P(I)+P(I-1))-P(I-2)-P(I+1))*6.25D-2
	IF(I.EQ.NRAD)P2=(P(I)+P(I-1))*0.5D0
	IF(I.NE.NRAD)V2=A2*EN+A2/R2*(9.D0*(Z(I)+Z(I-1))-Z(I-2)-Z(I+1))*
     &  6.25D-2
	IF(I.EQ.NRAD)V2=A2*EN+A2/R2*(Z(I)+Z(I-1))*0.5D0
	P3=P(I-1)
	V3=A3*EN+A3/R3*Z(I-1)
C   **************
	K1= A1*QDOT(I)+B1*PDOT(I)
	M1=-V1*PDOT(I)-B1*QDOT(I)-A1*P1
C   **************
	K2= A2*(QDOT(I)-M1*0.5D0)+B2*(PDOT(I)-K1*0.5D0)
	M2=-V2*(PDOT(I)-K1*0.5D0)-B2*(QDOT(I)-M1*0.5D0)-A2*P2
C   **************
	K3= A2*(QDOT(I)-M2*0.5D0)+B2*(PDOT(I)-K2*0.5D0)
	M3=-V2*(PDOT(I)-K2*0.5D0)-B2*(QDOT(I)-M2*0.5D0)-A2*P2
C   **************
	K4= A3*(QDOT(I)-M3)+B3*(PDOT(I)-K3)
	M4=-V3*(PDOT(I)-K3)-B3*(QDOT(I)-M3)-A3*P3
C   **************
	PDOT(I-1)=PDOT(I)-(K1+K4+2.D0*(K2+K3))/6.D0
	QDOT(I-1)=QDOT(I)-(M1+M4+2.D0*(M2+M3))/6.D0
  30    CONTINUE
C   MATCHING OF FUNCTIONS BY ADDING GENERAL SOLUTION
	AD=(PDOTTURN-PDOT(ITRN))/P(ITRN)
C       AD=(QDOTTURN-QDOT(ITRN))/Q(ITRN) !!! ALSO POSSIBLE ???
	DO 40 IRAD=ITRN,NRAD
	PDOT(IRAD)=PDOT(IRAD)+AD*P(IRAD)
	QDOT(IRAD)=QDOT(IRAD)+AD*Q(IRAD)
  40    CONTINUE
C ****** RELATIVISTIC VERSION ****** NOT WRITTEN
	ELSEIF(LCR.EQ.1.OR.LCR.EQ.2)THEN
	L2=L1*(L1-1)
C   DIRECT RECURSION ---->
C   ASSIMPTOTIC BEHAVIOR ::
	QL=SQRT(L2+1-Z(0)**2*C2)
	P(0)=0.D0
	I0=1
  50    P(I0)=R(I0)**QL
	IF(P(I0).EQ.0.D0)THEN
	I0=I0+1
	GOTO50
	ENDIF
	Q(I0)=P(I0)*(QL-1)/(Z(0)*C2)
C   4-TH ORDER RUNGE-KUTTA LOOP ::
	R3=R(I0)
	B3=DR(I0)/R3*H
	EV3=EN+Z(I0)/R3
	A3=DR(I0)*(1.D0+EV3*C2)*H
	V3=DR(I0)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DO 60 I=I0,ITRN-1
	R1=R3
	R2=BETTA*(EXP(H*(I+0.5D0))-1.D0)   !!! R(I+1/2)
	R3=R(I+1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I+1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD-1) EV2=EN+(9.D0*(Z(I)+Z(I+1))-Z(I-1)-Z(I+2))*
     &  6.25D-02/R2
	IF(I.EQ.NRAD-1) EV2=EN+(Z(I)+Z(I+1))*0.5D0/R2
	EV3=EN+Z(I+1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I+1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I+1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)+M1*0.5D0)+B2*(P(I)+K1*0.5D0)
	M2=-V2*(P(I)+K1*0.5D0)-B2*(Q(I)+M1*0.5D0)
C   **************
	K3= A2*(Q(I)+M2*0.5D0)+B2*(P(I)+K2*0.5D0)
	M3=-V2*(P(I)+K2*0.5D0)-B2*(Q(I)+M2*0.5D0)
C   **************
	K4= A3*(Q(I)+M3)+B3*(P(I)+K3)
	M4=-V3*(P(I)+K3)-B3*(Q(I)+M3)
C   **************
	P(I+1)=P(I)+(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I+1)=Q(I)+(M1+M4+2.D0*(M2+M3))/6.D0
  60    CONTINUE
	PTURN=P(ITRN)
	QTURN=Q(ITRN)
	IF(ITRN.EQ.NRAD)RETURN
C   REVERSE RECURSION -->
	P(NRAD)=1.D0
	Q(NRAD)=D*P(NRAD)/(S+(EN*S+Z(NRAD))*C2)
	R3=R(NRAD)
	B3=DR(NRAD)/R3*H
	EV3=EN+Z(NRAD)/R3
	A3=DR(NRAD)*(1.D0+EV3*C2)*H
	V3=DR(NRAD)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
	DO 70 I=NRAD,ITRN+1,-1
	R1=R3
	R2=BETTA*(EXP(H*(I-0.5D0))-1.D0)   !!! R(I-1/2)
	R3=R(I-1)
	B1=B3
	B2=(R2+BETTA)/R2*H
	B3=DR(I-1)/R3*H
	EV1=EV3
	IF(I.NE.NRAD) EV2=EN+(9.D0*(Z(I)+Z(I-1))-Z(I-2)-Z(I+1))*
     &  6.25D-02/R2
	IF(I.EQ.NRAD) EV2=EN+(Z(I)+Z(I-1))*0.5D0/R2
	EV3=EN+Z(I-1)/R3
	A1=A3
	A2=(R2+BETTA)*(1.D0+EV2*C2)*H
	A3=DR(I-1)*(1.D0+EV3*C2)*H
	V1=V3
	V2=(R2+BETTA)*(EV2-L2/R2/R2/(1.D0+EV2*C2))*H
	V3=DR(I-1)*(EV3-L2/R3/R3/(1.D0+EV3*C2))*H
C   **************
	K1= A1*Q(I)+B1*P(I)
	M1=-V1*P(I)-B1*Q(I)
C   **************
	K2= A2*(Q(I)-M1*0.5D0)+B2*(P(I)-K1*0.5D0)
	M2=-V2*(P(I)-K1*0.5D0)-B2*(Q(I)-M1*0.5D0)
C   **************
	K3= A2*(Q(I)-M2*0.5D0)+B2*(P(I)-K2*0.5D0)
	M3=-V2*(P(I)-K2*0.5D0)-B2*(Q(I)-M2*0.5D0)
C   **************
	K4= A3*(Q(I)-M3)+B3*(P(I)-K3)
	M4=-V3*(P(I)-K3)-B3*(Q(I)-M3)
C   **************
	P(I-1)=P(I)-(K1+K4+2.D0*(K2+K3))/6.D0
	Q(I-1)=Q(I)-(M1+M4+2.D0*(M2+M3))/6.D0
  70    CONTINUE
C   MATCHING OF FUNCTIONS
	ENDIF
	END
