	SUBROUTINE DELBXFTR(IGPTB,MY,IQPNT,KEY)
*************************************************************
* Calculates change in exchange-correlation pseudopotential *
* Generalized gradient corrections after Perdew et.al added *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3),MDIV(3)
     &    ,MF(3)
        COMPLEX*16 RHOPS(0:NPLWMAX,NSPINMAX)
     &    ,DPOTPS(0:NPLWMAX,NSPINMAX),DRHOPS(0:NPLWMAX,NSPINMAX)
     &    ,DBXCPS(0:NPLWMAX,NSPINMAX),DMAGPS(0:NPLWMAX,NSPINMAX)
     &    ,RHORS(NFFTMAX,NSPINMAX),DMAGRS(NFFTMAX,NSPINMAX)
     &    ,G1RHO(NFFTMAX,NSPINMAX,NGGAMAX)
     &    ,G2RHO(NFFTMAX,NSPINMAX,NGGAMAX,NGGAMAX)
     &    ,GR1UP(3),GR2UP(3,3),GR1DN(3),GR2DN(3,3)
     &    ,DBXCRS(NFFTMAX,NSPINMAX),TMPARR(NFFTMAX)
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3),QGAM(3)
     &    ,RBAS(3,3),GBAS(3,3),AD(3,3),RD(3,3),GL(3),QPNT(3)
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from readini
	COMMON /EXCH/   IXC                              !!! from readini
	COMMON /SPIN/   NSPIN                            !!! from readini
        COMMON /ORBS/   NORBS                            !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                          !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                       !!! from qvector
	COMMON /LATTICE/RBAS,GBAS                        !!! from readstr
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from readini
C Potential:
	COMMON /DPSVCOM/DPOTPS,DBXCPS                    !!! from dvxftr
C Density:
	COMMON /PSRHO/  RHOPS                            !!! from ttrint
	COMMON /DPSRHO/ DRHOPS,DMAGPS                    !!! from ttrint
C Temporary storage:
	COMMON /STORE1/ RHORS,DMAGRS,DBXCRS,G1RHO
	COMMON /STORE2/ G2RHO                            !!! tmp.storage
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
	COMMON /FFTMESH/MDIV,AD,RD                       !!! from readini
C Outputs:
	COMMON /WORD/   NVAL                             !!! from setup
	DATA PI/3.141592653589793D0/,QGAM/0.D0,0.D0,0.D0/
        IF(NORBS.EQ.1.AND.(MY.EQ.0.OR.MY.EQ.2))RETURN
        SFACT=0.5D0*DBLE(NSPIN)
C Set keys for LDA and GGA
        ILDA=MOD(IXC,10)     !!! LDA key
        IGGA=(IXC-ILDA)/10   !!! GGA key
        DO ISPIN=1,NSPIN                         !!! over spins
	ITRAN=ISPIN
C SET CHARGE DENSITY AT THE REAL SPACE MESH
        CALL FTRANSD( RHOPS(0,ISPIN), RHORS(1,ISPIN),
     &  TMPARR,0,0,QGAM)
        CALL FTRANSD(DMAGPS(0,ITRAN),DMAGRS(1,ITRAN),
     &  TMPARR,0,0,QPNT)
        IF(IGGA.NE.0)THEN
C SET DENSITY GRADIENTS
        DO IA=1,3
        CALL FTRANSD(RHOPS(0,ISPIN),G1RHO(1,ISPIN,IA),
     &  TMPARR,IA,0,QGAM)
	DO IB=1,3
        CALL FTRANSD(RHOPS(0,ISPIN),G2RHO(1,ISPIN,IA,IB),
     &  TMPARR,IA,IB,QGAM)
        ENDDO
        ENDDO
        ENDIF
        ENDDO                                    !!! over spins
C Set gradients to zero
        DO IA=1,3
        GR1UP(IA)=(0.D0,0.D0)
        GR1DN(IA)=(0.D0,0.D0)
        DO IB=1,3
        GR2UP(IA,IB)=(0.D0,0.D0)
        GR2DN(IA,IB)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ALRUP=0.D0
        ALRDN=0.D0
C *** GET EXCHANGE-CORRELATION PSEUDOPOTENTIAL AT THE REAL SPACE MESH ***
	DO 3000 MFFT3=0,MDIV(3)-1               !!! over mfft3
	DO 2000 MFFT2=0,MDIV(2)-1               !!! over mfft2
	DO 1000 MFFT1=0,MDIV(1)-1               !!! over mfft1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
C Spin densities
        ROUP=DREAL(RHORS(IFFT,1    ))*SFACT
        RODN=DREAL(RHORS(IFFT,NSPIN))*SFACT
C Spin gradients
        IF(IGGA.NE.0)THEN
        ALRUP=0.D0
        ALRDN=0.D0
        DO IA=1,3
        GR1UP(IA)=G1RHO(IFFT,1    ,IA)*SFACT
        GR1DN(IA)=G1RHO(IFFT,NSPIN,IA)*SFACT
        DO IB=1,3
        GR2UP(IA,IB)=G2RHO(IFFT,1    ,IA,IB)*SFACT
        GR2DN(IA,IB)=G2RHO(IFFT,NSPIN,IA,IB)*SFACT
        ENDDO
        ALRUP=ALRUP+GR2UP(IA,IA)
        ALRDN=ALRDN+GR2DN(IA,IA)
        ENDDO
        ENDIF
        CALL EXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,ALRDN,
     &       IXC,KEY,NSPIN,EXCUP,EXCDN,VXCUP,VXCDN)
        IF(ABS(ROUP-RODN).LE.1.D-05)WXC=0.D0
        IF(ABS(ROUP-RODN).GT.1.D-05.AND.KEY.EQ.1)
     &  WXC=0.5D0*(VXCUP-VXCDN)/(ROUP-RODN)
        IF(ABS(ROUP-RODN).GT.1.D-05.AND.KEY.EQ.2)
     &  WXC=0.5D0*(VXCUP-VXCDN)
        DO ITRAN=1,NSPIN                    !!! over -/+ polarizations
        IF(ITRAN.EQ.1)JTRAN=NSPIN
        IF(ITRAN.EQ.NSPIN)JTRAN=1
        DBXCRS(IFFT,ITRAN)=-WXC*DMAGRS(IFFT,JTRAN)
        ENDDO
1000	CONTINUE                                !!! over mfft1
2000	CONTINUE                                !!! over mfft2
3000	CONTINUE                                !!! over mfft3
C  GET EXCHANGE-CORRELATION MAGNETIC FIELD BY RECIPROCAL FOURIER TRANSFORM
        DO ITRAN=1,NSPIN
        CALL FTRANSR(DBXCPS(0,ITRAN),DBXCRS(1,ITRAN),TMPARR,QPNT)
        ENDDO
	END
