	SUBROUTINE SDELMAT(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)
**************************************************************
*  Calculate change in the Hamiltonian and Overlap matrices  *
*  due to change in the potential parameters                 *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX),IS(NPAT)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,NKAP(NPANMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &   ,DELHHH(LIMLMB,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHJH(LIMLMT,LIMLMB,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHHJ(LIMLMB,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DELHJJ(LIMLMT,LIMLMT,NPAT,NKAPMAX,NKAPMAX)
     &   ,DHHA(LIMLMT),DJHA(LIMLMT),DHJS(LIMLMT),DJJS(LIMLMT)
     &   ,THHA(LIMLMT),TJHA(LIMLMT),THJS(LIMLMT),TJJS(LIMLMT)
     &   ,DHA(LIMLMT,NPAT,NKAPMAX),DHS(LIMLMT,NPAT,NKAPMAX)
     &   ,DOA(LIMLMT,NPAT,NKAPMAX),DOS(LIMLMT,NPAT,NKAPMAX)
     &   ,DELOHH(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELOJH(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELOHJ(NKAPMAX,NKAPMAX,0:LMAXB,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DELOJJ(NKAPMAX,NKAPMAX,0:LMAXT,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &   ,DHMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &   ,DOMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &   ,APHK(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJK(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APHQ(LIMLMB ,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &   ,APJQ(LIMLMT1,NPAT,NKAPMAX,NORBSMAX,NDIMMAX*NSPINMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE           !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM          !!! from init
        COMMON /ORBS/   NORBS                                  !!! from init
        COMMON /SPIN/   NSPIN                                  !!! from init
C Inputs:
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                      !!! from init
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                  !!! from init
	COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                      !!! from init
C Pot.pars:
	COMMON /DOVRPAR/DELOHH,DELOJH,DELOHJ,DELOJJ            !!! from dlmtpar 
C Temporary:
	COMMON /STORE1/ DELHHH,DELHJH,DELHHJ,DELHJJ            !!! from dintpar
	COMMON /STORE2/ DHMAT,DOMAT                            !!! from delmat
C Bands:
	COMMON /EIGVEC/ APHK,APJK,APHQ,APJQ                    !!! from lmtvec
C Outputs:
	COMMON /WORD/   NVAL                                   !!! from nmtdata
	DATA PI/3.141592653589793D0/
C  **** CALCULATE SOFT CHANGE IN THE HAMILTONIAN AND OVERLAP MATRIX ****
C  SET INITIAL VALUES
	DO IBNDS1=1,NSPIN
	DO IBNDT1=1,NBNDT(IPAN)
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO IBNDS=1,NSPIN
	DO IBNDT=1,NBNDT(IPAN)
	IBAND=IBNDS+NSPIN*(IBNDT-1)
	DHMAT(IBAND1,IBAND)=(0.D0,0.D0)
	DOMAT(IBAND1,IBAND)=(0.D0,0.D0)
	ENDDO
	ENDDO
	ENDDO
	ENDDO
        IF(MODE.NE.5)IBNDMIN=1
        IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
        IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
        IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C ***** DO GLOBALLY OVER SPINORS ********
	DO 6000 IUPDN1=1,NSPIN                    !!! over spinors
	IF(NORBS.EQ.2)IORBS1=IUPDN1
	IF(NORBS.EQ.1)IORBS1=1
	DO 5000 IUPDN =1,NSPIN                    !!! over spinors
	IF(NORBS.EQ.2)IORBS=IUPDN
	IF(NORBS.EQ.1)IORBS=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
	    IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
	IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
	ISPIN=1
        ITRAN=0
	ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
	IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
	ISPIN=2
        ITRAN=0
	ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
	IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO5000
	ISPIN=0
        ITRAN=2
	ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
	IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO5000
	ISPIN=0
        ITRAN=1
	ENDIF	
C READ POTENTIAL PARAMETERS
	IF(ISPIN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ISPIN,IQPNT,41,'R')
	IF(ITRAN.NE.0)CALL NMTFILES(IGPTB,MY,IPAN,ITRAN,IQPNT,43,'R')
	DO 4000 IBNDS=1,NSPIN                     !!! over spin subbands
	IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)GOTO4000
	DO 3000 IBNDT=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  FIND CONVOLUTIONS WITH THE CHANGE IN H-PAR AND O-PAR
	DO IKAP1=1,NKAP(IPAN)                     !!! over energies
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L1=0,ILST(ISORT)                       !!! over l1
	DO M1=-L1,L1                              !!! over m1
	L1M1=L1*(L1+1)+M1+1
	DHHA(L1M1)=(0.D0,0.D0)
	DJHA(L1M1)=(0.D0,0.D0)
	DHJS(L1M1)=(0.D0,0.D0)
	DJJS(L1M1)=(0.D0,0.D0)
	THHA(L1M1)=(0.D0,0.D0)
	TJHA(L1M1)=(0.D0,0.D0)
	THJS(L1M1)=(0.D0,0.D0)
	TJJS(L1M1)=(0.D0,0.D0)
	DO IKAP=1,NKAP(IPAN)                      !!! over energies
	IF(IPAN.EQ.1)THEN                         !!! only for valence panel
	DO L=0,ILST(ISORT)
	DO M=-L,L                                 !!! over l
	LM=L*(L+1)+M+1                            !!! over m
	IF(LTPAN(L1,IATOM,IKAP1,IPAN).AND.LTPAN(L,IATOM,IKAP,IPAN))
     &  DHHA(L1M1)=DHHA(L1M1)+
     &  DELHHH(L1M1,LM,IATOM,IKAP1,IKAP)*
     &  APHK(LM,IATOM,IKAP,IORBS,IBAND)
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &  DJHA(L1M1)=DJHA(L1M1)+
     &  DELHJH(L1M1,LM,IATOM,IKAP1,IKAP)*
     &  APHK(LM,IATOM,IKAP,IORBS,IBAND)
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))
     &  DHJS(L1M1)=DHJS(L1M1)+
     &  DELHHJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &  APJK(LM,IATOM,IKAP,IORBS,IBAND)
	DJJS(L1M1)=DJJS(L1M1)+
     &  DELHJJ(L1M1,LM,IATOM,IKAP1,IKAP)*
     &  APJK(LM,IATOM,IKAP,IORBS,IBAND)
        ENDDO                                     !!! over m
        ENDDO                                     !!! over l
	ENDIF
	IF(ISPIN.NE.0)THEN
	IF(LTPAN(L1,IATOM,IKAP1,IPAN).AND.LTPAN(L1,IATOM,IKAP,IPAN))
     &  THHA(L1M1)=THHA(L1M1)+
     &  DELOHH(IKAP1,IKAP,L1,IATOM,ISPIN,IGPTB,MY)*
     &  APHK(L1M1,IATOM,IKAP,IORBS,IBAND)
	IF(LTPAN(L1,IATOM,IKAP,IPAN))
     &  TJHA(L1M1)=TJHA(L1M1)+
     &  DELOJH(IKAP1,IKAP,L1,IATOM,ISPIN,IGPTB,MY)*
     &  APHK(L1M1,IATOM,IKAP,IORBS,IBAND)
	IF(LTPAN(L1,IATOM,IKAP1,IPAN))
     &  THJS(L1M1)=THJS(L1M1)+
     &  DELOHJ(IKAP1,IKAP,L1,IATOM,ISPIN,IGPTB,MY)*
     &  APJK(L1M1,IATOM,IKAP,IORBS,IBAND)
	TJJS(L1M1)=TJJS(L1M1)+
     &  DELOJJ(IKAP1,IKAP,L1,IATOM,ISPIN,IGPTB,MY)*
     &  APJK(L1M1,IATOM,IKAP,IORBS,IBAND)
	ENDIF
        ENDDO                                     !!! over energies
	DHA(L1M1,IATOM,IKAP1)=+DHHA(L1M1)-DHJS(L1M1)
	DHS(L1M1,IATOM,IKAP1)=-DJHA(L1M1)+DJJS(L1M1)
	DOA(L1M1,IATOM,IKAP1)=+THHA(L1M1)-THJS(L1M1)
	DOS(L1M1,IATOM,IKAP1)=-TJHA(L1M1)+TJJS(L1M1)
        ENDDO                                     !!! over m1
        ENDDO                                     !!! over l1
        ENDDO                                     !!! over atoms
        ENDDO                                     !!! over energies
C ***** DO GLOBALLY OVER BANDS IBND1 ******
	DO 2000 IBNDS1=1,NSPIN                    !!! over spin subbands
	IF(NORBS.EQ.1.AND.IUPDN1.NE.IBNDS1)GOTO2000
	DO 1000 IBNDT1=IBNDMIN,IBNDMAX            !!! over all bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
	DO IKAP=1,NKAP(IPAN)                      !!! over energies
	DO IATOM=1,NATOM                          !!! over atoms
	ISORT=IS(IATOM)
	DO L=0,ILST(ISORT)                        !!! over l
	DO M=-L,L                                 !!! over m
	LM=L*(L+1)+M+1
C  ONE-, TWO- AND THREE-CENTER CONTRIBUTIONS TO THE CHANGE IN H-MATRIX
	IF(IPAN.EQ.1)THEN
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &  DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+
     &  CONJG(APHQ(LM,IATOM,IKAP,IORBS1,IBAND1))*DHA(LM,IATOM,IKAP)
	DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+
     &  CONJG(APJQ(LM,IATOM,IKAP,IORBS1,IBAND1))*DHS(LM,IATOM,IKAP)
	ENDIF
C  ONE-, TWO- AND THREE-CENTER CONTRIBUTIONS TO THE CHANGE IN O-MATRIX
	IF(ISPIN.NE.0)THEN
	IF(LTPAN(L,IATOM,IKAP,IPAN))
     &  DOMAT(IBAND1,IBAND)=DOMAT(IBAND1,IBAND)+
     &  CONJG(APHQ(LM,IATOM,IKAP,IORBS1,IBAND1))*DOA(LM,IATOM,IKAP) 
	DOMAT(IBAND1,IBAND)=DOMAT(IBAND1,IBAND)+
     &  CONJG(APJQ(LM,IATOM,IKAP,IORBS1,IBAND1))*DOS(LM,IATOM,IKAP)
	ENDIF
        ENDDO                                     !!! over m
        ENDDO                                     !!! over l
        ENDDO                                     !!! over atoms
        ENDDO                                     !!! over energies
1000    CONTINUE                                  !!! over all bands
2000    CONTINUE                                  !!! over spin subbands
3000    CONTINUE                                  !!! over all bands
4000    CONTINUE                                  !!! over spin subbands
5000	CONTINUE                                  !!! over spinors
6000	CONTINUE                                  !!! over spinors
	END
