	SUBROUTINE SDELPOT(IQPNT,ITER)
************************************************************
*   The calculation of the change in the potential         *
*   and exchange-correlation magentic field.               *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,ILSV(NSORTMAX),NITER(0:NENVMAX,-1:2)
	DIMENSION QPNT(3)
	LOGICAL EXIST
	CHARACTER TXTEL(NSORTMAX)*10
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPFR,MODE        !!! from readini
        COMMON /MAGCOM/ ITERMAX,NITER                        !!! from qvector
	COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ                       !!! from readlrt
        COMMON /PTBCOM/ NGSHL,NGPTB                          !!! from qvector
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from readini
	COMMON /QMESH/  NQPNT,QPNT                           !!! from qvector
        COMMON /SPIN/   NSPIN                                !!! from readini
        COMMON /TXTEL/  TXTEL                                !!! from readini
	COMMON /UNIT/   IUN                                  !!! from readini
	CALL READSCF                        !!! reads charge density
C  SET FULL POTENTIAL
        CALL VCOUL                          !!! Coulomb potential within MTS
        CALL VEXCH(1)                       !!! ex.-cor.potential within MTS
        CALL VCFTR                          !!! Coulomb potential in the INT
        CALL VXFTR(1)                       !!! ex.-cor.potential in the INT
        CALL ZEROV                          !!! set up energy zero
        CALL VPINT                          !!! convolutions of pseudopotential
C  DO GLOBALLY OVER POLARIZATIONS
	DO 2000 MY=-1,2                     !!! over polarizations
	DO 1000 IGPTB=0,NGPTB               !!! over g-vectors
        IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C  INITIALIZE FILES WITH THE POTENTIAL
        CALL DSVFILES(IGPTB,MY,IQPNT,36,'I')!!! store change in the potential
        CALL DPVFILES(IGPTB,MY,IQPNT,37,'I')!!! store change in pseudopotential
C  SET UP EXTERNAL PERTURBATION
	CALL DELVEXTR(IGPTB,MY,IQPNT)       !!! Vext(r)=exp(iqr)
	CALL DELBEXTR(IGPTB,MY,IQPNT)       !!! Bext(r)=Wxc(r)*exp(iqr)
C  READ CHANGE IN CHARGE DENSITY
        CALL DROFILES(IGPTB,MY,IQPNT,33,'R')!!! read change in density 
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'R')!!! read pseudocharge density
C  CALCULATE CHANGE IN THE FULL POTENTIAL
   	CALL DMULTRHO(IGPTB,MY,IQPNT)       !!! change in pseudodensity moments
   	CALL DMULTFTR(IGPTB,MY,IQPNT,1)     !!! change in multipoles
   	CALL DELVCOUL(IGPTB,MY,IQPNT)       !!! change in Coulomb potential in MTS
   	CALL DELVEXCH(IGPTB,MY,IQPNT,1)     !!! change in XC-potential in MTS
   	CALL DELBEXCH(IGPTB,MY,IQPNT,1)     !!! change in XC-magnetic field   
   	CALL DELVCFTR(IGPTB,MY,IQPNT,1)     !!! change in Coulomb potential in INT
   	CALL DELVXFTR(IGPTB,MY,IQPNT,1)     !!! change in XC-potential in INT
   	CALL DELBXFTR(IGPTB,MY,IQPNT,1)     !!! change in XC-magnetic field
CCC   	CALL DELVSCRN(IGPTB,MY,IQPNT)       !!! add screened long range if MODE=4,5
   	CALL DELVZERO(IGPTB,MY,IQPNT)       !!! change in MT-zero 
   	CALL DELVPINT(IGPTB,MY,IQPNT)       !!! set convolutions 
C  STORE CHANGE IN THE POTENTIAL 
   	CALL PRINT3  (IGPTB,MY,IQPNT,ITER)  !!! print values
        CALL DSVFILES(IGPTB,MY,IQPNT,36,'W')!!! store change in the potential
        CALL DPVFILES(IGPTB,MY,IQPNT,37,'W')!!! store change in pseudopotential
C  COMPUTE HUBBARD CORRECTIONS
   	CALL DELVHUBB(IGPTB,MY,IQPNT)       !!! change in Hubbard potential
   	CALL DELBHUBB(IGPTB,MY,IQPNT)       !!! change in Hubbard potential
1000	CONTINUE                            !!! over g-vectors
2000	CONTINUE                            !!! over polarizations
	END
