	SUBROUTINE DINTMAT(IGPTB,MY,IPNT,ISGQ,IPAN,IQPNT)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  change in the hamiltonian and overlap matrix using     *
*  fourier transform.                                     * 
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX),MVECR(3)
        INTEGER INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
	COMPLEX*16 EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX)
     &    ,DPOTPS(0:NPLWMAX,NSPINMAX),DBXCPS(0:NPLWMAX,NSPINMAX)
     &    ,DPOTIN(0:NPLWMAX,NSPINMAX),DBXCIN(0:NPLWMAX,NSPINMAX)
     &    ,DHMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,DOMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX)
     &    ,PSIK(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,PSIQ(0:NBASMAX,NORBSMAX,NDIMMAX*NSPINMAX)
     &    ,CONV(0:NPLWMAX),CHIS(0:NBASMAX),DELVT
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTK(3),PNTQ(3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
        COMMON /ORBS/   NORBS                                !!! from init
        COMMON /SPIN/   NSPIN                                !!! from init
C Inputs:
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
C Potential:
        COMMON /DPSVCOM/DPOTPS,DBXCPS,DPOTIN,DBXCIN          !!! from dvpint
C Temporary:
        COMMON /STORE2/ DHMAT,DOMAT                          !!! from dintmat
        COMMON /DELRO/  PSIK,PSIQ,PNTK,PNTQ                  !!! from psivec
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG      !!! from plwmsh
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
C Outputs:
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
        IF(IPAN.NE.1)RETURN
C *** DO GLOBALLY OVER BANDS ***
        IF(MODE.NE.5)IBNDMIN=1
        IF(MODE.NE.5)IBNDMAX=NBNDT(IPAN)
        IF(MODE.EQ.5)IBNDMIN=NBNDE(IPAN)
        IF(MODE.EQ.5)IBNDMAX=NBNDF(IPAN)
C ***** DO GLOBALLY OVER SPINORS ********
        DO 6000 IUPDN1=1,NSPIN                    !!! over spinors
        IF(NORBS.EQ.2)IORBS1=IUPDN1
        IF(NORBS.EQ.1)IORBS1=1
        DO 5000 IUPDN =1,NSPIN                    !!! over spinors
        IF(NORBS.EQ.2)IORBS=IUPDN
        IF(NORBS.EQ.1)IORBS=1
C SET LONGITUDINAL AND TRANSVERSE COMPONENTS
            IF(IUPDN1.EQ.1.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
        ISPIN=1
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)GOTO5000
        ISPIN=2
        ITRAN=0
        SIGNF=1.D0
        ELSEIF(IUPDN1.EQ.1.AND.IUPDN.EQ.2)THEN
        IF(NORBS.EQ.1.AND.MY.NE.+1)GOTO5000
        ISPIN=0
        ITRAN=2
        SIGNF=-SQRT(2.D0)
        ELSEIF(IUPDN1.EQ.2.AND.IUPDN.EQ.1)THEN
        IF(NORBS.EQ.1.AND.MY.NE.-1)GOTO5000
        ISPIN=0
        ITRAN=1
        SIGNF=+SQRT(2.D0)
        ENDIF
	DO 4000 IBNDS1=1,NSPIN                    !!! over spin subbands
        IF(NORBS.EQ.1.AND.IUPDN1.NE.IBNDS1)GOTO4000
        DO 3000 IBNDT1=IBNDMIN,IBNDMAX            !!! over all bands
	IBAND1=IBNDS1+NSPIN*(IBNDT1-1)
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
        DO IBAS=0,MIN(NBAS,MBAS)
        CHIS(IBAS)=DCONJG(PSIQ(IBAS,IORBS1,IBAND1))
        ENDDO
	IF(ISPIN.NE.0)
     &  CALL CONVOL1(DPOTIN(0,ISPIN),CHIS(0),CONV(0),'L',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
	IF(ITRAN.NE.0)
     &  CALL CONVOL1(DBXCIN(0,ITRAN),CHIS(0),CONV(0),'L',
     &               0,MIN(NBAS,MBAS),0,MIN(NBAS,MBAS))
C *** DO GLOBALLY OVER BANDS ***
	DO 2000 IBNDS=1,NSPIN                     !!! over spin subbands
        IF(NORBS.EQ.1.AND.IUPDN.NE.IBNDS)GOTO2000
        DO 1000 IBNDT=IBNDMIN,IBNDMAX             !!! over all bands
	IBAND=IBNDS+NSPIN*(IBNDT-1)
C  CHANGE IN PSEUDPOTENTIAL MATRIX ELEMENTS
	DELVT=(0.D0,0.D0)
	DO IBAS=0,MIN(NBAS,MBAS)                  !!! over plane waves
	DELVT=DELVT+CONV(IBAS)*PSIK(IBAS,IORBS,IBAND)
        ENDDO                                     !!! over plane waves
	DHMAT(IBAND1,IBAND)=DHMAT(IBAND1,IBAND)+
     &  DELVT*SIGNF
1000    CONTINUE                                  !!! over all bands
2000    CONTINUE                                  !!! over spin subbands
3000    CONTINUE                                  !!! over all bands
4000    CONTINUE                                  !!! over spin subbands
5000    CONTINUE                                  !!! over spinors
6000    CONTINUE                                  !!! over spinors
	END
