	SUBROUTINE DMULTFTR(IGPTB,MY,IQPNT,ISCR)
*************************************************************
* Calculate induced multipoles as reciprocal lattice sums.  * 
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,LMSYM(LMMAXV,NPAT),INDZPTB(NENVMAX)
	COMPLEX*16 GAUS(0:LMAXV,NPAT),YLM(LMMAXV),EXPT
     &    ,DRHOPS(0:NPLWMAX,NSPINMAX),DRHOPS1(0:NPLWMAX,NSPINMAX)
     &    ,DPSMOM1(LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DPSMOM (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELMAD (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,DELMRO (LMMAXV,NPAT,NSPINMAX,0:NENVMAX,-1:2)
     &    ,COUINT,DMAGPS(0:NPLWMAX,NSPINMAX)
	DIMENSION SMT(NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &    ,BET(0:LMAXV,NSORTMAX),GPLW(3,0:NPLWMAX),BES(-1:LMAXV)
     &    ,COFL(0:LMAXV,NSORTMAX),ORTH(2:3),TAU(3,NPAT)
     &    ,BESD(0:LMAXV),QPNT(3),QPTB(3,NENVMAX)
	LOGICAL SYM(LMMAXV,NPAT)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE     !!! from readini
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from readini
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ,NZPTB,QPTB,INDZPTB!!! from readini
	COMMON /SPIN/   NSPIN                            !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /BASIS/  TAU                              !!! from readstr
	COMMON /QMESH/  NQPNT,QPNT                       !!! from qvector
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from readini
	COMMON /MULTRO/ Z,ZCOR                           !!! from multrho
	COMMON /SYMMLM/ SYM,LMSYM                        !!! from symmlm 
C Density:
	COMMON /DPSRHO/ DRHOPS,DMAGPS,DRHOPS1            !!! from vcftr
        COMMON /DROMULT/DELMRO,DPSMOM,DPSMOM1,DELMAD     !!! from dmultrho
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW                        !!! from plwmsh
	COMMON /BETPAR/ BET                              !!! from multro
C Outputs:
	COMMON /WORD/   NVAL                             !!! from setup
	DATA PI/3.141592653589793D0/
	LMM=0
	DO ISPIN=1,NSPIN
	DO IATOM=1,NATOM
	ISORT=IS(IATOM)
	LMM=MAX(LMM,ILSV(ISORT))
	DO L=0,ILSV(ISORT)
	COFL(L,ISORT)=4.D0*PI/OMEGAC*SMT(ISORT)**(L+1)/FAC2(2*L-1)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DELMAD(LM,IATOM,ISPIN,IGPTB,MY)=(0.D0,0.D0)
        ENDDO     
        ENDDO     
        ENDDO     
        ENDDO     
C  CALCULATE AUXILARY CHARGE DENSITY IN FOURIER REPRESENTATION
C  ALSO CALCULATE CHANGE IN MULTIPOLE CHARGE 
	DO 1000 IPLW=0,NPLW                  !!! over plane waves
	GX=(QPNT(1)+GPLW(1,IPLW))*2.D0*PI/PAR
	GY=(QPNT(2)+GPLW(2,IPLW))*2.D0*PI/PAR
	GZ=(QPNT(3)+GPLW(3,IPLW))*2.D0*PI/PAR
	AG=SQRT(GX**2+GY**2+GZ**2)
	AG2=AG*AG
C  SET SPHERICAL HARMONICS
	IF(AG.GE.1.D-10)THEN
	CALL SPHHARM(GX/AG,GY/AG,GZ/AG,LMM,YLM)
	ELSE
	YLM(1)=1.D0/SQRT(4.D0*PI)
	DO LM=2,(LMM+1)**2
	YLM(LM)=(0.D0,0.D0)
        ENDDO     
	ENDIF
C  SET AUXILARY PSEUDODENSITY DRHOPS1
	DO ISPIN=1,NSPIN                     !!! over spins
	DRHOPS1(IPLW,ISPIN)=(0.D0,0.D0)
	DO IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	SCP=(QPNT(1)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &      (QPNT(2)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &      (QPNT(3)+GPLW(3,IPLW))*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO L=0,ILSV(ISORT)
	IF(L.EQ.0)AGL=1.D0
	IF(L.NE.0)AGL=AG**L
	EXPG=EXP(-0.25D0*AG**2/BET(L,ISORT)**2)
	GAUS(L,IATOM)=COFL(L,ISORT)*EXPT*AGL*EXPG
	DO M=-L,L
	LM=L*(L+1)+M+1
	ISYM=LMSYM(LM,IATOM)
	DRHOPS1(IPLW,ISPIN)=DRHOPS1(IPLW,ISPIN)+
     &  GAUS(L,IATOM)*YLM(LM)*DPSMOM1(LM,IATOM,ISPIN,IGPTB,MY)
        ENDDO     
        ENDDO     
        ENDDO                                !!! over atoms
        ENDDO                                !!! over spins
	IF(AG.GE.1.D-10)COUINT=4.D0*PI/AG**2
	IF(AG.LT.1.D-10)COUINT=(0.D0,0.D0)
C  SET SCREENING
	DO IZPTB=1,NZPTB
	IF(ISCR.EQ.1.AND.LPLZ.GT.0.AND.IPLW.EQ.INDZPTB(IZPTB))
     &  COUINT=(0.D0,0.D0)
        ENDDO     
C  SET MULTIPOLE CHARGE DUE TO CHANGE IN PSRHO AND PSRHO1
	DO IATOM=1,NATOM                     !!! over atoms
	ISORT=IS(IATOM)
	CALL BESSR(AG*SMT(ISORT),BES(0),BESD(0),ILSV(ISORT))
        DO L=0,ILSV(ISORT)
        BES(L)=BES(L)*AG*SMT(ISORT)
        ENDDO     
        BES(-1)=COS(AG*SMT(ISORT))
	SCP=(QPNT(1)+GPLW(1,IPLW))*TAU(1,IATOM)+
     &      (QPNT(2)+GPLW(2,IPLW))*TAU(2,IATOM)+
     &      (QPNT(3)+GPLW(3,IPLW))*TAU(3,IATOM)
	EXPT=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
	DO ISPIN=1,NSPIN                     !!! over spins
	DO L=0,ILSV(ISORT)
	DO M=-L,L
	LM=L*(L+1)+M+1
	DELMAD(LM,IATOM,ISPIN,IGPTB,MY)=
     &  DELMAD(LM,IATOM,ISPIN,IGPTB,MY)+
     &  COUINT*DRHOPS(IPLW,ISPIN)/DBLE(2*L+1)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))*BES(L-1)
	DELMAD(LM,IATOM,ISPIN,IGPTB,MY)=
     &  DELMAD(LM,IATOM,ISPIN,IGPTB,MY)+
     &  COUINT*DRHOPS1(IPLW,ISPIN)/DBLE(2*L+1)*
     &  4.D0*PI*DCONJG(EXPT*YLM(LM))*BES(L-1)
        ENDDO     
        ENDDO     
        ENDDO                                !!! over spins
        ENDDO                                !!! over atoms
1000    CONTINUE                             !!! over plane waves
	END
