	SUBROUTINE DSTR(XK,YK,ZK,ILS2,ILD2,NE,E,FIRST,
     &  NLPMAX,NLDMAX,NKPMAX,SIGMA,SIGMADOT)
********************************************************************
*    Subroutine calculates Sigma-structure constants for           *
*    different values of energy E                                  *
*                                                                  *
*      k       _  ikR              l *                             *
* Sigma  (E)=K > e   H (K|R-T|)(-i) Y (R-T)  ; E=K*K ; T-basis     *
*      LT      -      l              L                             *
*              R                                                   *
*   as well as their energy derivatives                            *
*   Method: Evald's summation for lower l, direct summation for    *
*   higher l.                                                      *
*   Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)      *
*   Last Revision: 17.02.93                                        *
********************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+3)**2,NDTMAX=NPAT*NPAT)
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,ILS2(NDTMAX),ILD2(NDTMAX),LIMLPL(NDTMAX),IS(NPAT)
     &   ,LIMLDL(NDTMAX)
	COMPLEX*16 SIGMA(NLPMAX,NDTMAX,NKPMAX),SIGMA3(NKAPMAX)
     &   ,SIGMADOT(NLDMAX,NDTMAX,NKPMAX),KAP,SIGMA4(NKAPMAX)
     &   ,CCOF(0:2*LMAXV+2,NKAPMAX,2),SIGM4DOT(NKAPMAX),ERFUN
     &   ,SIGM3DOT(NKAPMAX),COEF,COEFDOT,EXPKR,EXPGD,DIMUNIT
     &   ,ERFL(-1:2*LMAXV+2,NKAPMAX),GKCOF(0:2*LMAXV+2),SUM,T
     &   ,E(NKAPMAX),EN(NKAPMAX),GKCOFDOT(0:2*LMAXV+2),CWERF
     &   ,YLG(LPLMAX),YLD(LPLMAX),HAN(3,0:2*LMAXV+2),YY(LPLMAX)
	DIMENSION RBAS(3,3),GBAS(3,3),RVEC(3,NVCMAX),GVEC(3,NVCMAX)
     &   ,SVEC(3,NVCMAX),DELTAU(3,NDTMAX),GL(3),BETT(LPLMAX)
	LOGICAL FIRST
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM         !!! from init
	COMMON /LATTICE/ RBAS,GBAS                             !!! from init
	COMMON /VECGEN/  LIMDT,DELTAU,NRVEC,RVEC,NGVEC,GVEC,ETA
     &                  ,NSVEC,SVEC                            !!! from vecgen
	COMMON /WORD/    NVAL                                  !!! from block
	COMMON /UNIT/    IUN                                   !!! from init
	SAVE FACS,SIGMA3,SIGM3DOT,SIGMA4,SIGM4DOT,EN,CCOF,SWZ,ILS2MAX
     &   ,LIMLPL,LIMLDL,LMCUT,BETT,IE0
	DATA PI/3.141592653589793D0/,DIMUNIT/(0.D0,1.D0)/,LCUT/50/
	SQPI4=SQRT(4.D0*PI)
	IF(FIRST)THEN  !!! set k-independent variables
C  CALCULATE K-INDEPENDENT VALUES
	CALL CROSS(GL,RBAS(1,2),RBAS(1,3))
	OMEGA=ABS(RBAS(1,1)*GL(1)+RBAS(2,1)*GL(2)+RBAS(3,1)*GL(3)) 
	RMAXR=(3.D0*DBLE(NRVEC)*OMEGA/4.D0/PI)**(1.D0/3.D0)
	RMAXG=(3.D0*DBLE(NGVEC)/OMEGA/4.D0/PI)**(1.D0/3.D0)*2.D0*PI
	LMCUT=(LCUT+1)**2
	ILS2MAX=0
	DO 1 ITAU=1,LIMDT
	LIMLPL(ITAU)=(ILS2(ITAU)+1)**2
	LIMLDL(ITAU)=(ILD2(ITAU)+1)**2
	IF(LIMLDL(ITAU).GT.LMCUT)STOP'<DSTR>: Lmax in S-DOT is too high'
	ILS2MAX=MAX(ILS2MAX,ILS2(ITAU))
   1    CONTINUE
	CALL CNSBET(2*LMAXV+2,BETT)
	SWZ=(3.D0/(4.D0*PI)*OMEGA/NATOM)**(1.D0/3.D0) !!! WZ-radius
	IE0=0
	DO 10 IEN=1,NE
	EN(IEN)=E(IEN)
	IF(EN(IEN).EQ.0.D0)IE0=IEN
  10    CONTINUE
	DO 30 IEN=1,NE  !! struct.independ. coeff. in Evald procedure
	DL=1.D0
	DO 20 L=0,ILS2MAX
	SWZL=SWZ**(L+1)
	CCOF(L,IEN,1)=8.D0*PI*SQRT(PI)*SWZL*EXP(0.25D0*EN(IEN)/
     &  ETA/ETA)/OMEGA/DL
	CCOF(L,IEN,2)=4.D0*(-2.D0*DIMUNIT)**L*EXP(0.25D0*EN(IEN)/
     &  ETA/ETA)*SWZL/DL
	DL=DL*(2.D0*L+1.D0) !! double factorial
  20    CONTINUE
  30    CONTINUE
C  CALCULATE THIRD CONTRIBUTION TO SIGMA_CONSTANTS
	DO 60 IEN=1,NE  
	IF(DREAL(EN(IEN)).GE.0.D0)KAP=+SQRT(EN(IEN))/2.D0/ETA
	IF(DREAL(EN(IEN)).LT.0.D0)KAP=-SQRT(EN(IEN))/2.D0/ETA
	IF(ABS(KAP).LT.1.D0)THEN ! Teilor series
	SUM=-1.D0
	FACT=1.D0
	DO 40 N=1,30000
	FACT=FACT/DBLE(N)
	T=(EN(IEN)/ETA/ETA*0.25D0)**N*FACT/DBLE(2*N-1)
	SUM=T+SUM
	IF(ABS(T/SUM).LE.1.D-10)GOTO50
  40    CONTINUE
	PRINT*,'<DSTR>: NO CONVERGENCY IN SIGMA3',T
  50    SIGMA3(IEN)=2.D0*ETA*SWZ/SQRT(PI)*SUM
	ELSEIF(ABS(KAP).GE.1.D0)THEN ! Direct expressions
	ERFUN=1.D0-EXP(EN(IEN)/ETA/ETA*0.25D0)*CWERF(-KAP)
	SUM=-DIMUNIT*KAP*SQRT(PI)*ERFUN-EXP(EN(IEN)/ETA/ETA*0.25D0)
	SIGMA3(IEN)=2.D0*ETA*SWZ/SQRT(PI)*SUM
	ENDIF
	KAP=SQRT(EN(IEN))
	IF(DREAL(EN(IEN)).LT.0.D0)
     &  SIGMA3(IEN)=SIGMA3(IEN)-DIMUNIT*SWZ*KAP
  60    CONTINUE
C  CALCULATE THIRD CONTRIBUTION TO SIGMA_DOT BY TEILOR SERIES
	DO 85 IEN=1,NE   
	IF(DREAL(EN(IEN)).GE.0.D0)KAP=+SQRT(EN(IEN))/2.D0/ETA
	IF(DREAL(EN(IEN)).LT.0.D0)KAP=-SQRT(EN(IEN))/2.D0/ETA
	IF(ABS(KAP).LT.1.D0)THEN ! Teilor series
	SUM=1.D0
	FACT=1.D0
	DO 70 N=1,30000  !!  case if en(1).ne.0
	FACT=FACT/DBLE(N)
	T=(EN(IEN)/ETA/ETA*0.25D0)**N*FACT/DBLE(2*N+1)
	SUM=T+SUM
	IF(ABS(T/SUM).LE.1.D-10)GOTO80
  70    CONTINUE
	PRINT*,'<DSTR>: NO CONVERGENCY IN SIGMA3-DOT',T
  80    SIGM3DOT(IEN)=0.5D0/ETA/SWZ/SQRT(PI)*SUM
	ELSEIF(ABS(KAP).GE.1.D0)THEN ! Direct formulas
	ERFUN=1.D0-EXP(EN(IEN)/ETA/ETA*0.25D0)*CWERF(-KAP)
	SUM=-DIMUNIT/KAP*SQRT(PI)*ERFUN/2.D0
	SIGM3DOT(IEN)=0.5D0/ETA/SWZ/SQRT(PI)*SUM
	ENDIF
	KAP=SQRT(EN(IEN))
	IF(DREAL(EN(IEN)).LT.0.D0)
     &  SIGM3DOT(IEN)=SIGM3DOT(IEN)-0.5D0*DIMUNIT/SWZ/KAP
  85    CONTINUE
C   CALCULATE FOURTH CONTRIBUTION TO SIGMA WHEN K=0
	DO 90 IEN=1,NE
	IF(DREAL(EN(IEN)).NE.0.D0)THEN
	SIGMA4(IEN)=-3.D0/SWZ/SWZ/NATOM/EN(IEN)*EXP(0.25D0*EN(IEN)/
     &  ETA/ETA)
	SIGM4DOT(IEN)=SIGMA4(IEN)/SWZ/SWZ*(0.25D0/ETA/ETA-
     &  1.D0/EN(IEN))
	ELSEIF(ABS(EN(IEN)).EQ.0.D0)THEN
	SIGMA4(IE0)=-0.75D0/NATOM/ETA/SWZ/ETA/SWZ 
	SIGM4DOT(IEN)=(0.D0,0.D0)                       ! no Sdot
	ENDIF
  90    CONTINUE
	FACS=0.25D0/SWZ/SWZ/ETA/ETA
	ENDIF
C  REDUCE K-VECTOR
	CALL REDUC2(XK,YK,ZK,NGVEC,GVEC,XKR,YKR,ZKR,GRX,GRY,GRZ)
	DO 120 IEN=1,NE
	DO 110 ITAU=1,LIMDT
	DO 100 LM=1,LIMLPL(ITAU)
	SIGMA(LM,ITAU,IEN)=(0.D0,0.D0)
	IF(LM.LE.LIMLDL(ITAU))SIGMADOT(LM,ITAU,IEN)=(0.D0,0.D0)
 100    CONTINUE
 110    CONTINUE
 120    CONTINUE
C ***  RECIPROCAL LATTICE SUMMATION (EVALD PROCEDURE) ***
	DO 170 IGVEC=1,NGVEC               !!! over vectors 
	GKX=(GVEC(1,IGVEC)+XKR)*2.D0*PI
	GKY=(GVEC(2,IGVEC)+YKR)*2.D0*PI
	GKZ=(GVEC(3,IGVEC)+ZKR)*2.D0*PI
	GK2=GKX*GKX+GKY*GKY+GKZ*GKZ
	GK=SQRT(GK2)
	IF(GK2.EQ.0.D0)GOTO170             !!! means that k.ne.0 and g.ne.0
	EXPKPG=EXP(-0.25D0*GK2/ETA/ETA)
	IF(EXPKPG.EQ.0.D0)GOTO170       
	CALL SPHHARM(GKX/GK,GKY/GK,GKZ/GK,MIN(ILS2MAX,LCUT),YY) ! sph. harmonics
	DO 160 IEN=1,NE                    !!! over energies
	GKL=1.D0
	COEF=EXPKPG/(GK2-EN(IEN))
	COEFDOT=COEF*(0.25D0/ETA/ETA+1.D0/(GK2-EN(IEN)))/SWZ/SWZ
	DO 130 L=0,MIN(ILS2MAX,LCUT)
	L0=L*(L+1)+1
	GKCOF(L)=GKL*CCOF(L,IEN,1)*COEF
	GKCOFDOT(L)=GKL*CCOF(L,IEN,1)*COEFDOT
	GKL=GKL*GK
	YLG(L0)=DCONJG(YY(L0))*GKCOF(L)
	YLD(L0)=DCONJG(YY(L0))*GKCOFDOT(L)
	DO 130 M=1,L
	LM =L0+M
	LMM=L0-M
	YLG(LM )=GKCOF(L)*DCONJG(YY(LM))
	YLG(LMM)=GKCOF(L)*DCONJG(YY(LMM))
	YLD(LM )=GKCOFDOT(L)*DCONJG(YY(LM))
	YLD(LMM)=GKCOFDOT(L)*DCONJG(YY(LMM))
 130    CONTINUE
C    CALCULATE SIGMA AND SIGMADOT
	DO 150 ITAU=1,LIMDT                !!! over basis: tau'-tau
	EXPGD=EXP(DIMUNIT*(GKX*DELTAU(1,ITAU)+GKY*DELTAU(2,ITAU)+
     &  GKZ*DELTAU(3,ITAU)))
	DO 140 LM=1,MIN(LIMLPL(ITAU),LMCUT)!!! over l
	SIGMA(LM,ITAU,IEN)=SIGMA(LM,ITAU,IEN)+EXPGD*YLG(LM)
 140    CONTINUE
	DO 145 LM=1,LIMLDL(ITAU)           !!! over l
	SIGMADOT(LM,ITAU,IEN)=SIGMADOT(LM,ITAU,IEN)+EXPGD*YLD(LM)
 145    CONTINUE
 150    CONTINUE                           !!! over basis
 160    CONTINUE                           !!! over energies
 170    CONTINUE                           !!! over vectors 
C **** DIRECT LATTICE SUMMATION  *****
	DO 270 ITAU=1,LIMDT                !!! over basis:tau'-tau
	CALL REDUC2(DELTAU(1,ITAU),DELTAU(2,ITAU),DELTAU(3,ITAU),
     &  NRVEC,RVEC,DX,DY,DZ,R0X,R0Y,R0Z)
C   CALCULATE SIGMA_CONSTANTS USING EVALD'S PROCEDURE
	DO 260 ISVEC=1,NSVEC               !!! over vectors 
	IF(ILS2(ITAU).LE.LCUT.AND.ISVEC.GT.NRVEC)GOTO270
	RX=SVEC(1,ISVEC)
	RY=SVEC(2,ISVEC)
	RZ=SVEC(3,ISVEC)
	EXPKR=EXP(((RX-R0X)*XK+(RY-R0Y)*YK+(RZ-R0Z)*ZK)*2.D0*PI*
     &  DIMUNIT)
	DRX=RX-DX
	DRY=RY-DY
	DRZ=RZ-DZ
	DR=SQRT(DRX*DRX+DRY*DRY+DRZ*DRZ)
	IF(ABS(DR).LE.1.D-12)GOTO260       !!! i.e only when R+tau-tau'.ne.0
	CALL SPHHARM(DRX/DR,DRY/DR,DRZ/DR,ILS2(ITAU),YY) ! sph. harm.
	IF(ISVEC.GT.NRVEC)GOTO220
	EXPDLT=EXP(-DR*DR*ETA*ETA)
	IF(EXPDLT.EQ.0.D0)GOTO220
	DO 210 IEN=1,NE                    !!! over energies
	CALL SERFLL(ERFL(-1,IEN),MIN(ILS2(ITAU),LCUT),ETA,DR,EN(IEN))!err.fun.
	DRL=1.D0
	DO 200 L=0,MIN(ILS2(ITAU),LCUT)    !!! over l
	T=DRL*CCOF(L,IEN,2)*EXPKR*EXPDLT
	COEF=T*ERFL(L,IEN)
	COEFDOT=T*ERFL(L-1,IEN)*FACS
	DRL=DRL*DR*ETA*ETA
	L0=L*(L+1)+1
	SIGMA(L0,ITAU,IEN)=SIGMA(L0,ITAU,IEN)+COEF*DCONJG(YY(L0))
	IF(L.LE.ILD2(ITAU))SIGMADOT(L0,ITAU,IEN)=
     &  SIGMADOT(L0,ITAU,IEN)+COEFDOT*DCONJG(YY(L0))
	DO 190 M=1,L                       !!! over m
	LM =L0+M
	LMM=L0-M
	SIGMA(LM ,ITAU,IEN)=SIGMA(LM ,ITAU,IEN)+COEF*
     &  DCONJG(YY(LM))
	SIGMA(LMM,ITAU,IEN)=SIGMA(LMM,ITAU,IEN)+COEF*
     &  DCONJG(YY(LMM))
	IF(L.LE.ILD2(ITAU))THEN
	SIGMADOT(LM ,ITAU,IEN)=SIGMADOT(LM ,ITAU,IEN)+COEFDOT*
     &  DCONJG(YY(LM))
	SIGMADOT(LMM,ITAU,IEN)=SIGMADOT(LMM,ITAU,IEN)+COEFDOT*
     &  DCONJG(YY(LMM))
	ENDIF
 190    CONTINUE                           !!! over m
 200    CONTINUE                           !!! over l
 210    CONTINUE                           !!! over energies
 220    IF(ILS2(ITAU).LE.LCUT)GOTO260
C  CALCULATE SIGMA CONSTANTS USING REAL SPACE FORMULAS
	DO 250 IEN=1,NE                             !!! over energies
	CALL HANKEL(DR,EN(IEN),SWZ,HAN,ILS2(ITAU))
	DO 240 L=LCUT+1,ILS2(ITAU)                  !!! over l
	L0=L*(L+1)+1
	COEF=EXPKR*SQPI4*(-DIMUNIT)**L*HAN(1,L)
	SIGMA(L0,ITAU,IEN)=SIGMA(L0,ITAU,IEN)+COEF*DCONJG(YY(L0))
	DO 230 M=1,L                                !!! over m
	LM =L0+M
	LMM=L0-M
	SIGMA(LM,ITAU,IEN)=SIGMA(LM,ITAU,IEN)+COEF*
     &  DCONJG(YY(LM))
	SIGMA(LMM,ITAU,IEN)=SIGMA(LMM,ITAU,IEN)+COEF*
     &  DCONJG(YY(LMM))
 230    CONTINUE                                   !!! over m
 240    CONTINUE                                   !!! over l
 250    CONTINUE                                   !!! over energies
 260    CONTINUE                                   !!! over vectors
 270    CONTINUE                                   !!! over basis
C************* THE END OF COMPUTING SIGMA_CONSTANTS *************
	DO 300 IEN=1,NE                    !!! normalization
	DO 290 ITAU=1,LIMDT
	IF(DELTAU(1,ITAU)**2+DELTAU(2,ITAU)**2+
     &  DELTAU(3,ITAU)**2.LE.1.D-10)THEN
	SIGMA(1,ITAU,IEN)=SIGMA(1,ITAU,IEN)+SIGMA3(IEN)
	IF(ILD2(ITAU).GE.0)
     &  SIGMADOT(1,ITAU,IEN)=SIGMADOT(1,ITAU,IEN)+SIGM3DOT(IEN)
	ENDIF
	IF(ABS(XKR).LE.1.D-10.AND.ABS(YKR).LE.1.D-10.
     &  AND.ABS(ZKR).LE.1.D-10)THEN  !!! k=0 case
	SIGMA(1,ITAU,IEN)=SIGMA(1,ITAU,IEN)+SIGMA4(IEN)
	IF(ILD2(ITAU).GE.0)
     &  SIGMADOT(1,ITAU,IEN)=SIGMADOT(1,ITAU,IEN)+SIGM4DOT(IEN)
	ENDIF
 290    CONTINUE
 300    CONTINUE
	END






	SUBROUTINE FNDETA(A,X)
*************************************************************
*  Finds E-factor in front of optimal Evald splitting.      *
*  Not used since 27.11.92                                  *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	COMPLEX*16 E1,E2,U,V,D,X1,X2,X3
C  NO OPTIMIZATION FOR NEGATIVE ENERGIES
	IF(A.LE.0.D0)THEN
	X=1.D0
C  FIND FACTOR X FOR POSITIVE ENERGIES BY SOLVING: X^3=X+A
C  (SEE BRONSHTEIN, SEMENDJAEV, MOSKVA, <<NAUKA>> 1965, P.139)
	ELSEIF(A.GT.0.D0)THEN   
	E1=DCMPLX(-0.5D0,+SQRT(3.D0)/2.D0)
	E2=DCMPLX(-0.5D0,-SQRT(3.D0)/2.D0)
	P=-1.D0/3.D0
	Q=-A/2.D0
	D=DCMPLX(Q**2+P**3,0.D0)
	U=(-Q+SQRT(D))**(1.D0/3.D0)
	V=(-Q-SQRT(D))**(1.D0/3.D0)
	X1=U+V         ! first root
	X2=E1*U+E2*V   ! second root
	X3=E2*U+E1*V   ! third root
	X=0.D0
	IF(DREAL(X1).GE.1.D0.AND.ABS(DIMAG(X1)).LE.1.D-10)X=DREAL(X1)
	IF(DREAL(X2).GE.1.D0.AND.ABS(DIMAG(X2)).LE.1.D-10)X=DREAL(X1)
	IF(DREAL(X3).GE.1.D0.AND.ABS(DIMAG(X3)).LE.1.D-10)X=DREAL(X1)
	IF(X.EQ.0.D0)STOP'<FNDETA>: NO ROOT FOUND'
	ENDIF
	END

