	SUBROUTINE DELVXFTR(IGPTB,MY,IQPNT,KEY)
*************************************************************
* Calculates change in exchange-correlation pseudopotential *
* Generalized gradient corrections after Perdew et.al added *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3),MDIV(3)
     &    ,MF(3)
	COMPLEX*16 DPOTPS(0:NPLWMAX,NSPINMAX)
     &    ,RHOPS(0:NPLWMAX,NSPINMAX),DRHOPS(0:NPLWMAX,NSPINMAX)
     &    ,RHORS(NFFTMAX,NSPINMAX),DRHORS(NFFTMAX,NSPINMAX)
     &    ,G1RHO(NFFTMAX,NSPINMAX,NGGAMAX)
     &    ,G2RHO(NFFTMAX,NSPINMAX,NGGAMAX,NGGAMAX)
     &    ,GR1UP(3),GR2UP(3,3),GR1DN(3),GR2DN(3,3)
     &    ,DG1RHO(NFFTMAX,NSPINMAX,NGGAMAX),DXC
     &    ,DG2RHO(NFFTMAX,NSPINMAX,NGGAMAX,NGGAMAX)
     &    ,DVXCRS(NFFTMAX,NSPINMAX),TMPARR(NFFTMAX)
     &    ,GEXCUP(3),GVXCUP(3),DVXC2UP(3,3)
     &    ,GEXCDN(3),GVXCDN(3),DVXC2DN(3,3)
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3),QGAM(3)
     &    ,RBAS(3,3),GBAS(3,3),AD(3,3),RD(3,3),GL(3),QPNT(3)
C Controls:
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from readini
	COMMON /EXCH/   IXC                              !!! from readini
	COMMON /SPIN/   NSPIN                            !!! from readini
        COMMON /ORBS/   NORBS                            !!! from readini
C Inputs:
	COMMON /POTCOM/ SWZ,SMT                          !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                       !!! from qvector
	COMMON /LATTICE/RBAS,GBAS                        !!! from readstr
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from readini
C Potential:
	COMMON /DPSVCOM/DPOTPS                           !!! from dvxftr
C Density:
	COMMON /PSRHO/  RHOPS                            !!! from ttrint
	COMMON /DPSRHO/ DRHOPS                           !!! from ttrint
C Temporary storage:
	COMMON /STORE1/ RHORS,DRHORS,DVXCRS,G1RHO,DG1RHO
	COMMON /STORE2/ G2RHO                            !!! tmp.storage
	COMMON /STORE3/ DG2RHO                           !!! tmp.storage
C Plane waves:
	COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
	COMMON /FFTMESH/MDIV,AD,RD                       !!! from readini
C Outputs:
	COMMON /WORD/   NVAL                             !!! from setup
	DATA PI/3.141592653589793D0/,QGAM/0.D0,0.D0,0.D0/
        IF(NORBS.EQ.1.AND.MY.NE.0.AND.MY.NE.2)RETURN
        SFACT=0.5D0*DBLE(NSPIN)
C Set keys for LDA and GGA
        ILDA=MOD(IXC,10)     !!! LDA key
        IGGA=(IXC-ILDA)/10   !!! GGA key
        DO ISPIN=1,NSPIN                         !!! over spins
C SET CHARGE DENSITY AT THE REAL SPACE MESH
        CALL FTRANSD( RHOPS(0,ISPIN), RHORS(1,ISPIN),
     &  TMPARR,0,0,QGAM)
        CALL FTRANSD(DRHOPS(0,ISPIN),DRHORS(1,ISPIN),
     &  TMPARR,0,0,QPNT)
        IF(IGGA.NE.0)THEN
C SET DENSITY GRADIENTS
        DO IA=1,3
        CALL FTRANSD( RHOPS(0,ISPIN), G1RHO(1,ISPIN,IA),
     &  TMPARR,IA,0,QGAM)
        CALL FTRANSD(DRHOPS(0,ISPIN),DG1RHO(1,ISPIN,IA),
     &  TMPARR,IA,0,QPNT)
	DO IB=1,3
        CALL FTRANSD( RHOPS(0,ISPIN), G2RHO(1,ISPIN,IA,IB),
     &  TMPARR,IA,IB,QGAM)
        CALL FTRANSD(DRHOPS(0,ISPIN),DG2RHO(1,ISPIN,IA,IB),
     &  TMPARR,IA,IB,QPNT)
        ENDDO
        ENDDO
        ENDIF
        ENDDO                                    !!! over spins
C Set gradients to zero
        DO IA=1,3
        GR1UP(IA)=(0.D0,0.D0)
        GR1DN(IA)=(0.D0,0.D0)
        DO IB=1,3
        GR2UP(IA,IB)=(0.D0,0.D0)
        GR2DN(IA,IB)=(0.D0,0.D0)
        ENDDO
        ENDDO
        ALRUP=0.D0
        ALRDN=0.D0
C *** GET EXCHANGE-CORRELATION PSEUDOPOTENTIAL AT THE REAL SPACE MESH ***
	DO 3000 MFFT3=0,MDIV(3)-1               !!! over mfft3
	DO 2000 MFFT2=0,MDIV(2)-1               !!! over mfft2
	DO 1000 MFFT1=0,MDIV(1)-1               !!! over mfft1
	IFFT=1+MFFT1+MFFT2*MDIV(1)+MFFT3*MDIV(1)*MDIV(2)
C Spin densities
        ROUP=DREAL(RHORS(IFFT,1    ))*SFACT
        RODN=DREAL(RHORS(IFFT,NSPIN))*SFACT
C Spin gradients
        IF(IGGA.NE.0)THEN
        ALRUP=0.D0
        ALRDN=0.D0
        DO IA=1,3
        GR1UP(IA)=G1RHO(IFFT,1    ,IA)*SFACT
        GR1DN(IA)=G1RHO(IFFT,NSPIN,IA)*SFACT
        DO IB=1,3
        GR2UP(IA,IB)=G2RHO(IFFT,1    ,IA,IB)*SFACT
        GR2DN(IA,IB)=G2RHO(IFFT,NSPIN,IA,IB)*SFACT
        ENDDO
        ALRUP=ALRUP+GR2UP(IA,IA)
        ALRDN=ALRDN+GR2DN(IA,IA)
        ENDDO
        ENDIF
C Change due to density
	DVXCRS(IFFT,1)    =(0.D0,0.D0)
	DVXCRS(IFFT,NSPIN)=(0.D0,0.D0)
        DO JSPIN=1,NSPIN
        CALL DEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &  ALRDN,IXC,JSPIN,KEY,NSPIN,DEXCUP,DEXCDN,DVXCUP,DVXCDN)
        DO ISPIN=1,NSPIN
        IF(ISPIN.EQ.1.AND.KEY.EQ.1)DXC=DVXCUP
        IF(ISPIN.EQ.2.AND.KEY.EQ.1)DXC=DVXCDN
        IF(ISPIN.EQ.1.AND.KEY.EQ.2)DXC=DEXCUP
        IF(ISPIN.EQ.2.AND.KEY.EQ.2)DXC=DEXCDN
        DVXCRS(IFFT,ISPIN)=DVXCRS(IFFT,ISPIN)+
     &  DXC*DRHORS(IFFT,JSPIN)
        ENDDO
        ENDDO
C Change due to gradients
        IF(IGGA.NE.0)THEN
        DO JSPIN=1,NSPIN
        CALL GEXCVXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &  ALRDN,IXC,JSPIN,KEY,NSPIN,GEXCUP,GEXCDN,GVXCUP,GVXCDN)
        DO ISPIN=1,NSPIN
        DO IA=1,3
        IF(ISPIN.EQ.1.AND.KEY.EQ.1)DXC=GVXCUP(IA)
        IF(ISPIN.EQ.2.AND.KEY.EQ.1)DXC=GVXCDN(IA)
        IF(ISPIN.EQ.1.AND.KEY.EQ.2)DXC=GEXCUP(IA)
        IF(ISPIN.EQ.2.AND.KEY.EQ.2)DXC=GEXCDN(IA)
        DVXCRS(IFFT,ISPIN)=DVXCRS(IFFT,ISPIN)+
     &  DXC*DG1RHO(IFFT,JSPIN,IA)
        ENDDO
        ENDDO
        ENDDO
        ENDIF
C Change due to second gradients
        IF(IGGA.NE.0.AND.KEY.EQ.1)THEN
        DO JSPIN=1,NSPIN
        CALL G2VXC(ROUP,RODN,GR1UP,GR1DN,GR2UP,GR2DN,ALRUP,
     &  ALRDN,IXC,JSPIN,KEY,NSPIN,DVXC2UP,DVXC2DN,DVXCLUP,DVXCLDN)
        DO ISPIN=1,NSPIN
        DO IA1=1,3 
        DO IA =1,3
        IF(ISPIN.EQ.1)DXC=DVXC2UP(IA,IA1)
        IF(ISPIN.EQ.2)DXC=DVXC2DN(IA,IA1)
        DVXCRS(IFFT,ISPIN)=DVXCRS(IFFT,ISPIN)+
     &  DXC*DG2RHO(IFFT,JSPIN,IA,IA1)
        ENDDO
        ENDDO
        IF(ISPIN.EQ.1)DXC=DVXCLUP
        IF(ISPIN.EQ.2)DXC=DVXCLDN
        DVXCRS(IFFT,ISPIN)=DVXCRS(IFFT,ISPIN)+
     &  DXC*(DG2RHO(IFFT,JSPIN,1,1)+
     &       DG2RHO(IFFT,JSPIN,2,2)+
     &       DG2RHO(IFFT,JSPIN,3,3))
        ENDDO
        ENDDO
        ENDIF
1000	CONTINUE                                !!! over mfft1
2000	CONTINUE                                !!! over mfft2
3000	CONTINUE                                !!! over mfft3
C  GET EXCHANGE-CORRELATION POTENTIAL BY RECIPROCAL FOURIER TRANSFORM
        DO ISPIN=1,NSPIN
        CALL FTRANSR(DPOTPS(0,ISPIN),DVXCRS(1,ISPIN),TMPARR,QPNT)
        ENDDO
	END
