	SUBROUTINE ELECTRONS
************************************************************
*   The calculation of the electron spectrum in terms      *
*   of the FP-LMTO method using plane-wave expansions.     *
*   Written by S.Yu.Savrasov                               *
************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	CHARACTER*8 ST,FN,TEXT*64
	COMMON /CONTROL/LIFT                   !!! from init
	COMMON /TEXT/   TEXT                   !!! from init
	COMMON /UNIT/   IUN                    !!! from init
	LOGICAL EXIT
	DATA ST/'started'/,FN/'finished'/
	write(iun,1000)text
C  CALCULATE STRUCTURE CONSTANTS
	call timel(times)
	write(iun,1001)st,times
	CALL STRMSH         !!!
	call timel(timef)
	write(iun,1001)fn,timef
C  CALCULATE ATOMIC CELL ENVELOPES
	call timel(times)
	write(iun,1002)st,times
	CALL SCELLS         !!!
	call timel(timef)
	write(iun,1002)fn,timef
	IF(LIFT.LE.1)CALL OUTPUT('No Band Structure Calculation',0)
C CALCULATE MULTIPOLE FIELD
	call timel(times)
	write(iun,1003)st,times
	CALL READSCF        !!! read charge density
        CALL MULTRHO        !!! calculate moments of (pseudo)density
        CALL MULTFTR        !!! multipoles as lattice sums
	call timel(timef)
	write(iun,1003)fn,timef
C  CALCULATE FULL POTENTIAL
	write(iun,1000)text
	call timel(times)
	write(iun,1004)st,times
	CALL VCOUL          !!! calculate Coulomb potential within MT-spheres
	CALL VEXCH(1)       !!! calculate ex.-cor.potential within MT-spheres
        CALL VCFTR          !!! calculate Coulomb potential in the int.region
	CALL VXFTR(1)       !!! calculate ex.-cor.potential in the int.region
	CALL ZEROV          !!! set up energy zero
        CALL VPINT          !!! calculate convolutions of pseudopotential
        CALL PRINT2         !!! print necessary information
        CALL HUBPOT         !!! adds Hubbard correction to the potential
        CALL PRINTH(IUN)    !!! print Hubbard correction
	call timel(timef)
	write(iun,1004)fn,timef
C  CALCULATE ELECTRON SPECTRUM
	call timel(times)
	write(iun,1005)st,times
	CALL BANDS          !!! find band energies and eigenvectors
	call timel(timef)
	write(iun,1005)fn,timef
C  CALCULATE BRILLOUIN ZONE INTEGRALS
	call timel(times)
	write(iun,1006)st,times
	CALL BZINT          !!! find Fermi level and partial numbers of states
	call timel(timef)
	write(iun,1006)fn,timef
	IF(LIFT.LE.2)CALL OUTPUT('No Linear Response Calculation',0)
	write(iun,1007)
1000    FORMAT(/1X,A64/)
1001  FORMAT('******* STRMSH ',A8,' ; CPU time: ',G14.7,' ************')
1002  FORMAT('******* SRFMSH ',A8,' ; CPU time: ',G14.7,' ************')
1003  FORMAT('******* MULTRO ',A8,' ; CPU time: ',G14.7,' ************')
1004  FORMAT('*******  VFULL ',A8,' ; CPU time: ',G14.7,' ************')
1005  FORMAT('******** BANDS ',A8,' ; CPU time: ',G14.7,' ************')
1006  FORMAT('******** BZINT ',A8,' ; CPU time: ',G14.7,' ************')
1007  FORMAT(63('='))
	END
