	SUBROUTINE INTMAT(IPNT,IPAN)
***********************************************************
*  Calculates pseudopotential contribution to the         *
*  hamiltonian and overlap matrix using fourier transform.* 
*  S.Savrasov, Last revison 21.06.94.                     *
***********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &   ,NKAP(NPANMAX),LBAS(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX)
     &   ,IND(LIMLMB,NPAT,NKAPMAX,NSPINMAX,NPANMAX),ILSV(NSORTMAX)
     &   ,IATS(NPAT,NPANMAX),ISTS(NSORTMAX,NPANMAX)
     &   ,NBNDF(NPANMAX),NBNDE(NPANMAX),NBNDT(NPANMAX)
     &   ,NDIV(3),NDIW(3)
	COMPLEX*16 VPS(0:NPLWMAX,NSPINMAX),YLM(LIMLMB,0:NBASMAX)
     &    ,HMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX),HHH
     &    ,OMAT(NDIMMAX*NSPINMAX,NDIMMAX*NSPINMAX),OOO
     &    ,EKAP(NKAPMAX,NPANMAX),EK(NKAPMAX,NPANMAX),GINT
     &    ,CFTR(0:LMAXB,NSORTMAX,NKAPMAX,0:NBASMAX)
     &    ,CONV(0:NBASMAX),CHIS(0:NBASMAX),CHIK(0:NBASMAX)
     &    ,XFUN(NDIMMAX,0:MBASMAX),VINT0(NDIMMAX,NDIMMAX)
     &    ,EXPS(0:NBASMAX),EXPK(0:NBASMAX),CONK(0:MBASMAX)
     &    ,VPSINT(0:NPLWMAX,NSPINMAX),CONS(0:MBASMAX)
	DIMENSION TAU(3,NPAT),GPLW(3,0:NPLWMAX),SMT(NSORTMAX)
     &    ,ETA(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),PNTR(3),PNTK(3)
     &    ,CUT(0:LMAXB,NSORTMAX,NKAPMAX,NPANMAX),ORTH(2:3)
     &    ,PNT(3,KMAX),SH(3,NPANMAX)
	LOGICAL LTPAN(0:LMAXT+1,NPAT,NKAPMAX,NPANMAX)
     &   ,LSPAN(0:LMAXT+1,NSORTMAX,NKAPMAX,NPANMAX)
	COMMON /CONTROL/MAN,LMTO,NLR,NOVR                    !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM        !!! from init
	COMMON /BASIS/  TAU                                  !!! from init
	COMMON /POTCOM/ SWZ,SMT                              !!! from init
	COMMON /DENS/   PNTR,CFTR,YLM                        !!! from strgnt
	COMMON /PANPAR/ LTPAN,LSPAN,IATS,ISTS                !!! from init
	COMMON /ETAPAR/ ETA,CUT,LBAS,NBAS                    !!! from plwmsh
        COMMON /TEILORG/KEYT,BZM,GOPT,MBAS                   !!! from teipar
	COMMON /PSVCOM/ VPS,VPSINT                           !!! from vpseudo
	COMMON /STORE2/ HMAT,OMAT                            !!! from intmat
	COMMON /STORE1/ XFUN,VINT0                           !!! from intpar
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                    !!! from init
        COMMON /MESH/   NPNT,PNT                             !!! from init
        COMMON /INTTR/  NDIV,NDIW,SH                         !!! from init
	COMMON /INDX/   IND                                  !!! from lmtpar
        COMMON /NBANDS/ NBNDF,NBNDE,NBNDT                    !!! from init
	COMMON /ORBS/   NORBS                                !!! from init
	COMMON /SPIN/   NSPIN                                !!! from init
	COMMON /UNIT/   IUN                                  !!! from init
	COMMON /WORD/   NVAL                                 !!! from nmtdata
	DATA PI/3.141592653589793D0/
        NDIM=NBNDT(IPAN)*NSPIN
C  SET ZEROES
        DO IDIM1=1,NDIM
        DO IDIM =1,NDIM
        HMAT(IDIM1,IDIM)=(0.D0,0.D0)
        OMAT(IDIM1,IDIM)=(0.D0,0.D0)
        ENDDO
        ENDDO
C  FIND K-POINT PNTR=K+G WHICH HAS A MINIMAL LENGTH
        XK=PNT(1,IPNT)+SH(1,IPAN)
        YK=PNT(2,IPNT)+SH(2,IPAN)
        ZK=PNT(3,IPNT)+SH(3,IPAN)
        CALL REDUC2(XK,YK,ZK,NBAS,GPLW(1,0),PNTK(1),PNTK(2),PNTK(3),
     &  GRX,GRY,GRZ)
C  SET PSEUDOLMTOS FOR THE POINT IPNTK
        CALL FTRMAT(PNTK,0,IPAN)
C  DO OVER SPINS
	DO 1000 ISPIN=1,NSPIN                      !!! over spins
C  READ POTENTIAL PARAMETERS
	IREC=ISPIN
        IF(KEYT.GT.0)
     &  READ(18,REC=IREC)((VINT0(IPAR1,IPAR),IPAR1=1,
     &  NBNDT(IPAN)),IPAR=1,NBNDT(IPAN)),((XFUN(IPAR1,IBAS),
     &  IPAR1=1,NBNDT(IPAN)),IBAS=0,MIN(NBAS,MBAS))
C  DO OVER LEFT INDEX
	DO IATOM1=1,NATOM                          !!! over iatom1
	ISORT1=IS(IATOM1)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM1)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM1)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM1)
	EXPS(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        ENDDO    
	DO IKAP1=1,NKAP(IPAN)                      !!! over energy
	DO L1=0,ILSB(ISORT1)                       !!! over l1
	DO M1=-L1,L1                               !!! over m1
	IF(.NOT.LTPAN(L1,IATOM1,IKAP1,IPAN))EXIT
	L1M1=L1*(L1+1)+M1+1
	IDIM1=IND(L1M1,IATOM1,IKAP1,ISPIN,IPAN)
	IPAR1=IND(L1M1,IATOM1,IKAP1,1    ,IPAN)
	MINB1=MIN(LBAS(L1,ISORT1,IKAP1,IPAN),MBAS)
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=0,MINB1                           !!! NG_1{small}
	CHIS(IBAS)=DCONJG(CFTR(L1,ISORT1,IKAP1,IBAS)*
     &  YLM(L1M1,IBAS)*EXPS(IBAS))
        ENDDO    
C  CONVOLUTION OF THE PSEUDOORBITAL WITH THE PSEUDOPOTENTIAL
        CALL CONVOL1(VPSINT(0,ISPIN),CHIS(0),CONV(0),'L',
     &               0,MIN(NBAS,MBAS),0,MINB1)
C  SET CONVOLUTION FROM THE TEILOR EXPANSION
	IF(KEYT.GT.0)THEN
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	CONS(IBAS)=XFUN(IPAR1,IBAS)*DCONJG(EXPS(0))
        ENDDO    
	ENDIF
C  DO OVER RIGHT INDEX
	DO IATOM=1,NATOM                           !!! over iatom
	ISORT=IS(IATOM)
C  CALCULATE EXPONENTIAL FACTOR
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	SCP=(GPLW(1,IBAS)+PNTK(1))*TAU(1,IATOM)+
     &      (GPLW(2,IBAS)+PNTK(2))*TAU(2,IATOM)+
     &      (GPLW(3,IBAS)+PNTK(3))*TAU(3,IATOM)
	EXPK(IBAS)=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
        ENDDO    
	DO IKAP=1,NKAP(IPAN)                       !!! over energy
	DO L=0,ILSB(ISORT)                         !!! over l
	DO M=-L,L                                  !!! over m
	IF(.NOT.LTPAN(L,IATOM,IKAP,IPAN))EXIT
	LM=L*(L+1)+M+1
	IDIM=IND(LM,IATOM,IKAP,ISPIN,IPAN)
	IPAR=IND(LM,IATOM,IKAP,1    ,IPAN)
	MINB=MIN(LBAS(L,ISORT,IKAP,IPAN),MBAS)
	IF(IDIM1.GE.IDIM)THEN
C  FOURIER TRANSFORM OF THE PSEUDOORBITAL
	DO IBAS=0,MINB                             !!! NG_0{small}
	CHIK(IBAS)=CFTR(L,ISORT,IKAP,IBAS)*YLM(LM,IBAS)*EXPK(IBAS)
        ENDDO    
C  SET CONVOLUTION FROM THE TEILOR EXPANSION
	IF(KEYT.GT.0)THEN
	DO IBAS=0,MIN(NBAS,MBAS)                   !!! NGMAX{small}
	CONK(IBAS)=DCONJG(XFUN(IPAR,IBAS))*EXPK(0) 
        ENDDO    
	ENDIF
C  ******** PSEUDOPOTENTIAL MATRIX ************
	HHH=(0.D0,0.D0)
C  1) CONTRIBUTION FROM SMALL G, FULL K-DEPENDENCE
	DO IBAS=0,MINB                             !!! NG_0{small}
	HHH=HHH+CONV(IBAS)*CHIK(IBAS)
        ENDDO    
	IF(KEYT.GT.0)THEN
C  2) CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR
	DO IBAS=0,MINB1                            !!! NG_1{small}
	HHH=HHH+CHIS(IBAS)*CONK(IBAS)
        ENDDO    
C  3) CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR
	DO IBAS=0,MINB                             !!! NG_0{small}
	HHH=HHH+CONS(IBAS)*CHIK(IBAS)
        ENDDO    
C  4) CONTRIBUTION FROM LARGE G, K-DEPENDENCE BY TEILOR
	HHH=HHH+DCONJG(EXPS(0))*VINT0(IPAR1,IPAR)*EXPK(0)
	ENDIF
C  PSEUDOOVERLAP MATRIX
	OOO=(0.D0,0.D0)
 	IF(NOVR.EQ.1)THEN
	STOP'NOVR.EQ.1 NOT READY'
C	DO JBAS=0,LBAS(L1,ISORT1,IKAP1,IPAN)
C	DO IBAS=0,LBAS(L,ISORT,IKAP,IPAN)
C	OOO=OOO+CHIS(IBAS)*CHIK(IBAS)*GINT
C	ENDDO
C	ENDDO
 	ENDIF
C  FILL UP THE MATRICES
	HRE= DREAL(HHH)  ! real part of the hamiltonian matrix
	HIM= DIMAG(HHH)  ! imaginary part of the hamiltonian matrix
	ORE= DREAL(OOO)  ! real part of the overlap matrix
	OIM= DIMAG(OOO)  ! imaginary part of the overlap matrix
C       IF(ABS(HRE).LE.1.D-10)HRE=0.D0
C       IF(ABS(HIM).LE.1.D-10)HIM=0.D0
C       IF(ABS(ORE).LE.1.D-10)ORE=0.D0   ! not necessary now !
C       IF(ABS(OIM).LE.1.D-10)OIM=0.D0
	IF(IDIM1.EQ.IDIM)HIM=0.D0
	IF(IDIM1.EQ.IDIM)OIM=0.D0
        HMAT(IDIM1,IDIM)=DCMPLX(+HRE,+HIM)
        OMAT(IDIM1,IDIM)=DCMPLX(+ORE,+OIM)
        HMAT(IDIM,IDIM1)=DCONJG(HMAT(IDIM1,IDIM))
        OMAT(IDIM,IDIM1)=DCONJG(OMAT(IDIM1,IDIM))
	ENDIF
        ENDDO                             !!! over m
        ENDDO                             !!! over l
        ENDDO                             !!! over energy
        ENDDO                             !!! over iatom
        ENDDO                             !!! over m1
        ENDDO                             !!! over l1
        ENDDO                             !!! over energy
        ENDDO                             !!! over iatom1
1000    CONTINUE                          !!! over spins
	END
