	SUBROUTINE MIXBRD(IQPNT,ITER,KEY)
**************************************************************
*  Mixes induced charge densities according to the Broyden   *
*  prescription.                                             *
**************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,IS(NPAT),NHSORT(NSORTMAX),NKAP(NPANMAX),NRAD(NSORTMAX)
     &   ,LBROY (0:NENVMAX,-1:2),IBROY(0:NENVMAX,-1:2)
     &   ,LBROY0(0:NENVMAX,-1:2),NITER(0:NENVMAX,-1:2)
     &   ,MTER  (0:NENVMAX,-1:2),INDGPTB(0:NENVMAX)
     &   ,INDZPTB(NENVMAX)
        DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX)
     &   ,WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),ZCOR(NSORTMAX)
     &   ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),DR(0:NRADMAX,NSORTMAX)
     &   ,ADMIXB(0:NENVMAX,-1:2),ADMIXH(0:NENVMAX,-1:2),WRAD(NLENMAX)
     &   ,WTER(0:NTERMAX,0:NENVMAX,-1:2),GPLW(3,0:NPLWMAX)
     &   ,TAU(3,NPAT),QPNT(3),ORTH(2:3),GPTB(3,0:NENVMAX)
     &   ,QPTB(3,NENVMAX)
        COMPLEX*16 
     &    DRHO(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),WRK1(NLENMAX)
     &   ,DMAG(0:NRADMAX,LMMAXV,NPAT,NSPINMAX),WRK2(NLENMAX)
     &	 ,DRHOPS(0:NPLWMAX,NSPINMAX),DMAGPS(0:NPLWMAX,NSPINMAX)
     &   ,WORK1(0:NRADMAX),WORK2(0:NRADMAX),DQCH(NPAT,NSPINMAX)
     &	 ,XRHO(NLENMAX),XNEW(NLENMAX),DMCH(NPAT,NSPINMAX)
     &   ,EXPQR,CNUM0P,DRHOPS1(0:NPLWMAX,NSPINMAX),DELP(8)
     &   ,WMIX(NTERMAX,NTERMAX,0:NENVMAX,-1:2)
     &   ,WINP(NTERMAX,0:NENVMAX,-1:2)
        CHARACTER*10 TXTEL(NSORTMAX),TXTSP(2)*2
     &   ,SCNFILE(0:NENVMAX,-1:2,100)*60
        LOGICAL FIRST,RESET(0:NENVMAX,-1:2)
C Controls:
        COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE         !!! from readini
        COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT !!! from readini
        COMMON /SPIN/   NSPIN                                !!! from readini
C Inputs:
        COMMON /BASIS/  TAU                                  !!! from readini
        COMMON /QMESH/  NQPNT,QPNT                           !!! from readini
        COMMON /POTCOM/ SWZ,SMT                              !!! from readini
        COMMON /MAGCOM/ ITERMAX,NITER                        !!! from qvector
        COMMON /LATPAR/ PAR,ORTH,OMEGAC                      !!! from readini
        COMMON /MULTRO/ Z,ZCOR                               !!! from readini
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB             !!! from plwptb
        COMMON /PLZCOM/ NPLZ,LPLZ,IPLZ,NZPTB,QPTB,INDZPTB    !!! from plwcrd
C Density:
        COMMON /DELRO/  DRHO,DMAG                            !!! from delrho
        COMMON /DPSRHO/ DRHOPS,DMAGPS,DRHOPS1                !!! from dtosint
C Rad.mesh:
        COMMON /RADMESH/NRAD,H,R,DR,WEIGHT,RL                !!! from radmsh
C Mixings:
	COMMON /MIXDBRD/LBROY,IBROY,ADMIXB,ADMIXH,MTER,WINP,WMIX ! from init
C Temporary:
	COMMON /STORE1/ XRHO,XNEW,WRAD,WRK1,WRK2             !!! tmp.storage
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW                            !!! from plwmsh
C Outputs:
        COMMON /OUT0PH/ SCNFILE                              !!! from qvector
        COMMON /UNIT/   IUN                                  !!! from readini
        COMMON /TXTEL/  TXTEL,TXTSP                          !!! from readini
	SAVE LBROY0,FIRST,RESET,WTER
        DATA PI/3.141592653589793D0/,FIRST/.TRUE./
	IF(MODE.EQ.4.OR.MODE.EQ.5)RETURN
C  DO GLOBALLY OVER POLARIZATIONS AND DISPLACEMENTS
	DO 2000 MY=-1,2                     !!! over polarizations
	DO 1000 IGPTB=0,NGPTB               !!! over g-vectors
	IF(NITER(IGPTB,MY).EQ.0)GOTO1000
C  SAVE SWITCHES
	IF(FIRST)THEN
        LBROY0(IGPTB,MY)=LBROY(IGPTB,MY)
	MTER(IGPTB,MY)=0
	RESET(IGPTB,MY)=.TRUE.
	ENDIF
C  DO NOT START BROYDEN, WAIT
	IF(ITER.LE.IBROY(IGPTB,MY))THEN
	LBROY(IGPTB,MY)=-1
C  SWITCH ON NOW
	ELSEIF(ITER.GT.IBROY(IGPTB,MY))THEN
	LBROY(IGPTB,MY)=LBROY0(IGPTB,MY)
	ENDIF
	IF(LBROY(IGPTB,MY).LT.0)GOTO1000
C  SET ITERATION NUMBER
	IF(MTER(IGPTB,MY).EQ.NTERMAX-1)RESET(IGPTB,MY)=.TRUE.
	IF(MTER(IGPTB,MY).EQ.NTERMAX-1)
     &  PRINT*,'<MIXROB>:: MTER>NTERMAX, BROYDEN RESTARTED'
	IF(RESET(IGPTB,MY))MTER(IGPTB,MY)=0
	IF(KEY.EQ.1.AND.MTER(IGPTB,MY).NE.0)GOTO1000
	IF(KEY.EQ.2)MTER(IGPTB,MY)=MTER(IGPTB,MY)+1
C  READ CHANGE IN CHARGE DENSITY
        CALL DROFILES(IGPTB,MY,IQPNT,33,'R')      !!! read change in density
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'R')      !!! read change in density
C  *** SET MIXING ARRAY ***
C  MT-PART
	IDIM=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        SL=SMT(ISORT)**L
        IF(L.LE.LBROY(IGPTB,MY))THEN              !!! for l.le.lbroy
C  1) Pack Induced Density into Array
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     & 	DRHO(IRAD,LM,IATOM,1)+DRHO(IRAD,LM,IATOM,NSPIN))
	WRAD(IDIM)=1.D0
	ENDDO
C  2) Pack Longitudinal Magnetization into Array
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      	XRHO(IDIM)=DRHO(IRAD,LM,IATOM,1)-DRHO(IRAD,LM,IATOM,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO
C  3) Pack Transverse Magnetization into Array
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      	XRHO(IDIM)=DMAG(IRAD,LM,IATOM,1)
	WRAD(IDIM)=1.D0
	ENDDO
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
      	XRHO(IDIM)=DMAG(IRAD,LM,IATOM,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO
	ENDIF                               !!! for l.le.lbroy
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C  *** SET MIXING ARRAY ***
C  PLW-PART
C  1) Pack Induced Density into Array
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      	XRHO(IDIM)=0.5D0*DBLE(NSPIN)*(
     & 	DRHOPS(IPLW,1)+DRHOPS(IPLW,NSPIN))
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
C  2) Pack Longitudinal Magnetization into Array
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      	XRHO(IDIM)=DRHOPS(IPLW,1)-DRHOPS(IPLW,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
C  3) Pack Transverse Magnetization into Array
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      	XRHO(IDIM)=DMAGPS(IPLW,1)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
      	XRHO(IDIM)=DMAGPS(IPLW,NSPIN)
	WRAD(IDIM)=1.D0
	ENDDO                               !!! over plane waves
	NDIM=IDIM
	IF(NDIM.GT.NLENMAX)
     &  STOP'NLENMAX MUST BE INCREASED IN PARAM.DAT'
C  SEND ARRAY TO BROYDEN
        CALL DBROY4N(XRHO,XNEW,WRAD,WRK1,WRK2,NDIM,MTER,
     &  ADMIXB,WTER,WINP,WMIX,23,SCNFILE(0,-1,23),IGPTB,MY)
	IF(MTER(IGPTB,MY).EQ.0)RESET(IGPTB,MY)=.FALSE.
	IF(MTER(IGPTB,MY).EQ.0)GOTO1000
C  *** DEFINE NEW INDUCED DENSITY ***
C  MT-PART
	IDIM=0
	NEGD=0
	DO IATOM=1,NATOM                    !!! over atoms
	ISORT=IS(IATOM)
        DO L=0,ILSV(ISORT)                  !!! over l
        DO M=-L,L                           !!! over m
        LM=L*(L+1)+M+1
        SL=SMT(ISORT)**L
        IF(L.LE.LBROY(IGPTB,MY))THEN        !!! for l.le.lbroy
C  Repack Induced Spin Densities
	DO IRAD=0,NRAD(ISORT) 
	IDIM=IDIM+1
	DRHO(IRAD,LM,IATOM,1)=XNEW(IDIM)/DBLE(NSPIN)
	DRHO(IRAD,LM,IATOM,NSPIN)=XNEW(IDIM)/DBLE(NSPIN)
	ENDDO
	DO IRAD=0,NRAD(ISORT)
	IDIM=IDIM+1
	DRHO(IRAD,LM,IATOM,1)=DRHO(IRAD,LM,IATOM,1)+
     &  XNEW(IDIM)/DBLE(NSPIN)
	DRHO(IRAD,LM,IATOM,NSPIN)=DRHO(IRAD,LM,IATOM,NSPIN)-
     &  XNEW(IDIM)/DBLE(NSPIN)
	ENDDO
	DO IRAD=0,NRAD(ISORT) 
	IDIM=IDIM+1
	DMAG(IRAD,LM,IATOM,1)=XNEW(IDIM)
	ENDDO
	DO IRAD=0,NRAD(ISORT) 
	IDIM=IDIM+1
	DMAG(IRAD,LM,IATOM,NSPIN)=XNEW(IDIM)
	ENDDO
	ENDIF                               !!! for l.le.lbroy
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
C  *** DEFINE NEW INDUCED DENSITY ***
C  PLW-PART
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DRHOPS(IPLW,1)=XNEW(IDIM)/DBLE(NSPIN)
	DRHOPS(IPLW,NSPIN)=XNEW(IDIM)/DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DRHOPS(IPLW,1)=DRHOPS(IPLW,1)+XNEW(IDIM)/DBLE(NSPIN)
	DRHOPS(IPLW,NSPIN)=DRHOPS(IPLW,NSPIN)-XNEW(IDIM)/
     &  DBLE(NSPIN)
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DMAGPS(IPLW,1)=XNEW(IDIM)
	ENDDO                               !!! over plane waves
	DO IPLW=0,NPLW                      !!! over plane waves
	IDIM=IDIM+1
	DMAGPS(IPLW,NSPIN)=XNEW(IDIM)
	ENDDO                               !!! over plane waves
C  SET NEW INDUCED CHARGES AND MAGNETIC MOMENTS
        DO ISPIN=1,NSPIN                    !!! over spins
	ITRAN=ISPIN
        DO IATOM=1,NATOM                    !!! over atoms
        ISORT=IS(IATOM)
	DO L=0,0                            !!! over l
        SL=SMT(ISORT)**L
	DO M=-L,L                           !!! over m
	LM=L*(L+1)+M+1
        DO IRAD=0,NRAD(ISORT)
        WORK1(IRAD)=DRHO(IRAD,LM,IATOM,ISPIN)*
     &  RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
        DQCH(IATOM,ISPIN)=WORK2(NRAD(ISORT))
        DO IRAD=0,NRAD(ISORT)
        WORK1(IRAD)=DMAG(IRAD,LM,IATOM,ITRAN)*
     &  RL(IRAD,L,ISORT)/SL*WEIGHT(IRAD,ISORT)/SQRT(4.D0*PI)
	ENDDO
        CALL CQD(H(ISORT),WORK1,WORK2,NRAD(ISORT)+1)
        DMCH(IATOM,ITRAN)=WORK2(NRAD(ISORT))
	ENDDO                               !!! over m
	ENDDO                               !!! over l
	ENDDO                               !!! over atoms
	ENDDO                               !!! over spins
C  Restart mixing (example)
C	IRES=0
C	IF(IRES.EQ.0)RESET(IGPTB,MY)=.FALSE.
C	IF(IRES.EQ.1)RESET(IGPTB,MY)=.TRUE.
C	IF(IRES.EQ.1)PRINT*,'<MIXBRD>: BROYDEN  MIXING  RESTARTED' 
C  Switch off mixing ??? (example)
C	IF(IRES.EQ.1)LBROY (IGPTB,MY)=-1
C	IF(IRES.EQ.1)LBROY0(IGPTB,MY)=-1
C	IF(IRES.EQ.1)PRINT*,'<MIXBRD>: BROYDEN  MIXING  IS OFF' 
C  PRINT BLOCK
	WRITE(IUN,1001)MY
	WRITE(IUN,1010)WTER(MTER(IGPTB,MY),IGPTB,MY)
1001    FORMAT(1X,'MAGNETIC FIELD POLARIZATION "',I2,'" ')
1010	FORMAT(1X,'Broyden Mixing for Dmag(r), Iter-Weight=',G14.7)
        DO IATOM=1,NATOM                    !!! over atoms
        ISORT=IS(IATOM)
	DELP(1)=CNUM0P(DQCH(IATOM,1)+DQCH(IATOM,NSPIN),
     &  1.D-07)*0.5D0*DBLE(NSPIN)
	DELP(2)=CNUM0P(DQCH(IATOM,1)-DQCH(IATOM,NSPIN),
     &  1.D-07)
	DELP(3)=CNUM0P(DMCH(IATOM,1),1.D-07)
	DELP(4)=CNUM0P(DMCH(IATOM,NSPIN),1.D-07)
	WRITE(IUN,1030)TXTEL(ISORT)
	WRITE(IUN,1031)DELP(1)
	WRITE(IUN,1032)DELP(2)
	WRITE(IUN,1033)DELP(3)
	WRITE(IUN,1034)DELP(4)
1030    FORMAT(1X,23X,'dM_iat[NEW]',3X,A10)
1031    FORMAT(1X,' Charge  :',2X,'(',G12.5,',',G12.5,')')
1032    FORMAT(1X,'Z-Moment :',2X,'(',G12.5,',',G12.5,')')
1033    FORMAT(1X,'M-Moment :',2X,'(',G12.5,',',G12.5,')')
1034    FORMAT(1X,'P-Moment :',2X,'(',G12.5,',',G12.5,')')
	ENDDO                               !!! over atoms
        CALL DMULTRHO(IGPTB,MY,IQPNT)       !!! change in pseudodensity moments
        CALL DMULTFTR(IGPTB,MY,IQPNT,0)     !!! change in multipoles
        WRITE(IUN,1040)
	DO IZPTB=1,NZPTB
	IPLW=INDZPTB(IZPTB)
	DELP(1)=OMEGAC*(DRHOPS (IPLW,1)+DRHOPS (IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN) 
     &         +OMEGAC*(DRHOPS1(IPLW,1)+DRHOPS1(IPLW,NSPIN))/
     &  2.D0*DBLE(NSPIN) 
        DELP(2)=OMEGAC*(DRHOPS (IPLW,1)-DRHOPS (IPLW,NSPIN))
     &         +OMEGAC*(DRHOPS1(IPLW,1)-DRHOPS1(IPLW,NSPIN))
        DELP(3)=OMEGAC*DMAGPS(IPLW,1)
        DELP(4)=OMEGAC*DMAGPS(IPLW,NSPIN)
	WRITE(IUN,1041)IZPTB,CNUM0P(DELP(1),1.D-07)
	WRITE(IUN,1042)IZPTB,CNUM0P(DELP(2),1.D-07)
	WRITE(IUN,1043)IZPTB,CNUM0P(DELP(3),1.D-07)
	WRITE(IUN,1044)IZPTB,CNUM0P(DELP(4),1.D-07)
1040    FORMAT(1X,23X,'dP_tot[NEW]',3X,'TOTAL')
1041    FORMAT(1X,'Drho(G',I2,'):',2X,'(',G12.5,',',G12.5,')')
1042    FORMAT(1X,'DmsZ(G',I2,'):',2X,'(',G12.5,',',G12.5,')')
1043    FORMAT(1X,'DmsM(G',I2,'):',2X,'(',G12.5,',',G12.5,')')
1044    FORMAT(1X,'DmsP(G',I2,'):',2X,'(',G12.5,',',G12.5,')')
	ENDDO
C  SAVE CHANGE IN CHARGE DENSITY
        CALL DROFILES(IGPTB,MY,IQPNT,33,'W')!!! save change in density
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'W')!!! save pseudocharge density
1000	CONTINUE                            !!! over g-vectors
2000	CONTINUE                            !!! over polarizations
	FIRST=.FALSE.
	IF(KEY.EQ.1)RETURN
C  SYMMETRIZATION PROGRAMS
        CALL SYMDRHO(IQPNT)                 !!! symmetrize change in density
        CALL SYMDPSR(IQPNT)                 !!! the same for pseudodensity
	END
