	SUBROUTINE RADMSH
*************************************************************
*   Module prepares radial mesh in each  MT-sphere          *
*************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER   IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &     ,NRAD(NSORTMAX),LR(NSORTMAX)
	DIMENSION H(NSORTMAX),R(0:NRADMAX,NSORTMAX),SMT(NSORTMAX)
     &     ,GL(3),WEIGHT(0:NRADMAX,NSORTMAX),Z(NSORTMAX),AS(NPAT)
     &     ,RL(0:NRADMAX,0:LMAXV,NSORTMAX),ZCOR(NSORTMAX),ORTH(2:3)  
     &     ,DR(0:NRADMAX,NSORTMAX),SASA(NSORTMAX),STRAIN(3,3,2)
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM      !!! from init
	COMMON /LATTICE/ A(3),B(3),C(3)                     !!! from init
	COMMON /RADMESH/ NRAD,H,R,DR,WEIGHT,RL              !!! for all modules
	COMMON /MULTRO/  Z,ZCOR                             !!! from init
	COMMON /POTCOM/  SWZ,SMT                            !!! for all modules
	COMMON /ASASPH/  SASA                               !!! for all modules
	COMMON /LATPAR/  PAR,ORTH,OMEGAC,STRAIN,VV0         !!! from init
	COMMON /RELATIV/ LR                                 !!! from init
	COMMON /UNIT/    IUN                                !!! from init
	DATA PI/3.141592653589793D0/,DELTANR/0.03D0/,DELTAR/0.03D0/
C  DEFINE WIGNER-ZEITS SPHERE
	CALL CROSS(GL,B,C)
	OMEGA=ABS(A(1)*GL(1)+A(2)*GL(2)+A(3)*GL(3))   !!! volume of unit-cell
	DO IATOM=1,NATOM
        AS(IATOM)=SASA(IS(IATOM))
	ENDDO 
	CALL SCASW(NATOM,OMEGA,AS,S0,AS)              !!! ASA sphere radii
	SWZ=PAR*S0                                    !!! WZ sphere radius
	DO IATOM=1,NATOM
        SASA(IS(IATOM))=PAR*AS(IATOM)
	ENDDO
	DO 1000 ISORT=1,NSORT
C  ESTIMATE STEP
	IF(LR(ISORT).EQ.0)H(ISORT)=DELTANR
	IF(LR(ISORT).EQ.1)H(ISORT)=DELTA R
C  ESTIMATE # OF RADIAL POINTS
	XMIN=-LOG(2.D0*Z(ISORT)+1.D0)
	BETTA=EXP(XMIN)
	PAR0=PAR/VV0**0.333333333333333D0
   	SMT0=SMT(ISORT)*PAR0/PAR
	NRAD(ISORT)=2*LOG(SMT0/BETTA+1.D0)/H(ISORT)
	NRAD(ISORT)=MAX(NRAD(ISORT),100)
	NRAD(ISORT)=MIN(NRAD(ISORT),NRADMAX)
	NRAD(ISORT)=((NRAD(ISORT)-1)/2)*2  !!! must be odd number
C  # OF RADIAL POINTS IS DEFINED, REDEFINE XMIN
C	BETTA=SMT(ISORT)/(EXP(H(ISORT)*NRAD(ISORT))-1.D0)
   	BETTA=SMT0      /(EXP(H(ISORT)*NRAD(ISORT))-1.D0)
	XMIN=LOG(BETTA)
C  SCALE STEP AND XMAX ACCORDING TO V/V0
	H(ISORT)=LOG(SMT(ISORT)/BETTA+1.D0)/DBLE(NRAD(ISORT))
	XMAX=XMIN+H(ISORT)*DBLE(NRAD(ISORT))
C  DEFINE RADIAL MESH ARRAYS
	DO IRAD=0,NRAD(ISORT)
	R(IRAD,ISORT)=BETTA*(EXP(H(ISORT)*IRAD)-1.D0)
	DR(IRAD,ISORT)=BETTA*EXP(H(ISORT)*IRAD)
	WEIGHT(IRAD,ISORT)=4.D0*PI*R(IRAD,ISORT)**2*DR(IRAD,ISORT)
	RL(IRAD,0,ISORT)=1.D0
	DO L=1,LMAXV
	RL(IRAD,L,ISORT)=R(IRAD,ISORT)**L
	ENDDO
	ENDDO
	IF(ABS(R(NRAD(ISORT),ISORT)-SMT(ISORT)).GE.1.D-12)
     &  STOP'<RADMSH>::ERROR IN RADIAL MESH'
1000	CONTINUE
	END




	SUBROUTINE SCASW(NATOM,OMEGA,R,S0,S)
*********************************************************
*  Scale ASA sphere radii according to the numbers R(I) *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION R(NATOM),S(NATOM)
	DATA PI/3.141592653589793D0/
	S0=(OMEGA/NATOM/(4.*PI)*3.)**0.33333333333333D0
	OMEGAR=0.0
	DO I=1,NATOM
        OMEGAR=OMEGAR+4.D0/3.D0*PI*R(I)**3
	ENDDO
	A=(OMEGA/OMEGAR)**0.333333333333333D0
	DO I=1,NATOM
        S(I)=A*R(I)
	ENDDO
	END
