	SUBROUTINE READLRT
**************************************************************
*  Reads LRTFILE which controls linear response calculation. *
**************************************************************
        IMPLICIT REAL*8 (A-H,O-Z)
        INCLUDE 'PARAM.DAT'
        INTEGER LBROY(0:NENVMAX,-1:2),IBROY(0:NENVMAX,-1:2)
     &   ,KSP(0:NENVMAX,-1:2),NDIV(3),NDIW(3),NQDIV(3)
     &   ,NITER(0:NENVMAX,-1:2),KEY(0:NENVMAX,-1:2)
        DIMENSION QPNT(3),SASA(NSORTMAX),EPS(0:NENVMAX,-1:2)
     &   ,ADMIX1(0:NENVMAX,-1:2),ADMIN (0:NENVMAX,-1:2)
     &   ,ADMAX (0:NENVMAX,-1:2),ADMIXB(0:NENVMAX,-1:2)
     &   ,ADMSPN(0:NENVMAX,-1:2),ASMIN (0:NENVMAX,-1:2)
     &   ,ASMAX (0:NENVMAX,-1:2),ADMIXH(0:NENVMAX,-1:2)
        CHARACTER*60 INIFILE,SC0FILE,STRFILE,LRTFILE
     &   ,HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE
        CHARACTER*60 SCNFILE(0:NENVMAX,-1:2,100)
     &   ,DROFILE(0:NENVMAX,-1:2),DPSFILE(0:NENVMAX,-1:2)
     &   ,DSVFILE(0:NENVMAX,-1:2),DPVFILE(0:NENVMAX,-1:2)
     &   ,DSFFILE,PHNFILE,TMLFILE,WGTFILE(10),STNFILE
        CHARACTER*60 PLZFILE(NENVMAX),PLSFILE(NENVMAX)
     &   ,SCPFILE(NENVMAX,100),TXTSCR
        CHARACTER TXTEL(NSORTMAX)*10,TXTSP(2)*2
     &   ,TASK*10,TEXQ*10,TEXM*60,TEXT*72,SCHM*10
     &   ,TPLZ*10,TSTN*10,TDLF*10,TDYN*10
	LOGICAL EXIST
C Controls:
        COMMON /CONTROL/ LIFT,LMTO,NSPH,NOVR,NPFR,MODE          !!! from readini
        COMMON /PLZCOM/  NPLZ,LPLZ,IPLZ                         !!! from readlrt
        COMMON /STNCOM/  NSTN,LSTN,ISTN                         !!! from readlrt
        COMMON /RWFCOM/  NRWF,LRWF,IRWF                         !!! from readini
        COMMON /DLFCOM/  NDLF,LDLF,IDLF                         !!! from readlrt
        COMMON /WHICOM/  NWHI,LWHI,IWHI                         !!! from readlrt
        COMMON /MAGCOM/  ITERMAX,NITER,EPS                      !!! from readlrt
C Mixings:
        COMMON /SCF1COM/ NITER1                                 !!! from readini
        COMMON /MIXRHO1/ ADMIX10,ADMIN0,ADMAX0,KEY0             !!! from readini
        COMMON /MIXMAG1/ ADSPIN0,ASMIN0,ASMAX0,KSP0             !!! from readini
        COMMON /MIXBROY/ LBROY0,IBROY0,ADMIXB0,ADMIXH0          !!! from readini
        COMMON /ACCU/    EPSTOT,EPSRHO,EPSMAG                   !!! from readini
        COMMON /MIXDRHO/ ADMIX1,ADMIN,ADMAX,KEY                 !!! from readlrt
        COMMON /MIXDMAG/ ADMSPN,ASMIN,ASMAX,KSP                 !!! from readlrt
        COMMON /MIXDBRD/ LBROY,IBROY,ADMIXB,ADMIXH              !!! from readlrt
C K-mesh:
        COMMON /INTTR/   NDIV,NDIW                              !!! from readini
C Additional inputs:
        COMMON /INP0/    INIFILE,SC0FILE,STRFILE,LRTFILE        !!! from readlrt
        COMMON /INP1/    ICHUB,ICHOP,ICOPT,ICENR,ICPNT          !!! from readini
        COMMON /INP2/    HUBFILE,HOPFILE,OPTFILE,ENRFILE,PNTFILE!!! from readlrt
C Q-vector:
        COMMON /PTBCOM/  NGSHL                                  !!! from init
        COMMON /QMESH/   NQPNT,QPNT,NUMQ,NQDIV,KEYQ             !!! from init
C Frequency:
	COMMON /FREQU/   OMGR                                   !!! from init
C Outputs:
        COMMON /OUT0PH/  SCNFILE,DROFILE,DSVFILE,DPSFILE,DPVFILE!!! from readlrt
        COMMON /OUT1PH/  ICDSF,ICDRO,ICPHN,ICTML,ICDSV,ICWGT,ICSTN! from readlrt
        COMMON /OUT2PH/  DSFFILE,PHNFILE,TMLFILE,WGTFILE,STNFILE!!! from readlrt
        COMMON /OUT4PH/  SCPFILE,PLZFILE,PLSFILE                !!! from readlrt
        COMMON /SCRDIR/  TXTSCR                                 !!! from block
        COMMON /TXTEL/   TXTEL,TXTSP,TEXQ,TEXM,TASK             !!! from init
       	DATA PI/3.141592653589793D0/
C  CHECK EXISTENCE
        INQUIRE(FILE=LRTFILE,EXIST=EXIST)
        IF(.NOT.EXIST)STOP'<READLRT>: LRTFILE MUST EXIST!'
C  READ DATA FROM LRTFILE
        OPEN(UNIT=1,FILE=LRTFILE,STATUS='OLD',FORM='FORMATTED')
        READ(1,1010)TEXT
        READ(1,1010)TEXT
C  **** GENERAL SETTINGS ****
C  SCHM= 'Phonons'/'Magnons' for PHN/MAG packages.
C  TPLZ= 'Plz=on,R=N'/'Plz=off' switches on polarzability with Gmax=R;
C  TSTN= 'Stn=on'/'Stn=off' switches on/off Stoner matrix calculation.
C  TLFL= 'Dlf=on'/'Del=off' switches on/off changes in radial functions.
C  TDYN= 'Dyn=none'/'Dyn=hf'/'Dyn=oka1'/'Dyn=oka*' scheme for dyn.matrix.
        READ(1,1010)TEXT
        READ(1,*)SCHM
        READ(1,*)TPLZ
        READ(1,*)TSTN
        READ(1,*)TDLF 
        READ(1,*)TDYN
C  Switch for scheme:
        CALL CONVLOW(SCHM,10)
        CALL RMBLANK(SCHM,10)
	LRTM=0
        IF(SCHM(1:7).EQ.'phonons')LRTM=1
        IF(SCHM(1:7).EQ.'magnons')LRTM=2
	IF(LRTM.EQ.0)STOP'<READLRT>: SET CORRECT SCHEME SWITCH'
C  Switch for polarizability:
        CALL CONVLOW(TPLZ,10)
        CALL RMBLANK(TPLZ,10)
	LPLZ=-1
	IF(TPLZ(5:7).EQ.'off' )LPLZ=0
	IF(TPLZ(5:6).EQ.'on'  )LPLZ=1
	IF(TPLZ(5:8).EQ.'auto')LPLZ=0
	IF(LPLZ.EQ.1)READ(TPLZ(10:10),*)LPLZ
	IF(LPLZ.EQ.-1)STOP'<READLRT>: SET CORRECT POLARIZABILTIY SWITCH'
C  Switch for Stoner matrix:
        CALL CONVLOW(TSTN,10)
        CALL RMBLANK(TSTN,10)
	LSTN=-1
	IF(TSTN(5:7).EQ.'off' )LSTN=0
	IF(TSTN(5:6).EQ.'on'  )LSTN=1
	IF(TSTN(5:8).EQ.'auto')LSTN=0
	IF(LSTN.EQ.-1)STOP'<READLRT>: SET CORRECT STONER MATRIX SWITCH'
C  Switch for including changes in radial functions:
        CALL CONVLOW(TDLF,10)
        CALL RMBLANK(TDLF,10)
	LDLF=-1
	IF(TDLF(5:7).EQ.'off' )LDLF=1
	IF(TDLF(5:6).EQ.'on'  )LDLF=2
	IF(TDLF(5:8).EQ.'auto')LDLF=1
	IF(LDLF.EQ.-1)STOP'<READLRT>: SET CORRECT SWITCH FOR DPHI'
C  Switch for dynamical matrix formulae:
        CALL CONVLOW(TDYN,10)
        CALL RMBLANK(TDYN,10)
	NPFR=-1
	IF(TDYN(5:8).EQ.'auto')NPFR=0
	IF(TDYN(5:8).EQ.'none')NPFR=0
	IF(TDYN(5:6).EQ.'hf'  )NPFR=0
	IF(TDYN(5:8).EQ.'oka*')NPFR=1
	IF(TDYN(5:8).EQ.'oka1')NPFR=2
	IF(NPFR.EQ.-1)STOP'<READLRT>: SET CORRECT SWITCH FOR DYN.MATRIX'
C *** DEFAULT FILE SETTINGS ****
        READ(1,1010)TEXT
	READ(1,*)ICDSF,DSFFILE       !!! cell constants
	READ(1,*)ICWGT,WGTFILE(+1)   !!! integration weights
	READ(1,*)ICTML,TMLFILE       !!! temporary file
	READ(1,*)ICSTN,STNFILE       !!! Stoner matrix
	READ(1,*)ICPHN,PHNFILE       !!! Phonon spectrum
	READ(1,*)ICPLZ,PLZFILE(+1)   !!! Polarizability within MTS
	READ(1,*)ICPLZ,PLSFILE(+1)   !!! Polarizability within INT
	READ(1,*)ICDSV,DSVFILE(0,-1) !!! Induced potential within MTS
	READ(1,*)ICDSV,DPVFILE(0,-1) !!! Induced potential within INT
	READ(1,*)ICDRO,DROFILE(0,-1) !!! Induced density within MTS
	READ(1,*)ICDRO,DPSFILE(0,-1) !!! Induced density within INT
	CLOSE(1)
C  SET LIFT TO "BANDS" IF MODE IS "PREPARATIONAL"
        IF(MODE.EQ.0)LIFT=2
C  SET LIFT TO "MAGNONS" IF SCF IS ON
	IF(MODE.NE.0)LIFT=4
C  CHECK RADIAL WAVE FUCNTIONS
	IF(LRWF.EQ.0)STOP'<LRTFILE> LRWF KEY CANNOT BE ZERO!'
C  NEW SELF-CONSISTENCY SCHEME IS ALWAYS ON!
        NPLZ=1
	IPLZ=ICPLZ
C  SET SWITCH FOR TETRAHEDRON WEIGHTS
	IF(MODE.LE.4)LWHI=1
   	IF(MODE.EQ.5)LWHI=4
C  SWITCH OFF POLARIZABILITY AND STONER 
  	IF(MODE.EQ.4.OR.MODE.EQ.5)LPLZ=0
	IF(MODE.EQ.4.OR.MODE.EQ.5)LSTN=0
C  SET DIVISIONS FOR MODE=0
        IF(MODE.EQ.0)NDIV(1)=NDIW(1)
        IF(MODE.EQ.0)NDIV(2)=NDIW(2)
        IF(MODE.EQ.0)NDIV(3)=NDIW(3)
C  SET MIXING ARRAYS
	IF(MODE.NE.0)ITERMAX=NITER1
        IF(MODE.EQ.0)ITERMAX=0
	IF(MODE.EQ.4)ITERMAX=1
	IF(MODE.EQ.5)ITERMAX=1
        DO MY=-1,2
	DO IGPTB=0,NENVMAX
        NITER(IGPTB,MY)=ITERMAX
        EPS  (IGPTB,MY)=EPSTOT
        KEY  (IGPTB,MY)=KEY0
        KSP  (IGPTB,MY)=KSP0
        LBROY(IGPTB,MY)=LBROY0
        IBROY(IGPTB,MY)=IBROY0
        ADMIX1(IGPTB,MY)=ADMIX10
        ADMSPN(IGPTB,MY)=ADSPIN0
        ADMIXB(IGPTB,MY)=ADMIXB0
        ADMIXH(IGPTB,MY)=ADMIXH0
        ENDDO
	ENDDO 
1010    FORMAT(A)
	END
