	SUBROUTINE STRMSH
**************************************************************
*  The preparation of the structure constants for the        *
*  LMTO method  at different energies and their energy       *
*  derivatives (following from the KKR)                      *
*  The symmetry analysis of the crystalline structure and    *
*  determination of the point group (possibly nonsymmorphic) *
*  Written by S.Yu.Savrasov (P.N.Lebedev PhysicaL Institute) *
**************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (LPLMAX=(2*LMAXV+3)**2,NDTMAX=NPAT*NPAT
     &    ,LDLMAX=(2*LMAXB+2)**2,LTLMAX=(LMAXT+1+LMAXB+1)**2)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX)
     &    ,LIMLPL2(NDTMAX),ILS2(NDTMAX),LIMLPL4(NDTMAX)
     &    ,LIMLDL2(NDTMAX),ILD2(NDTMAX),LIMLDL4(NDTMAX)
     &    ,LIM2OLD(NDTMAX),LIM4OLD(NDTMAX),NKAP(NPANMAX)
     &    ,LID2OLD(NDTMAX),NDIV(3),NDIC(3),ILS4(NDTMAX)
     &    ,NKAP0(NPANMAX),IDELP(NPAT,NPAT),ILSV(NSORTMAX)
     &    ,ILD4(NDTMAX),NDIW(3)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
     &    ,EKOLD(NKAPMAX,NPANMAX),SIGMA(LTLMAX,NDTMAX,NKAPMAX)
     &    ,SIGMADOT(LDLMAX,NDTMAX,NKAPMAX)
C    &    ,SIGMM(LPLMAX,NDTMAX)
	DIMENSION PNT(3,KMAX),PNW(3,KMAX),SH(3,NPANMAX),DELTAU(3,NDTMAX)
	CHARACTER*60 SCRFILE(100),KOVFILE,FTRFILE,CONFILE,SYS*1
	LOGICAL FIRST
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /LATTICE/A(3,3)                              !!! from init
	COMMON /BASIS/  TAU(3,NPAT)                         !!! from init
	COMMON /OUT0/   SCRFILE                             !!! form init
	COMMON /OUT1/   ICCON,ICFTR,ICKOV                     !!! from init
	COMMON /OUT2/   CONFILE,FTRFILE,KOVFILE             !!! from init
	COMMON /DENS/   SIGMA,SIGMADOT                      !!! from dstr,hstr
	COMMON /VECGEN/ LIMDT,DELTAU                        !!! from vecgen
	COMMON /LM2STR/ IDELP,NR2,ILS2,ILD2,LIMLPL2,LIMLDL2 !!! from vecgen
	COMMON /LM4STR/       NR4,ILS4,ILD4,LIMLPL4,LIMLDL4 !!! from vecgen
	COMMON /INTTR/  NDIV,NDIW,SH                        !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP,EDGE              !!! from init
	COMMON /GROUPOUT/NGROUP                             !!! from group
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /MESW/   NPNW,PNW                            !!! from ttrmsh
        COMMON /ORBS/   NORBS                               !!! from init
        COMMON /SPIN/   NSPIN                               !!! from init
	COMMON /UNIT/   IUN                                 !!! from init
	COMMON /WORD/   NVAL                                !!! from nmtdata
C  	EQUIVALENCE (SIGMA(1,1,1),SIGMM(1,1))
	DATA PI/3.141592653589793D0/,EPS/1.D-05/
C  INITIATION
	LMMT=0
	LMMB=0
	LMMV=0
	DO 10 IATOM=1,NATOM
	LMMT=MAX(LMMT,ILST(IS(IATOM)))   !!! maximum lmaxt for all atoms
	LMMB=MAX(LMMB,ILSB(IS(IATOM)))   !!! maximum lmaxb for all atoms
	LMMV=MAX(LMMV,ILSV(IS(IATOM)))   !!! maximum lmaxv for all atoms
  10    CONTINUE
	LMMC=MAX(LMMT+1,LMMV+1)
C  CALCULATE TRANSFORMATION MATRICES
        IF(ICKOV.EQ.1)SYS='C'
        IF(ICKOV.EQ.2)SYS='H'
        IF(ICKOV.EQ.3)SYS='A'
        CALL WIGMAT(MAX(LMMT+1,LMMV),SYS,KOVFILE)
        CALL GROUPS(A,TAU,IS,MAX(LMMT+1,LMMV),NATOM,NSPIN,NORBS,EPS,1)
        WRITE(IUN,1010)NGROUP
	CALL KELITAB              !!! calculate Keli table
C  K-MESH CONSTRUCTION
	CALL SBZMESH(NDIV)
	CALL SBZMESW(NDIW)
	WRITE(IUN,1030)NPNT
	WRITE(IUN,1040)NPNW
C  GENERATE STR.VECTORS AND CHECK SINGULARITIES IN STR.CONSTANTS
	CALL GDATA(LMMC)          !!! calculate Gaunt-coefficients
	CALL SYMLMM               !!! calculate some logical arrays
C  STORE CHARGE DENSITY IN ORDER TO USE SOME MEMORY
	CALL SVECGEN              !!! generate structure vectors
	CALL CHECKS               !!! check singularities in str.con
C  OPEN FILE FOR SIGMA-CONSTANTS
	IF(ICCON.EQ.0)THEN
	OPEN(8,FILE=SCRFILE(8),STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
	WRITE(8,REC=1)NR2,NDIV(1),NPNT,NATOM,LIMDT,NPAN,
     &  (NKAP(IPAN),IPAN=1,NPAN),((EK(IKAP,IPAN),
     &  IKAP=1,NKAP(IPAN)),IPAN=1,NPAN)
	ELSEIF(ICCON.EQ.1)THEN
	OPEN(8,FILE=CONFILE,STATUS='NEW',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
	WRITE(8,REC=1)NR2,NDIV(1),NPNT,NATOM,LIMDT,NPAN,
     &  (NKAP(IPAN),IPAN=1,NPAN),((EK(IKAP,IPAN),
     &  IKAP=1,NKAP(IPAN)),IPAN=1,NPAN)
C  TEST INPUT DATA
	ELSEIF(ICCON.EQ.2)THEN    !!! test input data !!!
	INQUIRE(FILE=CONFILE,RECL=NR2)
CWRONG  IF(WRONG)THEN           !!! wrong compiler statement
	NR2=NVAL
	OPEN(8,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
	READ(8,REC=1)NR2
	CLOSE(8)
CWRONG  ENDIF
	OPEN(8,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
	READ(8,REC=1)NR2,NDIV0,NPNT0,NATOM0,
     &  LIMDT0,NPAN0,(NKAP0(IPAN),IPAN=1,NPAN0),((EKOLD(IKAP,IPAN),
     &  IKAP=1,NKAP0(IPAN)),IPAN=1,NPAN0)
	DO 30 ITAU=1,LIMDT0
	IREC=ITAU+1
	READ(8,REC=IREC)LIM2OLD(ITAU),LID2OLD(ITAU)
  30    CONTINUE
	IF(NDIV0.NE.NDIV(1))
     &  STOP '<STRMSH>: NUMBER OF DIVISIONS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	IF(LIMDT0.NE.LIMDT)STOP '<STRMSH>: NUMBER OF CONNECTING 
     &  VECTORS MISMATCH, CONFILE MUST BE RECALCULATED'
	IF(NPAN.NE.NPAN0)STOP '<STRMSH>: # OF PANELS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	DO 50 IPAN=1,NPAN
	IF(NKAP(IPAN).NE.NKAP0(IPAN))
     &  STOP '<STRMSH>: # OF KAPPAS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	DO 40 IKAP=1,NKAP(IPAN)
	IF(ABS(EK(IKAP,IPAN)-EKOLD(IKAP,IPAN)).GE.1.D-08)
     &  STOP '<STRMSH>:TAIL KAPPAS MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
  40    CONTINUE
  50    CONTINUE
	DO 60 ITAU=1,LIMDT
	IF(LIMLPL2(ITAU).GT.LIM2OLD(ITAU))
     &  STOP '<STRMSH>: LMAX(T+B) MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
	IF(LIMLDL2(ITAU).GT.LID2OLD(ITAU))
     &  STOP '<STRMSH>: LMAX(T+B)-DOT MISMATCH,
     &  CONFILE MUST BE RECALCULATED'
  60    CONTINUE
	CLOSE(8)
	ENDIF
C  ******* COMPUTE SIGMA-CONSTANTS IF NECESSARY ******
	IF(ICCON.EQ.1.OR.ICCON.EQ.0)THEN
	IREC=1
	DO 110 IPAN=1,NPAN                    !!! over energy panels
	FIRST=.TRUE.
	DO 100 IPNT=1,NPNT                    !!! over k-points
	XK=PNT(1,IPNT)+SH(1,IPAN)
	YK=PNT(2,IPNT)+SH(2,IPAN)
	ZK=PNT(3,IPNT)+SH(3,IPAN)
	IF(IPAN.EQ.1.OR.(DREAL(EKAP(1,IPAN)).GE.EDGE.AND.IPAN.NE.1))
     &  CALL DSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &  LTLMAX,LDLMAX,NKAPMAX,SIGMA,SIGMADOT)
	IF(IPAN.NE.1.AND.DREAL(EKAP(1,IPAN)).LT.EDGE)
     &  CALL HSTR(XK,YK,ZK,ILS2,ILD2,NKAP(IPAN),EK(1,IPAN),FIRST,
     &  LTLMAX,LDLMAX,NKAPMAX,SIGMA,SIGMADOT)
	FIRST=.FALSE.
	DO 90 IKAP=1,NKAP(IPAN)
	DO 80 ITAU=1,LIMDT
	IREC=IREC+1
	WRITE(8,REC=IREC)LIMLPL2(ITAU),LIMLDL2(ITAU),
     &  (SIGMA(LM,ITAU,IKAP),LM=1,LIMLPL2(ITAU)),
     &  (SIGMADOT(LM,ITAU,IKAP),LM=1,LIMLDL2(ITAU))
  80    CONTINUE
  90    CONTINUE
 100    CONTINUE                             !!! over k-points
 110    CONTINUE                             !!! over energy panels
	CLOSE(8)
	ENDIF
C   OPEN FILE WITH THE STRUCTURE CONSTANTS
	OPEN(8,FILE=CONFILE,STATUS='OLD',FORM='UNFORMATTED',
     &  ACCESS='DIRECT',RECL=NR2)
C   CALCULATE MADELUNG MATRIX AND STORE IT
C	OPEN(7,FILE=SCRFILE(7),STATUS='NEW',FORM='UNFORMATTED',
C    &  ACCESS='DIRECT',RECL=NR4)
C	CALL DSTR(0.D0,0.D0,0.D0,ILS4,ILD4,1,(0.D0,0.D0),.TRUE.,
C    &  LPLMAX,1,1,SIGMM,SIGMADOT)
C	DO 120 ITAU=1,LIMDT
C	WRITE(7,REC=ITAU)LIMLPL4(ITAU),
C    &  (SIGMM(LM,ITAU),LM=1,LIMLPL4(ITAU))
C120    CONTINUE
1010    FORMAT(1X,I4,' elements discovered')
1030    FORMAT(1X,I4,' k-points  generated')
1040    FORMAT(1X,I4,' k-points  to weight')
	END




	SUBROUTINE CHECKS
****************************************************************
*    Check the singularities in the structure constants        *
*    by calculating the difference between free-electron       *
*    energies and input tail energies.                         *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	PARAMETER (NDTMAX=NPAT*NPAT)
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &    ,NKAP(NPANMAX)
	DIMENSION PNT(3,KMAX),RBAS(3,3),GBAS(3,3)
     &    ,DELTAU(3,NDTMAX),GVEC(3,NVCMAX),RVEC(3,NVCMAX)
	COMPLEX*16 EK(NKAPMAX,NPANMAX),EKAP(NKAPMAX,NPANMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
	COMMON /KAPPAR/ NPAN,NKAP,EK,EKAP                   !!! from init
	COMMON /VECGEN/ LIMDT,DELTAU,NRVEC,RVEC,NGVEC,GVEC  !!! from vecgen
	COMMON /MESH/   NPNT,PNT                            !!! from ttrmsh
	COMMON /UNIT/   IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
	DO 50 IPAN=1,1 ! NPAN
	DO 40 IKAP=1,NKAP(IPAN)
	DIFMIN=10.D+10
	DO 30 IPNT=1,NPNT
	DO 20 IGVEC=1,NGVEC
	GKX=GVEC(1,IGVEC)+PNT(1,IPNT)
	GKY=GVEC(2,IGVEC)+PNT(2,IPNT)
	GKZ=GVEC(3,IGVEC)+PNT(3,IPNT)
	GK2=GKX*GKX+GKY*GKY+GKZ*GKZ
	DIF=ABS(GK2-DREAL(EK(IKAP,IPAN))/4.D0/PI/PI)
	DIFMIN=MIN(DIFMIN,DIF)
  20    CONTINUE
  30    CONTINUE
	WRITE(IUN,1010)IKAP,DIFMIN
	IF(DIFMIN+ABS(DIMAG(EK(IKAP,IPAN))).LE.1.D-10)
     &  PRINT*,' <CHECKS> : STR.CONSTANTS WILL BE SINGULAR'
  40    CONTINUE
  50    CONTINUE
1010    FORMAT(1X,'Minimum difference between |k+G|^2 and kappa',
     &  I1,'^2 is ',G14.7)
	END
