	SUBROUTINE SYMLMM
****************************************************************
*  Define which coefficients in the expansion of the potential *
*  or charge density over spherical harmonics are not equal    *
*  to zero for a given crystalline group.                      *
*  Written by S.Yu.Savrasov (P.N.Lebedev Physical Institute)   *
****************************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER LPR(0:LMAXV),MPR(0:LMAXV,2*LMAXV+1)
     &   ,IS(NPAT),NHSORT(NSORTMAX),IARR(LMMAXV),NRAD(NSORTMAX)
     &   ,ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,NSYM(NPAT),LMSYM(LMMAXV,NPAT),IKOV(NOPRMAX)
     &   ,IP(NPAT,NOPRMAX)
	DIMENSION SMT(NSORTMAX),TAU(3,NPAT),GPLW(3,0:NPLWMAX)
     &   ,BET(0:LMAXV,NSORTMAX),RBAS(3,3),GBAS(3,3),CUTG(0:LMAXV)
     &   ,RDC(3,NPAT,NOPRMAX),SHIFT(3,NOPRMAX)
	COMPLEX*16 RHAN(0:LMAXV),HAN(3,0:LMAXV)
     &   ,ERFG(-1:LMAXV),YLM(LMMAXV),ZLM(LMMAXV,NPAT)
     &   ,TMP,ERFR(-1:LMAXV),ERF0(-1:LMAXV),U(NWIGMAX,48)
	LOGICAL SYM(LMMAXV,NPAT),PRINTH
	CHARACTER TXTEL(NSORTMAX)*10,BLANCK*40
	COMMON /CONTROL/ MAN,LMTO,NLR                        !!! from init
	COMMON /PARAM/   NSORT,IS,ILST,ILSB,ILSV,NATOM,NHSORT!!! from init
	COMMON /POTCOM/  SWZ,SMT                             !!! from init
	COMMON /LATTICE/ RBAS,GBAS                           !!! from init
	COMMON /BASIS/   TAU                                 !!! from init
	COMMON /STORE1/  ZLM,WORK1,WORK2                     !!! tmp.storage
        COMMON /INVERS/  INV,IKOV                            !!! from group
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT               !!! from group
	COMMON /BETPAR/  BET                                 !!! from plwmsh
	COMMON /LATPAR/  PAR                                 !!! from init
	COMMON /PLWMESH/ NPLW,GPLW                           !!! from plwmsh
	COMMON /SYMMLM/  SYM,LMSYM,NSYM                      !!! from sym
	COMMON /RADMESH/ NRAD                                !!! from radmsh
	COMMON /SPIN/    NSPIN                               !!! from init
	COMMON /TXTEL/   TXTEL                               !!! from init
	COMMON /UNIT/    IUN                                 !!! from init
	DATA PI/3.141592653589793D0/
C  DEFINE WHICH OF THE DENSITY OR POTENTIAL L-COMPONENTS WILL BE ZERO
        LMM=0
        DO 20 IATOM=1,NATOM                !!! over iatom
        LMM=MAX(LMM,ILSV(IS(IATOM)))
        DO 10 LM=1,(ILSV(IS(IATOM))+1)**2
        SYM(LM,IATOM)=.FALSE.
        ZLM(LM,IATOM)=(0.D0,0.D0)
  10    CONTINUE
  20    CONTINUE
C  SET ARBITRARY VECTOR
        AX=0.1D0
        AY=0.2D0
        AZ=0.3D0
        AA=SQRT(AX**2+AY**2+AZ**2)
C  DO OVER ATOMS AND CRYSTALLINE GROUP
        DO 70 IATOM=1,NATOM
        ISORT=IS(IATOM)
        DO 60 IR=1,NGROUP
        IG=IKOV(IR)
        IATOMG=IP(IATOM,IR)
        IF(IATOMG.NE.IATOM)GOTO60
C  ROTATE VECTOR BY GROUP OPERATION
        CALL ROTATE(AX,AY,AZ,ARX,ARY,ARZ,U(2,IG),2)
        CALL SPHHARM(ARX/AA,ARY/AA,ARZ/AA,ILSV(ISORT),YLM)
        DO 50 L=0,ILSV(ISORT)
        DO 40 M=-L,L
        LM=L*(L+1)+M+1
        ZLM(LM,IATOM)=ZLM(LM,IATOM)+YLM(LM)
  40    CONTINUE
  50    CONTINUE
  60    CONTINUE
  70    CONTINUE
C  LOOK FOR ZEROES
        DO 90 IATOM=1,NATOM
        DO 80 LM=1,(ILSV(IS(IATOM))+1)**2
        IF(ABS(ZLM(LM,IATOM)).GT.1.D-08)SYM(LM,IATOM)=.TRUE.
  80    CONTINUE
  90    CONTINUE
C  PRINT ALLOWED LM-VALUES
	BLANCK='                                        '
	DO 260 IATOM=1,NATOM
	ISORT=IS(IATOM)
	WRITE(IUN,1010)(TAU(I,IATOM),I=1,3),TXTEL(IS(IATOM))
	WRITE(IUN,1020)ILST(IS(IATOM))
	WRITE(IUN,1030)ILSV(IS(IATOM))
	WRITE(IUN,1040)
	NSYM(IATOM)=0
	NSTOP=0
	LPRMAX=0
	DO 240 L=0,ILSV(IS(IATOM))
	LPR(L)=0
	DO 230 M=-L,L
	LM=L*(L+1)+M+1
	LMSYM(LM,IATOM)=0
	IF(SYM(LM,IATOM))THEN
	NSYM(IATOM)=NSYM(IATOM)+1
	LMSYM(LM,IATOM)=NSYM(IATOM)
	LPR(L)=LPR(L)+1
	MPR(L,LPR(L))=M
	ENDIF
 230    CONTINUE
	IF(L.GT.8)GOTO240
	LPRMAX=MAX(LPRMAX,LPR(L))
 240    CONTINUE
C THE FOLLOWING CYCLE IS JUST FOR PRINTING, REMOVE IT IF DOES NOT WORK
	DO 250 L=0,ILSV(IS(IATOM))
	NSHIFT=2*(LPRMAX-LPR(L))+1
	IF(NSHIFT.LE. 0)NSHIFT=1 
	IF(NSHIFT.GT.40)NSHIFT=40
	IF(LPR(L).NE.0.AND.L.LE.8)WRITE(IUN,1050)L,BLANCK(:NSHIFT),
     &  (MPR(L,I),I=1,LPR(L))
	IF(LPR(L).NE.0.AND.L.GT.8)WRITE(IUN,1060)L,LPR(L)
 250    CONTINUE
	WRITE(IUN,1070)NSYM(IATOM)
	IF(NSYM(IATOM).GT.NSYMMAX)NSTOP=1
C CALCULATE ACCURACY
	DO 255 L=0,ILSV(ISORT)
	CUTG(L)=SQRT(GPLW(1,NPLW)**2+GPLW(2,NPLW)**2+GPLW(3,NPLW)**2) ! 2pi/a
	CUTG(L)=CUTG(L)*2.D0*PI/PAR
	CALL SERFL2(ERF0,L,BET(L,ISORT),SMT(ISORT),
     &  (0.D0,0.D0))
	ERFR(L)=ERF0(L)
	CALL SERFL3(ERF0,L,BET(L,ISORT),SMT(ISORT),
     &  (0.D0,0.D0),CUTG(L))
	ERFG(L)=ERF0(L)
 255    CONTINUE
	CALL REGHAN(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),BET(0,ISORT),
     &  RHAN(0),ILSV(ISORT))
	CALL HANKEL(SMT(ISORT),(0.D0,0.D0),SMT(ISORT),HAN(1,0),
     &  ILSV(ISORT))
	WRITE(IUN,1080)
	DO 257 L=0,ILSV(ISORT)
	PRINTH=.FALSE.
	DO 256 M=-L,L
	LM=L*(L+1)+M+1
	IF(SYM(LM,IATOM))PRINTH=.TRUE.
 256    CONTINUE
CCC     IF(PRINTH)
	WRITE(IUN,1090)L,NPLW,CUTG(L)**2,
     &  ABS(RHAN(L)/HAN(1,L)),ABS(ERFG(L)/ERFR(L))
 257    CONTINUE
 260    CONTINUE
	IF(NSTOP.EQ.1)
     &  STOP'<SYMMLM>: SYMMETRY IS TOO LOW,
     &  INCREASE "NSYMMAX" IN PARAM.DAT'
1010    FORMAT(1X,'Position : (',G12.5,',',G12.5,',',G12.5,') ',A10)
1020    FORMAT(1X,'LMTO-basis set is expanded in spherical harmonics ',
     &  'up to Lmax=',I2)
1030    FORMAT(1X,'Charge density is expanded in spherical harmonics ',
     &  'up to Lmax=',I2)
1040    FORMAT(1X,'Non-zero elements allowed by symmetry are ',
     &            'the following:')
1050    FORMAT(1X,'l=',I2,' ; m=',A,17(1X,I3))
1060    FORMAT(1X,'l=',I2,' ; m= ',I2,' elements')
1070    FORMAT(1X,'Total # of non-zero components found ',I3)
1080    FORMAT(1X,' l=    Nplw   Ecut (Ry)   RH(S)/H(S) ',
     &  '   GH(S)/RH(S)')
1090    FORMAT(1X,'"',I2,'"',2X,I5,2X,G10.3,2X,G12.5,2X,G12.5)
	END
