	SUBROUTINE SYMDPSR(IQPNT)
********************************************************
*  Symmetrizes change in pseudocharge density.         *
********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,INDG(NFFTMAX),KVEC(3,0:NPLWMAX),KGMIN(3),KGMAX(3)
     &   ,ISG(NOPRMAX,NOPRMAX),NITER(0:NENVMAX,-1:2),IS(NPAT)
     &   ,IKOV(NOPRMAX),IP(NPAT,NOPRMAX),NHSORT(NSORTMAX)
     &   ,INDGPTB(0:NENVMAX),INGPTBR(NOPRMAX,0:NENVMAX)
     &   ,NQDIV(3)
	COMPLEX*16 U(NWIGMAX,48),PHSQ,EXPGR,EXPQR
     &    ,DRHOPS(0:NPLWMAX,NSPINMAX)
     &    ,DMAGPS(0:NPLWMAX,NSPINMAX)
     &    ,SRHOPS(0:NPLWMAX,NSPINMAX)
     &    ,SMAGPS(0:NPLWMAX,NSPINMAX)
	DIMENSION QPNT(3),SMT(NSORTMAX),QPNT0(3),RBAS(3,3)
     &   ,RDC(3,NPAT,NOPRMAX),GBAS(3,3),GPLW(3,0:NPLWMAX)
     &   ,GPTB(3,0:NENVMAX),SHIFT(3,NOPRMAX)
C Controls:
	COMMON /CONTROL/LIFT,LMTO,NSPH,NINT,NPF,MODE        !!! from init
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM       !!! from init
        COMMON /SPIN/   NSPIN                               !!! from init
C Inputs:
        COMMON /LATTICE/RBAS,GBAS                           !!! from init
	COMMON /MAGCOM/ ITERMAX,NITER                       !!! from init
        COMMON /QMESH/  NQPNT,QPNT,NUMQ,NQDIV,KEYQ          !!! from init
        COMMON /PTBCOM/ NGSHL,NGPTB,GPTB,INDGPTB,INGPTBR    !!! from plwptb
	COMMON /POTCOM/ SWZ,SMT                             !!! from init
C Plane waves:
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG     !!! from plwmsh
C Group:
        COMMON /INVERS/ INV,IKOV                            !!! from group
        COMMON /GROUPOUT/NGROUP,U,IP,RDC,SHIFT              !!! from group
        COMMON /SUBGROUP/NSGQ,NGEQ,ISG                      !!! from symmsh
C Density:
        COMMON /DPSRHO/ DRHOPS,DMAGPS                       !!! from dpsfiles
        COMMON /STORE1/ SRHOPS,SMAGPS                       !!! from dpsfiles
C Outputs:
        COMMON /WORD/   NVAL                                !!! from block
	COMMON /UNIT/   IUN                                 !!! from init
        DATA PI/3.141592653589793D0/
	IF(MODE.EQ.5)RETURN
	DO 3000 MY=-1,2                               !!! over polarizations
	DO 2000 IGPTB=0,NGPTB                         !!! over g-vectors
	IF(NITER(IGPTB,MY).EQ.0)GOTO2000
        CALL DPSFILES(IGPTB,MY,IQPNT,31,'I')          !!! initialize file
C  SET SYMMETRIZED CHARGE DENSITY TO ZERO.
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IPLW=0,NPLW
	SRHOPS(IPLW,ISPIN)=(0.D0,0.D0)
	SMAGPS(IPLW,ITRAN)=(0.D0,0.D0)
	ENDDO
	ENDDO
C  DO OVER GROUP OF WAVE VECTOR Q
        DO 1000 IGEQ=1,NGEQ                           !!! over group of q-vector
        IR=ISG(IGEQ,1)                                !!! element "g" in the main G-list
        IG=IKOV(IR)                                   !!! element "g" after Kovalev
        IGPTBR=INGPTBR(IGEQ,IGPTB)                    !!! q+Gr=q+gamma^{-1}G
        CALL DPSFILES(IGPTBR,MY,IQPNT,35,'R')
	DO ISPIN=1,NSPIN                              !!! over spins
	ITRAN=ISPIN
        DO IPLW=0,NPLW                                !!! over plane waves
C  RECIPROCAL LATTICE VECTOR IS GIVEN BY
        GX=GPLW(1,IPLW)
        GY=GPLW(2,IPLW)
        GZ=GPLW(3,IPLW)
C  APPLY SYMMETRY OPERATION
        CALL ROTATE(GX,GY,GZ,GRX,GRY,GRZ,U(2,IG),1)
C  GET COORDINATES IN G1,G2,G3
        X1R=GRX*RBAS(1,1)+GRY*RBAS(2,1)+GRZ*RBAS(3,1)
        X2R=GRX*RBAS(1,2)+GRY*RBAS(2,2)+GRZ*RBAS(3,2)
        X3R=GRX*RBAS(1,3)+GRY*RBAS(2,3)+GRZ*RBAS(3,3)
        M1R=ANINT(X1R)
        M2R=ANINT(X2R)
        M3R=ANINT(X3R)
        IF(ABS(DBLE(M1R)-X1R).GE.1.D-10.OR.
     &     ABS(DBLE(M2R)-X2R).GE.1.D-10.OR.
     &     ABS(DBLE(M3R)-X3R).GE.1.D-10)STOP'<SYMDPS>: WRONG VECTOR'
        IDIM=1+M1R-KGMIN(1)+(KGMAX(1)-KGMIN(1)+1)*(M2R-KGMIN(2))+
     &  (KGMAX(1)-KGMIN(1)+1)*(KGMAX(2)-KGMIN(2)+1)*(M3R-KGMIN(3))
        IPLWR=INDG(IDIM)
        IF(IPLWR.EQ.-1)STOP'<SYMDPS>:: ERROR IN IPLWR'
        SCP=(GX-GPTB(1,IGPTB))*SHIFT(1,IR)+
     &      (GY-GPTB(2,IGPTB))*SHIFT(2,IR)+
     &      (GZ-GPTB(3,IGPTB))*SHIFT(3,IR)
        EXPGR=EXP((0.D0,-1.D0)*2.D0*PI*SCP)
C  SYMMETRIZE CHARGE DENSITY
        SRHOPS(IPLW,ISPIN)=SRHOPS(IPLW,ISPIN)+DRHOPS(IPLWR,ISPIN)*
     &  EXPGR
        SMAGPS(IPLW,ITRAN)=SMAGPS(IPLW,ITRAN)+DMAGPS(IPLWR,ITRAN)*
     &  EXPGR
        ENDDO                                         !!! over plane waves
	ENDDO                                         !!! over spins
1000	CONTINUE                                      !!! over group of q-vector
C  SYMMETRIZATION FINISHED, NORMALIZATION
	DO ISPIN=1,NSPIN
	ITRAN=ISPIN
	DO IPLW=0,NPLW
	DRHOPS(IPLW,ISPIN)=SRHOPS(IPLW,ISPIN)/DBLE(NGEQ)
	DMAGPS(IPLW,ITRAN)=SMAGPS(IPLW,ITRAN)/DBLE(NGEQ)
	ENDDO
	ENDDO
C  SAVE FINAL CHANGE IN CHARGE DENSITY
        CALL DPSFILES(IGPTB,MY,IQPNT,31,'W')
2000	CONTINUE                                      !!! over g-vectors
C  DELETE SCRATCH FILES
        DO IGPTB=0,NGPTB
	IF(NITER(IGPTB,MY).NE.0)THEN
        CALL DPSFILES(IGPTB,MY,IQPNT,31,'R')
        CALL DPSFILES(IGPTB,MY,IQPNT,35,'W')
        CALL DPSFILES(IGPTB,MY,IQPNT,31,'D')
	ENDIF
        ENDDO
3000	CONTINUE                                      !!! over polarizations
	END
