	SUBROUTINE VCFTR
*********************************************************
* Calculates coulomb part of pseudopotential which is   *
* true Coulomb potential in the interstitial region.    *
* Written by S.Yu.Savrasov (Lebedev Physical Institute) *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
	COMPLEX*16 VPS(0:NPLWMAX,NSPINMAX),RHOPS(0:NPLWMAX,NSPINMAX)
     &    ,RHOPS1(0:NPLWMAX,NSPINMAX),PSTOT,PSTOT1
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /PSVCOM/ VPS                              !!! from vpseudo
	COMMON /PSRHO/  RHOPS,RHOPS1                     !!! from vcftr
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	COMMON /PLWMESH/NPLW,GPLW                        !!! from plwmsh
	COMMON /SPIN/   NSPIN                            !!! from init
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
	DO 20 ISPIN=1,NSPIN                  !!! over spins
	DO 10 IPLW=0,NPLW                    !!! over plane waves
	GX=GPLW(1,IPLW)*2.D0*PI/PAR
	GY=GPLW(2,IPLW)*2.D0*PI/PAR
	GZ=GPLW(3,IPLW)*2.D0*PI/PAR
	G2=GX**2+GY**2+GZ**2
	PSTOT=(RHOPS(IPLW,1)+RHOPS(IPLW,NSPIN))/2.D0*DBLE(NSPIN)
	PSTOT1=(RHOPS1(IPLW,1)+RHOPS1(IPLW,NSPIN))/2.D0*DBLE(NSPIN)
	IF(G2.GE.1.D-10)VPS(IPLW,ISPIN)=8.D0*PI*(PSTOT+PSTOT1)/G2
	IF(G2.LT.1.D-10)VPS(IPLW,ISPIN)=(0.D0,0.D0) ! for G=0
  10    CONTINUE                             !!! over spins
  20    CONTINUE                             !!! over plane waves
	END



	SUBROUTINE VPINT
*********************************************************
* Calculates convolution of pseudopotential with inter- *
* stitial plane-wave integral.                          *
* Written by S.Yu.Savrasov (Lebedev Physical Institute) *
*********************************************************
	IMPLICIT REAL*8 (A-H,O-Z)
	INCLUDE 'PARAM.DAT'
	INTEGER IS(NPAT),ILST(NSORTMAX),ILSB(NSORTMAX),ILSV(NSORTMAX)
     &   ,KGMIN(3),KGMAX(3),INDG(NFFTMAX),KVEC(3,0:NPLWMAX)
     &   ,INDG2(9*NFFTMAX)
	COMPLEX*16 VPS(0:NPLWMAX,NSPINMAX),VPSINT(0:NPLWMAX,NSPINMAX)
     &   ,GVAL,GINT(0:9*NPLWMAX)
	DIMENSION SMT(NSORTMAX),GPLW(3,0:NPLWMAX),ORTH(2:3)
     &   ,G2PLW(3,0:9*NPLWMAX)
	COMMON /PARAM/  NSORT,IS,ILST,ILSB,ILSV,NATOM    !!! from init
	COMMON /POTCOM/ SWZ,SMT                          !!! from vfull
	COMMON /PSVCOM/ VPS,VPSINT                       !!! from vpint   
	COMMON /LATPAR/ PAR,ORTH,OMEGAC                  !!! from init
	COMMON /STORE1/ GINT                             !!! from plwint
        COMMON /PLWMESH/NPLW,GPLW,KVEC,KGMIN,KGMAX,INDG  !!! from plwmsh
        COMMON /PLW2MSH/N2PLW,G2PLW,INDG2     	         !!! from plw2mh
	COMMON /SPIN/   NSPIN                            !!! from init
	COMMON /WORD/   NVAL                             !!! from nmtdata
	DATA PI/3.141592653589793D0/
	M1D=2*KGMAX(1)-2*KGMIN(1)+1
	M2D=2*KGMAX(2)-2*KGMIN(2)+1
	M3D=2*KGMAX(3)-2*KGMIN(3)+1
	M12D=M1D*M2D
	M123D=M1D*M2D*M3D
	CALL PLWINT(GINT)                    !!! take the integral for PWs
	DO 30 ISPIN=1,NSPIN                  !!! over spins
	DO 20 IPLW=0,NPLW                    !!! over plane waves
	VPSINT(IPLW,ISPIN)=(0.D0,0.D0)
	M1I=KVEC(1,IPLW)+2*KGMIN(1)
	M2I=KVEC(2,IPLW)+2*KGMIN(2)
	M3I=KVEC(3,IPLW)+2*KGMIN(3)
	DO 10 JPLW=0,NPLW                    !!! over plane waves
        M1=KVEC(1,JPLW)-M1I
        M2=KVEC(2,JPLW)-M2I
        M3=KVEC(3,JPLW)-M3I
        IDIM=1+M1+M1D*M2+M12D*M3
	I2PLW=INDG2(IDIM)
	VPSINT(IPLW,ISPIN)=VPSINT(IPLW,ISPIN)+
     &  VPS(JPLW,ISPIN)*GINT(I2PLW)
  10    CONTINUE                             !!! over plane waves
  20    CONTINUE                             !!! over plane waves
  30    CONTINUE                             !!! over spins
	END

